#ifndef lint
/*static char yysccsid[] = "from: @(#)yaccpar	1.9 (Berkeley) 02/21/93";*/
static char yyrcsid[] = "$Id: skeleton.c,v 1.4 1993/12/21 18:45:32 jtc Exp $";
#endif
#define YYBYACC 1
#define YYMAJOR 1
#define YYMINOR 9
#define yyclearin (yychar=(-1))
#define yyerrok (yyerrflag=0)
#define YYRECOVERING (yyerrflag!=0)
#define YYPREFIX "yy"
#line 2 "../source/cmd_pars.y"
/* rts_cmd_parser.y - yacc input for RULEWORKS command interpreter parser */
/****************************************************************************
**                                             
RuleWorks - Rules based application development tool.

Copyright (C) 1999  Compaq Computer Corporation

This program is free software; you can redistribute it and/or modify it 
under the terms of the GNU General Public License as published by the 
Free Software Foundation; either version 2 of the License, or any later 
version. 

This program is distributed in the hope that it will be useful, but 
WITHOUT ANY WARRANTY; without even the implied warranty of 
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU General 
Public License for more details. 

You should have received a copy of the GNU General Public License along 
with this program; if not, write to the Free Software Foundation, 
Inc., 675 Mass Ave, Cambridge, MA 02139, USA.

Email: info@ruleworks.co.uk
****************************************************************************/


/*
**  FACILITY:
**	RULEWORKS Command Interpreter
**
**  ABSTRACT:
**	Parse command input.
**      Yacc processes this file and generates rts_cmd_parser_tab.[ch].
**
**  MODIFIED BY:
**	DEC	Digital Equipment Corporation
 *	CPQ	Compaq Computer Corporation
**
**  MODIFICATION HISTORY:
**
**	 1-Oct-1992	DEC	Initial version
**	 1-Nov-1992	DEC	Major enhancements
**	30-Mar-1994	DEC	Make yacc compatible: Don't define bogus
**					YYMAXDEPTH, don't use %pure_parser bisonism,
**					define yylex() with 0 parameters
**	 1-Jun-1994	DEc	Don't ACCVIO on "ppwm ^bogus nil"; "ppwm ^good
**					nil"
**	01-Dec-1999	CPQ	Release with GPL
*/

#include <ctype.h>	/* define toupper 				*/
#include <common.h>	/* declares Molecule, Mol_Compound, Mol_Symbol  */
#include <cli_msg.h>	/* message defs				        */
#include <msg.h>	/* message routines                             */
#include <scan.h>	/* defines Token_Type and Token_Value & scanner	*/
#include <rbs.h>	/* declares Ruling blocks 			*/
#include <cs.h>		/* declares Conflict Set			*/
#include <wm.h>		/* declares Work Memory				*/
#include <mol.h>	/* declares molecules				*/
#include <decl.h>	/* declares declarations			*/
#include <decl_att.h>	/* declares declarations for attributes		*/
#include <list.h>	/* declares lists				*/
#include <ios.h>	/* io streams					*/
#include <dbg.h>	/* declares debugger (interp) info		*/
#include <dbg_p.h>	/* declares debugger private info		*/
#include <callback.h>	/* declares functions i.e. translation...	*/
#ifdef __vms
#include <descrip.h>
#include <rmsdef.h>
#include <iodef.h>
#include <starlet.h>
#include <lib$routines.h>
#include <libclidef.h>
#endif



typedef enum {
   DBG__E_CMD_IS_BOGUS = 0,
   DBG__E_CMD_AT = 1,
   DBG__E_CMD_ADDSTATE,
   DBG__E_CMD_AFTER,
   DBG__E_CMD_CLOSEFILE,
   DBG__E_CMD_COPY,
   DBG__E_CMD_CS,
   DBG__E_CMD_DEFAULT,
   DBG__E_CMD_DISABLE,
   DBG__E_CMD_EBREAK,
   DBG__E_CMD_ENABLE,
   DBG__E_CMD_EXIT,
   DBG__E_CMD_MAKE,
   DBG__E_CMD_MATCHES,
   DBG__E_CMD_MODIFY,
   DBG__E_CMD_NEXT,
   DBG__E_CMD_OPENFILE,
   DBG__E_CMD_RBREAK,
   DBG__E_CMD_PPCLASS,
   DBG__E_CMD_PPWM,
   DBG__E_CMD_PROMPT,
   DBG__E_CMD_QUIT,
   DBG__E_CMD_REMOVE,
   DBG__E_CMD_REMOVE_EVERY,
   DBG__E_CMD_RESTORESTATE,
   DBG__E_CMD_RETURN,
   DBG__E_CMD_RUN,
   DBG__E_CMD_SAVESTATE,
   DBG__E_CMD_SHOW,
   DBG__E_CMD_SPECIALIZE,
   DBG__E_CMD_TRACE,
   DBG__E_CMD_WBREAK,
   DBG__E_CMD_WM,
   DBG__E_CMD_WMHISTORY
} RulDbg_Command;


static RulDbg_Command  dbg_command = DBG__E_CMD_IS_BOGUS;
static long            num_attrs;  /* number of attrs in current class       */
static Molecule	      *result;     /* result and array ???		     */
static long            result_len; /* lenght of result array   	             */
static Pat_Pattern    *pat_pat;	  /* current condition/object pattern        */
static Pat_Classes    *pat_cls;    /* current class pointer                  */
static Pat_Attrs      *pat_att;    /* current attr pointer                   */
static Pat_Tests      *pat_tst;    /* current test pointer                   */
static Pat_Classes   **pcn;        /* pointer to next class pointer          */
static Pat_Attrs     **pan;        /* pointer to next attr pointer           */
static Pat_Tests     **ptn;        /* pointer to next test pointer           */
static Pat_Tests     **pdtn;       /* pointer to next disj test pointer      */
static Decl_Shape      att_shape;  /* current attr shape		     */
static Boolean         pred1;      /* current predidate is a compound pred   */
static Boolean         pred2;      /* opt predidate is a compound pred       */
static Boolean         val_scalar; /* value is scalar                        */
static Boolean         ok; 	   /* continue if ok multiple if's           */
static Decl_Block      cur_blk;    /* current decling block                  */
static Object          cur_wmo;    /* a WMO being made/modified/copied/rem'd */
static Class           cur_cls;    /* class of current WMO                   */
static Class           tmp_cls;    /* temp class holder	                     */
static long            cur_off;
static int             line_number;/* scanner position in the source file    */
static Mol_Instance_Id cur_wid;	   /* current wmo id 			     */
static Mol_Symbol      tmp_atm;    /* temp atom holder	         	     */
static Mol_Symbol      cls_nam;    /* current class name symbol              */
static Mol_Symbol      cur_rb;     /* current ruling block name              */
static Mol_Symbol      cur_rul;    /* current rule name                      */
static Mol_Compound    comp_value; /* used to build a compound value         */
static int             comp_elmts; /* number of elements in a compound value */
static IO_Stream       tmpios;
static int             j;
static long            cur_int;
static double          cur_flt;
static Wm_Opr_Code     wmo_cmd;
static Entry_Data      ebdata;
static RuleName        rul_nam;
static Boolean         on_flag;
static Param_List      pl;
static void           *p1;
static void           *p2;
static void           *p3;
static void           *p4;

/* functions... */
static    void        set_error (void);
static    void        clear_error (void);
static    Boolean     in_error (void);
static    Boolean     in_command (void);
static    long        get_command_type (void);
static    char       *command_type_to_name (RulDbg_Command cmd_type);
static    char       *get_usage_string (RulDbg_Command cmd);
static    char       *get_examples_string (RulDbg_Command cmd);
static    char       *get_hints_string (RulDbg_Command cmd);
static    void        process_command (void);
extern    void        rul__scan_reset_parens(void);
EXTERNAL  Mol_Symbol  rul__rac_active_rule_name;
extern    Boolean     rul__scan_switch_file (IO_Stream);


/*
 * Declare alloca, since Bison code calls it without declaring it.
 */
/*
 * void *alloca(size_t);
 */

/* if not defined it complains, when defined it
   yy defines alloca to be __builtin_alloca
*/
/*
 * #ifndef __GNUC__
 * #define __GNUC__ 0
 * #endif
 */

#define yyparse rul__cmd_yyparse

#ifdef YYPURE
#define yylex(lval)  rul__scan_get_token(lval.tok, &line_number)
#else
#define yylex() rul__scan_get_token(&yylval.tok, &line_number)
#endif

#ifdef YYDEBUG
/* function to print out values of tokens	*/
#define YYERROR_VERBOSE	/* be verbose about diagnosing parsing errors	*/
#define xmalloc malloc	/* where is xmalloc defined/declared? use malloc*/
#else
#define YYDEBUG 0
#endif

static void yyerror(char *msg);

#define INTERP_ERROR	rul__scan_reset_parens(); \
			clear_error (); \
			yyclearin; \
			yyerrok

#define INTERP_ABORT	rul__scan_reset_parens(); \
			clear_error (); \
			rul__dbg_free_pattern (&pat_pat); \
			yyclearin; \
			yyerrok; \
			YYABORT

#define INTERP_ACCEPT	YYACCEPT


#line 233 "../source/cmd_pars.y"
typedef union {	/* This union is where the parser values are stored:        */
  Token_Value    tok;	/* keeps track of constant token values - terminals */
  Molecule       mol;	/* this is where a molecularized constant is stored */
  Class          cls;	/* symbols are transformed into object-classes	    */
  Object         obj;
  void          *ptr;
  IO_Catagory    ioc;
  IO_Access_Mode ioa;
/*
  Pat_Pattern   *pat;
  Pat_Classes   *pc;
  Pat_Attrs     *pa;
  Pat_Tests     *pt;
*/
} YYSTYPE;
#line 253 "y.tab.c"
#define TOK_EOL 257
#define TOK_EOF 258
#define TOK_INTEGER_CONST 259
#define TOK_INSTANCE_CONST 260
#define TOK_OPAQUE_CONST 261
#define TOK_FLOAT_CONST 262
#define TOK_LPAREN 263
#define TOK_RPAREN 264
#define TOK_LBRACE 265
#define TOK_RBRACE 266
#define TOK_LBRACKET 267
#define TOK_RBRACKET 268
#define TOK_HAT 269
#define TOK_AMPERSAND 270
#define TOK_TILDE 271
#define TOK_START_DISJUNCTION 272
#define TOK_END_DISJUNCTION 273
#define TOK_PLUS 274
#define TOK_MINUS 275
#define TOK_TIMES 276
#define TOK_DIVIDE 277
#define TOK_MODULUS 278
#define UMINUS 279
#define TOK_ACCEPT 280
#define TOK_ACCEPT_ATOM 281
#define TOK_ACCEPTLINE_COMPOUND 282
#define TOK_ACCEPTS 283
#define TOK_ACTIVATES 284
#define TOK_ADDSTATE 285
#define TOK_AFTER 286
#define TOK_ALIAS_FOR 287
#define TOK_AND 288
#define TOK_ANY 289
#define TOK_APPEND 290
#define TOK_APPROX_EQUAL 291
#define TOK_ARROW 292
#define TOK_ASCID 293
#define TOK_ASCIZ 294
#define TOK_AT 295
#define TOK_ATOM 296
#define TOK_BIND 297
#define TOK_BLOCK_NAME 298
#define TOK_BY 299
#define TOK_BYTE 300
#define TOK_CATCH 301
#define TOK_CALL_INHERITED 302
#define TOK_CLOSEFILE 303
#define TOK_COMPOUND 304
#define TOK_CONTAINS 305
#define TOK_CONCAT 306
#define TOK_COPY 307
#define TOK_CRLF 308
#define TOK_CS 309
#define TOK_CTRLC 310
#define TOK_DECLARATION_BLOCK 311
#define TOK_DEBUG 312
#define TOK_DEFAULT 313
#define TOK_DIFF_TYPE 314
#define TOK_DISABLE 315
#define TOK_DO 316
#define TOK_DOES_NOT_CONTAIN 317
#define TOK_DOLLAR_LAST 318
#define TOK_DOUBLE_FLOAT 319
#define TOK_EBREAK 320
#define TOK_EB 321
#define TOK_ELSE 322
#define TOK_ENABLE 323
#define TOK_END_BLOCK 324
#define TOK_END_GROUP 325
#define TOK_ENTRY_BLOCK 326
#define TOK_EQUAL 327
#define TOK_EQUAL_EQUAL 328
#define TOK_EVERY 329
#define TOK_EXCISE 330
#define TOK_EXIT 331
#define TOK_EXTERNAL_ROUTINE 332
#define TOK_FAILURE 333
#define TOK_FILENAME 334
#define TOK_FILL 335
#define TOK_FLOAT 336
#define TOK_FOR_EACH 337
#define TOK_GENATOM 338
#define TOK_GENERIC_METHOD 339
#define TOK_GENINT 340
#define TOK_GET 341
#define TOK_GREATER 342
#define TOK_GREATER_EQUAL 343
#define TOK_IF 344
#define TOK_IN 345
#define TOK_INHERITS_FROM 346
#define TOK_INSTANCE 347
#define TOK_INTEGER 348
#define TOK_IS_OPEN 349
#define TOK_LENGTH 350
#define TOK_LENGTH_EQUAL 351
#define TOK_LENGTH_GREATER 352
#define TOK_LENGTH_GREATER_EQUAL 353
#define TOK_LENGTH_LESS 354
#define TOK_LENGTH_LESS_EQUAL 355
#define TOK_LENGTH_NOT_EQUAL 356
#define TOK_LESS 357
#define TOK_LESS_EQUAL 358
#define TOK_LEX 359
#define TOK_LONG 360
#define TOK_MAKE 361
#define TOK_MAX 362
#define TOK_MATCHES 363
#define TOK_MEA 364
#define TOK_METHOD 365
#define TOK_MIN 366
#define TOK_MODIFY 367
#define TOK_NEXT 368
#define TOK_NTH 369
#define TOK_NOT 370
#define TOK_NOT_APPROX_EQUAL 371
#define TOK_NOT_EQ 372
#define TOK_NOT_EQUAL 373
#define TOK_ON_EMPTY 374
#define TOK_ON_ENTRY 375
#define TOK_ON_EVERY 376
#define TOK_ON_EXIT 377
#define TOK_OBJECT_CLASS 378
#define TOK_OF 379
#define TOK_OFF 380
#define TOK_ON 381
#define TOK_OPAQUE 382
#define TOK_OPENFILE 383
#define TOK_OR 384
#define TOK_OUT 385
#define TOK_P 386
#define TOK_PATHNAME 387
#define TOK_RBREAK 388
#define TOK_POINTER 389
#define TOK_POSITION 390
#define TOK_PPCLASS 391
#define TOK_PPWM 392
#define TOK_PROMPT 393
#define TOK_READ_ONLY 394
#define TOK_READ_WRITE 395
#define TOK_QUIT 396
#define TOK_QUOTED_SYMBOL 397
#define TOK_QUOTED_VAR 398
#define TOK_RESTART 399
#define TOK_REFERENCE 400
#define TOK_REMOVE 401
#define TOK_REMOVE_EVERY 402
#define TOK_REPORT 403
#define TOK_RG 404
#define TOK_RUN 405
#define TOK_RESTORESTATE 406
#define TOK_RETURN 407
#define TOK_RETURNS 408
#define TOK_RJUST 409
#define TOK_RULE 410
#define TOK_RULE_BLOCK 411
#define TOK_RULE_GROUP 412
#define TOK_SAVESTATE 413
#define TOK_SAME_TYPE 414
#define TOK_SCALAR 415
#define TOK_SHORT 416
#define TOK_SHOW 417
#define TOK_SINGLE_FLOAT 418
#define TOK_SPACE 419
#define TOK_SPECIALIZE 420
#define TOK_SQL_ATTACH 421
#define TOK_SQL_COMMIT 422
#define TOK_SQL_DELETE 423
#define TOK_SQL_DETACH 424
#define TOK_SQL_FETCH_AS_OBJECT 425
#define TOK_SQL_FETCH_EACH 426
#define TOK_SQL_INSERT 427
#define TOK_SQL_INSERT_FROM_OBJECT 428
#define TOK_SQL_ROLLBACK 429
#define TOK_SQL_START 430
#define TOK_SQL_UPDATE 431
#define TOK_SQL_UPDATE_FROM_OBJECT 432
#define TOK_STARTUP 433
#define TOK_STRATEGY 434
#define TOK_SUBCOMPOUND 435
#define TOK_SUBSYMBOL 436
#define TOK_SUCCESS 437
#define TOK_SYMBOL 438
#define TOK_SYMBOL_CONST 439
#define TOK_SYMBOL_LENGTH 440
#define TOK_TABTO 441
#define TOK_THEN 442
#define TOK_TRACE 443
#define TOK_UNSIGNED_BYTE 444
#define TOK_UNSIGNED_LONG 445
#define TOK_UNSIGNED_SHORT 446
#define TOK_USES 447
#define TOK_VALUE 448
#define TOK_VARIABLE 449
#define TOK_VERSION 450
#define TOK_WARNING 451
#define TOK_WBREAK 452
#define TOK_WHEN 453
#define TOK_WHILE 454
#define TOK_WM 455
#define TOK_WMHISTORY 456
#define TOK_WRITE 457
#define YYERRCODE 256
short yylhs[] = {                                        -1,
    0,    0,    0,    0,    0,   45,   45,   45,   45,   45,
   45,   45,   45,   45,   45,   45,   45,   45,   45,   45,
   45,   45,   45,   45,   45,   45,   45,   45,   45,   45,
   45,   45,   45,   45,   45,   45,   45,   45,   79,   46,
   80,   47,   82,   48,   81,   81,   84,   49,   83,   83,
   50,   87,   85,   51,   88,   52,   43,   43,   43,   43,
   89,   53,   34,   34,   34,   34,   34,   91,   54,   92,
   54,   90,   90,   93,   93,   94,   94,   96,   96,   95,
   95,   97,   97,   97,   97,   18,   98,   55,   35,   35,
   35,   35,   35,   56,   56,   57,  100,   99,  102,   58,
  101,  101,   59,  104,  103,   60,  105,   61,   44,   44,
   44,   44,   44,  107,   62,  106,  106,  108,  108,  109,
  109,  110,  110,  111,  111,  111,  111,  112,   63,   32,
   32,  113,   64,   36,   36,  114,   65,  115,   66,    9,
    9,    9,    9,  117,   67,  116,  116,  116,  116,  118,
   68,  119,   69,  120,   70,   24,   24,  121,   71,    6,
    6,    6,    6,    6,  122,   72,  124,   73,  123,   74,
  126,  125,  128,   75,  127,  127,  129,  129,  130,  130,
  131,  131,  132,  132,  132,  132,  132,  132,  132,  134,
   76,  133,  133,  135,  135,  136,  137,  137,  138,  138,
  138,   13,  140,   77,  139,  139,  141,  141,  142,   78,
   33,   29,   29,   86,   86,  143,  143,   31,   31,   31,
   14,  144,   37,  145,   37,   38,   38,   39,  146,  146,
    5,    5,    5,    7,    7,   40,  147,   40,   42,   42,
  149,   41,   41,   41,  148,  148,    2,    2,    3,    3,
    3,    3,    3,    3,    3,    3,    3,    3,    3,    3,
    4,    4,    4,    4,    4,    4,    4,    4,    4,    4,
    4,    4,   28,   16,   16,   16,   16,   16,   16,   27,
   27,   25,   25,   22,   22,   21,   21,   10,   11,   11,
   12,   12,   12,   12,   12,   12,   12,   12,   12,   12,
   12,   12,   12,   12,   12,   12,   12,   12,   12,   12,
   12,   12,   12,   12,   12,   12,   12,   12,   12,   12,
   12,   12,   12,   12,   12,   12,   12,   12,   12,   12,
   12,   12,   12,   12,   12,   12,   12,   12,   12,   12,
   12,   12,   12,   12,   12,   12,   12,   12,   12,   12,
   12,   12,   12,   12,   12,   12,   12,   12,   12,   12,
   12,   12,   12,   12,   12,   12,   12,   12,   12,   12,
   12,   12,   12,   12,   12,   12,   12,   12,   12,   12,
   12,   12,   12,   12,   12,   12,   12,   12,   12,   12,
   12,   12,   12,   12,   12,   12,   12,   12,   12,   12,
   12,   12,   12,   12,   12,   12,   12,   12,   12,   12,
   12,   12,   12,   12,   12,   12,   12,   12,   12,   12,
   12,   12,   12,   12,   12,   12,   12,   12,   12,   12,
   12,   12,   12,   12,   12,   12,   12,   12,   12,   12,
   12,   12,   12,   12,   12,   12,   12,   12,   12,   20,
    8,   19,    1,   23,   15,   17,   17,   26,   26,   26,
   26,   26,   26,   30,
};
short yylen[] = {                                         2,
    2,    2,    3,    3,    1,    1,    1,    1,    1,    1,
    1,    1,    1,    1,    1,    1,    1,    1,    1,    1,
    1,    1,    1,    1,    1,    1,    1,    1,    1,    1,
    1,    1,    1,    1,    1,    1,    1,    1,    0,    3,
    0,    3,    0,    3,    2,    1,    0,    3,    1,    2,
    2,    0,    3,    1,    0,    4,    1,    1,    1,    1,
    0,    3,    1,    1,    1,    1,    1,    0,    3,    0,
    3,    0,    1,    2,    2,    1,    1,    1,    2,    1,
    1,    1,    2,    1,    2,    1,    0,    3,    1,    1,
    1,    1,    1,    1,    1,    2,    0,    3,    0,    3,
    1,    2,    2,    0,    3,    1,    0,    5,    0,    1,
    1,    1,    1,    0,    3,    0,    1,    2,    2,    1,
    2,    1,    1,    1,    2,    1,    2,    0,    3,    0,
    1,    0,    3,    0,    1,    0,    3,    0,    3,    0,
    1,    1,    1,    0,    3,    0,    1,    2,    1,    0,
    3,    0,    3,    0,    3,    0,    1,    0,    3,    0,
    1,    1,    1,    1,    0,    3,    0,    3,    1,    2,
    0,    4,    0,    3,    0,    1,    2,    2,    1,    1,
    1,    2,    1,    1,    1,    1,    1,    1,    1,    0,
    3,    0,    1,    2,    2,    1,    1,    1,    1,    1,
    2,    1,    0,    3,    0,    1,    1,    2,    0,    4,
    1,    0,    2,    0,    2,    4,    1,    3,    1,    1,
    1,    0,    5,    0,    3,    0,    2,    2,    3,    1,
    0,    3,    1,    1,    1,    1,    0,    4,    2,    1,
    0,    4,    2,    1,    1,    2,    1,    1,    1,    1,
    1,    1,    1,    1,    1,    1,    1,    1,    1,    1,
    1,    1,    1,    1,    1,    1,    1,    1,    2,    2,
    2,    2,    1,    1,    1,    1,    1,    1,    1,    1,
    1,    1,    3,    1,    1,    1,    1,    1,    1,    1,
    1,    1,    1,    1,    1,    1,    1,    1,    1,    1,
    1,    1,    1,    1,    1,    1,    1,    1,    1,    1,
    1,    1,    1,    1,    1,    1,    1,    1,    1,    1,
    1,    1,    1,    1,    1,    1,    1,    1,    1,    1,
    1,    1,    1,    1,    1,    1,    1,    1,    1,    1,
    1,    1,    1,    1,    1,    1,    1,    1,    1,    1,
    1,    1,    1,    1,    1,    1,    1,    1,    1,    1,
    1,    1,    1,    1,    1,    1,    1,    1,    1,    1,
    1,    1,    1,    1,    1,    1,    1,    1,    1,    1,
    1,    1,    1,    1,    1,    1,    1,    1,    1,    1,
    1,    1,    1,    1,    1,    1,    1,    1,    1,    1,
    1,    1,    1,    1,    1,    1,    1,    1,    1,    1,
    1,    1,    1,    1,    1,    1,    1,    1,    1,    1,
    1,    1,    1,    1,    1,    1,    1,    1,    1,    1,
    1,    1,    1,    1,    1,    1,    1,    1,    1,    1,
    1,    1,    1,    1,    1,    1,    1,    1,    1,    1,
    1,    1,    1,    1,    4,    0,    2,    1,    1,    1,
    1,    1,    1,    1,
};
short yydefred[] = {                                      0,
    0,    5,   95,    0,   41,   43,   39,   47,   52,   54,
   55,   61,   68,   70,   87,   94,   97,   99,  104,  106,
  107,  114,  128,  132,  136,  138,  144,  150,  158,  152,
  154,  165,  167,  171,  173,  190,  203,  209,    0,    0,
    6,    7,    8,    9,   10,   11,   12,   13,   14,   15,
   16,   17,   18,   19,   20,   21,   22,   23,   24,   25,
   26,   27,   28,   29,   30,   31,   32,   33,   34,   35,
   36,   37,   38,  214,  214,  214,  214,    2,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    1,    0,    0,    0,    0,    4,    3,  382,  361,
  289,  324,  363,  292,  293,  294,  295,  296,  297,  298,
  299,  300,  301,  302,  303,  304,  305,  291,  306,  307,
  308,  309,  310,  311,  312,  313,  314,  315,  316,  317,
  318,  319,  320,  321,  322,  323,  325,  326,  327,  328,
  329,  330,  331,  332,  333,  334,  335,  336,  337,  338,
  339,  340,  341,  342,  343,  344,  345,  346,  347,  348,
  349,  350,  351,  352,  353,  354,  355,  357,  356,  358,
  359,  360,  362,  364,  366,  365,  371,  372,  373,  374,
  367,  368,  369,  370,  375,  376,  377,  378,  379,  380,
  381,  383,  384,  385,  386,  387,  390,  391,  388,  288,
  389,  396,  392,  393,  394,  395,  400,  405,  397,  398,
  399,  401,  402,  403,  404,  406,  407,  408,  409,  410,
  411,  412,  413,  414,  415,  416,  417,  418,  419,  420,
  421,  422,  423,  424,  425,  426,  428,  427,  429,  430,
  431,  432,  433,  434,  435,  436,  437,  438,  439,  440,
  441,  442,  443,  444,  446,  445,  447,  448,  449,  281,
  280,  290,   42,   46,  451,  450,    0,   44,   40,   49,
    0,  464,   53,    0,   67,   65,   66,   63,   64,   62,
    0,    0,   69,   73,   71,   93,   91,   92,   89,   90,
   88,  220,  285,  284,    0,   98,    0,  101,    0,  105,
    0,    0,    0,  115,  117,  131,  129,    0,  224,  133,
  135,  137,  142,  141,  143,  139,  149,  147,    0,  151,
  453,  452,  159,  161,  163,  162,  164,  153,  454,    0,
  459,  458,  287,  462,  461,  157,  463,  155,  286,  460,
  166,  169,  168,    0,    0,    0,  174,  176,    0,    0,
  191,  193,  207,  204,    0,  211,    0,  217,    0,  215,
   45,   50,   60,   57,   58,   59,   56,   80,   84,   82,
   86,   75,    0,   76,   78,   74,    0,    0,    0,  102,
    0,  122,  126,  124,  119,    0,  120,    0,  222,  226,
  148,  456,  172,  179,  189,  184,  183,  186,  187,  185,
  188,  178,    0,  181,  177,  197,  200,  199,  195,    0,
  196,  194,  208,    0,  210,    0,  202,   85,   83,   79,
  218,  283,  113,  112,  110,  111,  108,  127,  125,  121,
  226,    0,    0,  182,  201,  213,  233,    0,    0,    0,
  230,    0,  227,    0,  455,  457,  235,    0,  234,  216,
  221,  223,    0,  237,  241,  249,    0,  260,    0,  251,
  252,  253,  254,  262,  266,  265,  264,  261,  263,  255,
  256,  250,  257,  258,  259,    0,    0,  248,  279,  273,
  275,  274,  277,  278,  244,  276,  228,  236,  232,  229,
    0,    0,  269,  270,  243,  271,  272,  240,    0,  245,
    0,  238,  239,  242,  246,
};
short yydgoto[] = {                                      39,
  342,  496,  497,  498,  459,  343,  468,  286,  336,  313,
  281,  314,  436,  470,  499,  500,  453,  390,  501,  502,
  356,  315,  503,  358,  318,  359,  504,  505,  435,  506,
  329,  327,  377,  300,  311,  330,  331,  452,  463,  507,
  508,  519,  387,  447,   40,   41,   42,   43,   44,   45,
   46,   47,   48,   49,   50,   51,   52,   53,   54,   55,
   56,   57,   58,   59,   60,   61,   62,   63,   64,   65,
   66,   67,   68,   69,   70,   71,   72,   73,   83,   81,
  288,   82,  291,   84,   74,  113,   85,   86,   87,  303,
   88,   89,  304,  396,  392,  397,  393,   90,   75,   91,
  319,   92,   76,   93,   94,  324,   95,  325,  408,  405,
  406,   96,   97,   98,   99,  339,  100,  101,  103,  104,
  102,  105,  363,  106,   77,  107,  367,  108,  368,  422,
  423,  424,  371,  109,  372,  432,  429,  430,  374,  110,
  375,  111,  380,  451,  410,  464,  511,  521,  512,
};
short yysindex[] = {                                   1002,
 -221,    0,    0, 1128,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0, -196,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0, -197, -146,
 4283,  -97, 4283, 4283, -113, 4283, -238, -278, -278, -236,
  599, 4651, -113, 4283, -182,  599,  397, 4283, -245, -191,
  599, 3502, 4283, 2308, 4283, -290, -113, -176, -173, -113,
 -113,    0, -187, -187, -187, -187,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0, 4283,    0,    0,    0,
 4283,    0,    0, -210,    0,    0,    0,    0,    0,    0,
 3701, 4467,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,  -62,    0,  -60,    0, 4651,    0,
 4283, 3900, 4651,    0,    0,    0,    0,  599,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0, -113,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0, -140,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,  599, -243, -243,    0,    0,  195,  397,
    0,    0,    0,    0, -113,    0,  -99,    0, 4651,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0, 4099,    0,    0,    0, 4651, 4651, 4651,    0,
 -231,    0,    0,    0,    0, 4099,    0, 4651,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0, -269,    0,    0,    0,    0,    0,    0,  -68,
    0,    0,    0, 4651,    0, -155,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0, -170, 2507,    0,    0,    0,    0, -225, 2308, -164,
    0, 4651,    0, 1313,    0,    0,    0,  -49,    0,    0,
    0,    0, -155,    0,    0,    0, -233,    0, -233,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0, 2308, -209,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
 1910, 2308,    0,    0,    0,    0,    0,    0, 1512,    0,
 2109,    0,    0,    0,    0,
};
short yyrindex[] = {                                      0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0, -160, -160,    0,
    0,    0,    0,    0, -138, -136, -134,    0, -130, -144,
    0, -128,    0, -120,    0,    0,    0, -115, -112, -111,
    0,    0, -109, -107, -106, -101,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
  -92,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0, -180,    0,  800,    0,  -91,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,  -89,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,  -86,    0,  -80,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,  -77,    0,    0,    0,  -75,    0,    0,    0,
  -69,    0,    0,    0,    0,  -67,    0,  -64,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,  -63,    0,    0,    0,    0,    0,    0,  -61,
    0,    0,    0,    0,    0, 2706,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0, -142,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0, 1711,    0,    0,    0, 2905,    0, 3104,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0, 3303,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,
};
short yygindex[] = {                                      0,
    0,    0, -294,    0, -271,    0,    0,  -87,    0,  -81,
  -98,  -55, -399,    0,  -94,    0,    0, -286,  -93,  -74,
 -280,  -85, -103,    0, -232, -230,  -30, -441,    0,  -66,
  -59,    0,    0,    0,    0,    0, -148, -227,    0,    0,
 -413,    0,    0,    0,  221,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,   56,    0,    0,    0,  137,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0, -139,
    0, -195,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,
};
#define YYTABLESIZE 5108
short yytable[] = {                                     280,
  357,  280,  280,  346,  280,  352,  317,  287,  347,  353,
  354,  335,  280,  285,  344,  395,  280,  295,  293,  306,
  345,  280,  351,  280,  443,  282,  320,  282,  282,  355,
  282,  316,  414,  285,  456,   78,  326,  360,  282,  415,
  364,  340,  282,  373,  376,  383,  282,  282,  282,  282,
  283,  416,  289,  290,  515,  294,  417,  476,  444,  296,
  112,  307,  473,  321,  337,  415,  117,  332,  378,  384,
  520,  297,  348,  308,  361,  219,  219,  416,  219,  525,
  478,  379,  417,  219,  338,  461,  400,  333,  219,  404,
  407,  461,  467,  480,  481,  516,   72,  518,  462,  472,
  457,  301,  302,   72,  462,  523,  439,  517,  482,  483,
  440,  458,  146,  445,  225,  146,  225,  118,  116,  146,
  130,  225,  134,  490,  491,  116,  140,  130,  160,  134,
  114,  115,  116,  140,  418,  160,  156,  492,  493,  494,
  419,  175,  420,  156,  192,  205,  292,   51,  175,   96,
  103,  192,  205,  446,   51,  170,   96,  103,  284,  362,
  418,  285,  170,  412,   48,  100,  419,  145,  420,  434,
  206,   48,  100,  449,  145,  450,  212,  206,  471,   81,
  495,   77,  513,  212,  514,  421,   81,  109,   77,  123,
  285,  334,  118,  180,  109,  198,  123,  322,  323,  118,
  180,  510,  198,  365,  366,  280,  369,  370,  398,  280,
  399,  421,  298,  389,  309,  391,  391,  299,  509,  310,
  428,  431,  466,  460,   80,  305,  425,  454,    0,    0,
    0,  282,  385,  317,  403,  282,  317,  317,    0,  280,
    0,    0,    0,    0,    0,    0,  386,    0,    0,    0,
    0,    0,    0,    0,    0,    0,  381,    0,    0,    0,
  382,    0,    0,    0,    0,  282,    0,    0,  409,    0,
    0,    0,  411,    0,    0,    0,    0,    0,    0,    0,
    0,  427,    0,    0,    0,    0,    0,    0,    0,    0,
  401,    0,    0,  437,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,  413,  438,    0,  391,  433,    0,
    0,  391,  441,  442,    0,    0,    0,    0,  448,    0,
  317,    0,  317,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,  455,    0,    0,    0,    0,    0,  437,  357,
    0,    0,    0,    0,  352,  357,    0,    0,    0,  354,
  352,    0,    0,    0,  353,  354,    0,    0,    0,    0,
  469,  351,    0,    0,    0,    0,  437,  351,  355,    0,
    0,    0,  280,    0,  355,    0,  360,    0,    0,    0,
    0,    0,  360,    0,    0,    0,    0,  282,    0,    0,
    0,    0,    0,  282,    0,    0,    0,    0,  282,    0,
    0,    0,    0,    0,  280,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,  280,
  280,    0,    0,    0,    0,    0,    0,  280,    0,  280,
  282,    0,    0,    0,    0,    0,    0,    0,    0,    0,
  312,    0,    0,  285,    0,  282,  282,  328,    0,    0,
    0,    0,    0,  282,    0,  282,    0,    0,  119,  120,
  426,  122,  123,    0,  124,  125,  126,  127,  128,  129,
  130,  131,  132,  133,  134,    0,  135,  136,  137,  138,
  139,  140,  141,  142,  143,  144,  145,  146,  147,    0,
  148,  149,  150,  151,  152,  153,  154,  155,    0,  156,
  157,    0,  158,  159,    0,  160,  161,  162,  163,  164,
  165,    0,    0,  166,  167,    0,  168,  169,  170,  171,
  172,  173,  174,  175,  176,  177,    0,    0,  178,  179,
  180,  181,  182,  183,  184,    0,    0,    0,    0,    0,
    0,    0,    0,  185,  186,  187,  188,  189,  190,  191,
  192,  193,  194,  195,  196,    0,    0,    0,  197,  198,
  199,  200,  201,  202,  203,  204,  205,  206,  207,  208,
  209,  210,  211,  212,  213,  214,  215,  216,  217,  218,
  219,  220,  221,  222,  223,  224,  225,  226,  227,  228,
  229,  230,  231,  232,  233,  234,  235,  236,    0,  237,
  238,  239,  240,  241,  242,  243,  244,  245,  246,  247,
  248,  249,  250,  251,  252,  253,  254,  255,  256,  257,
  258,  259,  260,  261,  262,  263,  264,  265,  266,  267,
  268,  269,  270,  271,  272,  273,  274,  275,  276,  277,
  278,  279,  312,    0,    0,    0,    0,    0,    0,  328,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
  119,  120,    0,  122,  123,    0,  124,  125,  126,  127,
  128,  129,  130,  131,  132,  133,  134,    0,  135,  136,
  137,  138,  139,  140,  141,  142,  143,  144,  145,  146,
  147,    0,  148,  149,  150,  151,  152,  153,  154,  155,
    0,  156,  157,    0,  158,  159,    0,  160,  161,  162,
  163,  164,  165,    0,    0,  166,  167,    0,  168,  169,
  170,  171,  172,  173,  174,  175,  176,  177,    0,    0,
  178,  179,  180,  181,  182,  183,  184,    0,    0,    0,
    0,    0,    0,    0,    0,  185,  186,  187,  188,  189,
  190,  191,  192,  193,  194,  195,  196,    0,    0,    0,
  197,  198,  199,  200,  201,  202,  203,  204,  205,  206,
  207,  208,  209,  210,  211,  212,  213,  214,  215,  216,
  217,  218,  219,  220,  221,  222,  223,  224,  225,  226,
  227,  228,  229,  230,  231,  232,  233,  234,  235,  236,
    0,  237,  238,  239,  240,  241,  242,  243,  244,  245,
  246,  247,  248,  249,  250,  251,  252,  253,  254,  255,
  256,  257,  258,  259,  260,  261,  262,  263,  264,  265,
  266,  267,  268,  269,  270,  271,  272,  273,  274,  275,
  276,  277,  278,  279,  312,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,  119,  120,    0,  122,  123,    0,  124,  125,
  126,  127,  128,  129,  130,  131,  132,  133,  134,    0,
  135,  136,  137,  138,  139,  140,  141,  142,  143,  144,
  145,  146,  147,    0,  148,  149,  150,  151,  152,  153,
  154,  155,    0,  156,  157,    0,  158,  159,    0,  160,
  161,  162,  163,  164,  165,    0,    0,  166,  167,    0,
  168,  169,  170,  171,  172,  173,  174,  175,  176,  177,
    0,    0,  178,  179,  180,  181,  182,  183,  184,    0,
    0,    0,    0,    0,    0,    0,    0,  185,  186,  187,
  188,  189,  190,  191,  192,  193,  194,  195,  196,    0,
    0,    0,  197,  198,  199,  200,  201,  202,  203,  204,
  205,  206,  207,  208,  209,  210,  211,  212,  213,  214,
  215,  216,  217,  218,  219,  220,  221,  222,  223,  224,
  225,  226,  227,  228,  229,  230,  231,  232,  233,  234,
  235,  236,    0,  237,  238,  239,  240,  241,  242,  243,
  244,  245,  246,  247,  248,  249,  250,  251,  252,  253,
  254,  255,  256,  257,  258,  259,  260,  261,  262,  263,
  264,  265,  266,  267,  268,  269,  270,  271,  272,  273,
  274,  275,  276,  277,  278,  279,  282,    0,  282,    0,
    0,    0,    0,  282,    0,    0,    0,    0,    0,    0,
    0,    0,    0,  282,  282,    0,  282,  282,    0,  282,
  282,  282,  282,  282,  282,  282,  282,  282,  282,  282,
    0,  282,  282,  282,  282,  282,  282,  282,  282,  282,
  282,  282,  282,  282,    0,  282,  282,  282,  282,  282,
  282,  282,  282,    0,  282,  282,    0,  282,  282,    0,
  282,  282,  282,  282,  282,  282,    0,    0,  282,  282,
    0,  282,  282,  282,  282,  282,  282,  282,  282,  282,
  282,    0,    0,  282,  282,  282,  282,  282,  282,  282,
    0,    0,    0,    0,    0,    0,    0,    0,  282,  282,
  282,  282,  282,  282,  282,  282,  282,  282,  282,  282,
    0,    0,    0,  282,  282,  282,  282,  282,  282,  282,
  282,  282,  282,  282,  282,  282,  282,  282,  282,  282,
  282,  282,  282,  282,  282,  282,  282,  282,  282,  282,
  282,  282,  282,  282,  282,  282,  282,  282,  282,  282,
  282,  282,  282,    0,  282,  282,  282,  282,  282,  282,
  282,  282,  282,  282,  282,  282,  282,  282,  282,  282,
  282,  282,  282,  282,  282,  282,  282,  282,  282,  282,
  282,  282,  282,  282,  282,  282,  282,  282,  282,  282,
  282,  282,  282,  282,  282,  282,  282,    1,    2,    3,
    0,    0,    0,    0,    4,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    5,    6,    0,    0,
    0,    0,    0,    0,    0,    0,    7,    0,    0,    0,
    0,    0,    0,    0,    8,    0,    0,    0,    9,    0,
   10,    0,    0,    0,   11,    0,   12,    0,    0,    0,
    0,   13,   14,    0,   15,    0,    0,    0,    0,    0,
    0,    0,   16,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,   17,    0,   18,    0,    0,    0,   19,   20,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,   79,   21,    3,    0,    0,    0,   22,
    0,    0,   23,   24,   25,    0,    0,   26,    0,    0,
    0,    0,   27,   28,    0,    0,   29,   30,   31,    0,
    0,    0,    5,    6,   32,    0,    0,    0,   33,    0,
    0,   34,    7,    0,    0,    0,    0,    0,    0,    0,
    8,    0,    0,    0,    9,    0,   10,    0,    0,    0,
   11,    0,   12,    0,   35,    0,    0,   13,   14,    0,
   15,    0,    0,   36,    0,    0,   37,   38,   16,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,   17,    0,
   18,    0,    0,    0,   19,   20,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
   21,    0,    0,    0,    0,   22,    0,    0,   23,   24,
   25,    0,    0,   26,    0,    0,    0,    0,   27,   28,
    0,    0,   29,   30,   31,    0,    0,    0,    0,    0,
   32,    0,    0,    0,   33,    0,    0,   34,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
   35,  285,  292,  349,  341,  350,    0,  474,    0,   36,
    0,    0,   37,   38,  475,    0,  119,  120,  121,  122,
  123,    0,  124,  125,  126,  127,  128,  129,  130,  131,
  132,  133,  134,  476,  135,  136,  137,  138,  139,  140,
  141,  142,  143,  144,  145,  146,  147,  477,  148,  149,
  150,  151,  152,  153,  154,  155,  478,  156,  157,  479,
  158,  159,    0,  160,  161,  162,  163,  164,  165,  480,
  481,  166,  167,    0,  168,  169,  170,  171,  172,  173,
  174,  175,  176,  177,  482,  483,  178,  179,  180,  181,
  182,  183,  184,  484,  485,  486,  487,  488,  489,  490,
  491,  185,  186,  187,  188,  189,  190,  191,  192,  193,
  194,  195,  196,  492,  493,  494,  197,  198,  199,  200,
  201,  202,  203,  204,  205,  206,  207,  208,  209,  210,
  211,  212,  213,  214,  215,  216,  217,  218,  219,  220,
  221,  222,  223,  224,  225,  226,  227,  228,  229,  230,
  231,  232,  233,  234,  235,  236,  495,  237,  238,  239,
  240,  241,  242,  243,  244,  245,  246,  247,  248,  249,
  250,  251,  252,  253,  254,  255,  256,  257,  258,  259,
  260,  261,  262,  263,  264,  265,  266,  267,  268,  269,
  270,  271,  272,  273,  274,  275,  276,  277,  278,  279,
  285,  292,  349,  341,  350,    0,    0,  522,    0,    0,
    0,    0,    0,  475,    0,  119,  120,  121,  122,  123,
    0,  124,  125,  126,  127,  128,  129,  130,  131,  132,
  133,  134,  476,  135,  136,  137,  138,  139,  140,  141,
  142,  143,  144,  145,  146,  147,  477,  148,  149,  150,
  151,  152,  153,  154,  155,  478,  156,  157,  479,  158,
  159,    0,  160,  161,  162,  163,  164,  165,  480,  481,
  166,  167,    0,  168,  169,  170,  171,  172,  173,  174,
  175,  176,  177,  482,  483,  178,  179,  180,  181,  182,
  183,  184,  484,  485,  486,  487,  488,  489,  490,  491,
  185,  186,  187,  188,  189,  190,  191,  192,  193,  194,
  195,  196,  492,  493,  494,  197,  198,  199,  200,  201,
  202,  203,  204,  205,  206,  207,  208,  209,  210,  211,
  212,  213,  214,  215,  216,  217,  218,  219,  220,  221,
  222,  223,  224,  225,  226,  227,  228,  229,  230,  231,
  232,  233,  234,  235,  236,  495,  237,  238,  239,  240,
  241,  242,  243,  244,  245,  246,  247,  248,  249,  250,
  251,  252,  253,  254,  255,  256,  257,  258,  259,  260,
  261,  262,  263,  264,  265,  266,  267,  268,  269,  270,
  271,  272,  273,  274,  275,  276,  277,  278,  279,  231,
  231,  231,  231,  231,    0,  231,    0,    0,    0,    0,
    0,    0,  231,    0,  231,  231,  231,  231,  231,    0,
  231,  231,  231,  231,  231,  231,  231,  231,  231,  231,
  231,  231,  231,  231,  231,  231,  231,  231,  231,  231,
  231,  231,  231,  231,  231,  231,  231,  231,  231,  231,
  231,  231,  231,  231,  231,  231,  231,  231,  231,  231,
    0,  231,  231,  231,  231,  231,  231,  231,  231,  231,
  231,    0,  231,  231,  231,  231,  231,  231,  231,  231,
  231,  231,  231,  231,  231,  231,  231,  231,  231,  231,
  231,  231,  231,  231,  231,  231,  231,  231,  231,  231,
  231,  231,  231,  231,  231,  231,  231,  231,  231,  231,
  231,  231,  231,  231,  231,  231,  231,  231,  231,  231,
  231,  231,  231,  231,  231,  231,  231,  231,  231,  231,
  231,  231,  231,  231,  231,  231,  231,  231,  231,  231,
  231,  231,  231,  231,  231,  231,  231,  231,  231,  231,
  231,  231,  231,  231,  231,  231,  231,  231,  231,  231,
  231,  231,  231,  231,  231,  231,  231,  231,  231,  231,
  231,  231,  231,  231,  231,  231,  231,  231,  231,  231,
  231,  231,  231,  231,  231,  231,  231,  231,  231,  231,
  231,  231,  231,  231,  231,  231,  231,  231,  285,  292,
  349,  341,  350,    0,    0,    0,    0,    0,    0,    0,
    0,  475,    0,  119,  120,  121,  122,  123,    0,  124,
  125,  126,  127,  128,  129,  130,  131,  132,  133,  134,
  476,  135,  136,  137,  138,  139,  140,  141,  142,  143,
  144,  145,  146,  147,  477,  148,  149,  150,  151,  152,
  153,  154,  155,  478,  156,  157,  479,  158,  159,    0,
  160,  161,  162,  163,  164,  165,  480,  481,  166,  167,
    0,  168,  169,  170,  171,  172,  173,  174,  175,  176,
  177,  482,  483,  178,  179,  180,  181,  182,  183,  184,
  484,  485,  486,  487,  488,  489,  490,  491,  185,  186,
  187,  188,  189,  190,  191,  192,  193,  194,  195,  196,
  492,  493,  494,  197,  198,  199,  200,  201,  202,  203,
  204,  205,  206,  207,  208,  209,  210,  211,  212,  213,
  214,  215,  216,  217,  218,  219,  220,  221,  222,  223,
  224,  225,  226,  227,  228,  229,  230,  231,  232,  233,
  234,  235,  236,  495,  237,  238,  239,  240,  241,  242,
  243,  244,  245,  246,  247,  248,  249,  250,  251,  252,
  253,  254,  255,  256,  257,  258,  259,  260,  261,  262,
  263,  264,  265,  266,  267,  268,  269,  270,  271,  272,
  273,  274,  275,  276,  277,  278,  279,  285,  292,  349,
  341,  350,    0,    0,    0,    0,    0,    0,    0,    0,
    0,  524,  119,  120,  121,  122,  123,    0,  124,  125,
  126,  127,  128,  129,  130,  131,  132,  133,  134,    0,
  135,  136,  137,  138,  139,  140,  141,  142,  143,  144,
  145,  146,  147,    0,  148,  149,  150,  151,  152,  153,
  154,  155,    0,  156,  157,    0,  158,  159,    0,  160,
  161,  162,  163,  164,  165,    0,    0,  166,  167,    0,
  168,  169,  170,  171,  172,  173,  174,  175,  176,  177,
    0,    0,  178,  179,  180,  181,  182,  183,  184,    0,
    0,    0,    0,    0,    0,    0,    0,  185,  186,  187,
  188,  189,  190,  191,  192,  193,  194,  195,  196,    0,
    0,    0,  197,  198,  199,  200,  201,  202,  203,  204,
  205,  206,  207,  208,  209,  210,  211,  212,  213,  214,
  215,  216,  217,  218,  219,  220,  221,  222,  223,  224,
  225,  226,  227,  228,  229,  230,  231,  232,  233,  234,
  235,  236,    0,  237,  238,  239,  240,  241,  242,  243,
  244,  245,  246,  247,  248,  249,  250,  251,  252,  253,
  254,  255,  256,  257,  258,  259,  260,  261,  262,  263,
  264,  265,  266,  267,  268,  269,  270,  271,  272,  273,
  274,  275,  276,  277,  278,  279,  285,  292,  349,  341,
  350,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,  119,  120,  121,  122,  123,    0,  124,  125,  126,
  127,  128,  129,  130,  131,  132,  133,  134,    0,  135,
  136,  137,  138,  139,  140,  141,  142,  143,  144,  145,
  146,  147,    0,  148,  149,  150,  151,  152,  153,  154,
  155,    0,  156,  157,    0,  158,  159,    0,  160,  161,
  162,  163,  164,  165,    0,    0,  166,  167,    0,  168,
  169,  170,  171,  172,  173,  174,  175,  176,  177,    0,
    0,  178,  179,  180,  181,  182,  183,  184,    0,    0,
    0,    0,    0,    0,    0,    0,  185,  186,  187,  188,
  189,  190,  191,  192,  193,  194,  195,  196,    0,    0,
    0,  197,  198,  199,  200,  201,  202,  203,  204,  205,
  206,  207,  208,  209,  210,  211,  212,  213,  214,  215,
  216,  217,  218,  219,  220,  221,  222,  223,  224,  225,
  226,  227,  228,  229,  230,  231,  232,  233,  234,  235,
  236,    0,  237,  238,  239,  240,  241,  242,  243,  244,
  245,  246,  247,  248,  249,  250,  251,  252,  253,  254,
  255,  256,  257,  258,  259,  260,  261,  262,  263,  264,
  265,  266,  267,  268,  269,  270,  271,  272,  273,  274,
  275,  276,  277,  278,  279,  285,  292,  349,  341,    0,
  465,    0,    0,    0,    0,    0,    0,    0,    0,    0,
  119,  120,  121,  122,  123,    0,  124,  125,  126,  127,
  128,  129,  130,  131,  132,  133,  134,    0,  135,  136,
  137,  138,  139,  140,  141,  142,  143,  144,  145,  146,
  147,    0,  148,  149,  150,  151,  152,  153,  154,  155,
    0,  156,  157,    0,  158,  159,    0,  160,  161,  162,
  163,  164,  165,    0,    0,  166,  167,    0,  168,  169,
  170,  171,  172,  173,  174,  175,  176,  177,    0,    0,
  178,  179,  180,  181,  182,  183,  184,    0,    0,    0,
    0,    0,    0,    0,    0,  185,  186,  187,  188,  189,
  190,  191,  192,  193,  194,  195,  196,    0,    0,    0,
  197,  198,  199,  200,  201,  202,  203,  204,  205,  206,
  207,  208,  209,  210,  211,  212,  213,  214,  215,  216,
  217,  218,  219,  220,  221,  222,  223,  224,  225,  226,
  227,  228,  229,  230,  231,  232,  233,  234,  235,  236,
    0,  237,  238,  239,  240,  241,  242,  243,  244,  245,
  246,  247,  248,  249,  250,  251,  252,  253,  254,  255,
  256,  257,  258,  259,  260,  261,  262,  263,  264,  265,
  266,  267,  268,  269,  270,  271,  272,  273,  274,  275,
  276,  277,  278,  279,  231,  231,  231,  231,  231,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,  231,
  231,  231,  231,  231,    0,  231,  231,  231,  231,  231,
  231,  231,  231,  231,  231,  231,    0,  231,  231,  231,
  231,  231,  231,  231,  231,  231,  231,  231,  231,  231,
    0,  231,  231,  231,  231,  231,  231,  231,  231,    0,
  231,  231,    0,  231,  231,    0,  231,  231,  231,  231,
  231,  231,    0,    0,  231,  231,    0,  231,  231,  231,
  231,  231,  231,  231,  231,  231,  231,    0,    0,  231,
  231,  231,  231,  231,  231,  231,    0,    0,    0,    0,
    0,    0,    0,    0,  231,  231,  231,  231,  231,  231,
  231,  231,  231,  231,  231,  231,    0,    0,    0,  231,
  231,  231,  231,  231,  231,  231,  231,  231,  231,  231,
  231,  231,  231,  231,  231,  231,  231,  231,  231,  231,
  231,  231,  231,  231,  231,  231,  231,  231,  231,  231,
  231,  231,  231,  231,  231,  231,  231,  231,  231,    0,
  231,  231,  231,  231,  231,  231,  231,  231,  231,  231,
  231,  231,  231,  231,  231,  231,  231,  231,  231,  231,
  231,  231,  231,  231,  231,  231,  231,  231,  231,  231,
  231,  231,  231,  231,  231,  231,  231,  231,  231,  231,
  231,  231,  231,  267,  267,  267,  267,  267,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,  267,  267,
  267,  267,  267,    0,  267,  267,  267,  267,  267,  267,
  267,  267,  267,  267,  267,    0,  267,  267,  267,  267,
  267,  267,  267,  267,  267,  267,  267,  267,  267,    0,
  267,  267,  267,  267,  267,  267,  267,  267,    0,  267,
  267,    0,  267,  267,    0,  267,  267,  267,  267,  267,
  267,    0,    0,  267,  267,    0,  267,  267,  267,  267,
  267,  267,  267,  267,  267,  267,    0,    0,  267,  267,
  267,  267,  267,  267,  267,    0,    0,    0,    0,    0,
    0,    0,    0,  267,  267,  267,  267,  267,  267,  267,
  267,  267,  267,  267,  267,    0,    0,    0,  267,  267,
  267,  267,  267,  267,  267,  267,  267,  267,  267,  267,
  267,  267,  267,  267,  267,  267,  267,  267,  267,  267,
  267,  267,  267,  267,  267,  267,  267,  267,  267,  267,
  267,  267,  267,  267,  267,  267,  267,  267,    0,  267,
  267,  267,  267,  267,  267,  267,  267,  267,  267,  267,
  267,  267,  267,  267,  267,  267,  267,  267,  267,  267,
  267,  267,  267,  267,  267,  267,  267,  267,  267,  267,
  267,  267,  267,  267,  267,  267,  267,  267,  267,  267,
  267,  267,  268,  268,  268,  268,  268,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,  268,  268,  268,
  268,  268,    0,  268,  268,  268,  268,  268,  268,  268,
  268,  268,  268,  268,    0,  268,  268,  268,  268,  268,
  268,  268,  268,  268,  268,  268,  268,  268,    0,  268,
  268,  268,  268,  268,  268,  268,  268,    0,  268,  268,
    0,  268,  268,    0,  268,  268,  268,  268,  268,  268,
    0,    0,  268,  268,    0,  268,  268,  268,  268,  268,
  268,  268,  268,  268,  268,    0,    0,  268,  268,  268,
  268,  268,  268,  268,    0,    0,    0,    0,    0,    0,
    0,    0,  268,  268,  268,  268,  268,  268,  268,  268,
  268,  268,  268,  268,    0,    0,    0,  268,  268,  268,
  268,  268,  268,  268,  268,  268,  268,  268,  268,  268,
  268,  268,  268,  268,  268,  268,  268,  268,  268,  268,
  268,  268,  268,  268,  268,  268,  268,  268,  268,  268,
  268,  268,  268,  268,  268,  268,  268,    0,  268,  268,
  268,  268,  268,  268,  268,  268,  268,  268,  268,  268,
  268,  268,  268,  268,  268,  268,  268,  268,  268,  268,
  268,  268,  268,  268,  268,  268,  268,  268,  268,  268,
  268,  268,  268,  268,  268,  268,  268,  268,  268,  268,
  268,  247,  247,  247,  247,  247,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,  247,  247,  247,  247,
  247,    0,  247,  247,  247,  247,  247,  247,  247,  247,
  247,  247,  247,    0,  247,  247,  247,  247,  247,  247,
  247,  247,  247,  247,  247,  247,  247,    0,  247,  247,
  247,  247,  247,  247,  247,  247,    0,  247,  247,    0,
  247,  247,    0,  247,  247,  247,  247,  247,  247,    0,
    0,  247,  247,    0,  247,  247,  247,  247,  247,  247,
  247,  247,  247,  247,    0,    0,  247,  247,  247,  247,
  247,  247,  247,    0,    0,    0,    0,    0,    0,    0,
    0,  247,  247,  247,  247,  247,  247,  247,  247,  247,
  247,  247,  247,    0,    0,    0,  247,  247,  247,  247,
  247,  247,  247,  247,  247,  247,  247,  247,  247,  247,
  247,  247,  247,  247,  247,  247,  247,  247,  247,  247,
  247,  247,  247,  247,  247,  247,  247,  247,  247,  247,
  247,  247,  247,  247,  247,  247,    0,  247,  247,  247,
  247,  247,  247,  247,  247,  247,  247,  247,  247,  247,
  247,  247,  247,  247,  247,  247,  247,  247,  247,  247,
  247,  247,  247,  247,  247,  247,  247,  247,  247,  247,
  247,  247,  247,  247,  247,  247,  247,  247,  247,  247,
  285,    0,    0,  341,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,  119,  120,  121,  122,  123,
    0,  124,  125,  126,  127,  128,  129,  130,  131,  132,
  133,  134,    0,  135,  136,  137,  138,  139,  140,  141,
  142,  143,  144,  145,  146,  147,    0,  148,  149,  150,
  151,  152,  153,  154,  155,    0,  156,  157,    0,  158,
  159,    0,  160,  161,  162,  163,  164,  165,    0,    0,
  166,  167,    0,  168,  169,  170,  171,  172,  173,  174,
  175,  176,  177,    0,    0,  178,  179,  180,  181,  182,
  183,  184,    0,    0,    0,    0,    0,    0,    0,    0,
  185,  186,  187,  188,  189,  190,  191,  192,  193,  194,
  195,  196,    0,    0,    0,  197,  198,  199,  200,  201,
  202,  203,  204,  205,  206,  207,  208,  209,  210,  211,
  212,  213,  214,  215,  216,  217,  218,  219,  220,  221,
  222,  223,  224,  225,  226,  227,  228,  229,  230,  231,
  232,  233,  234,  235,  236,    0,  237,  238,  239,  240,
  241,  242,  243,  244,  245,  246,  247,  248,  249,  250,
  251,  252,  253,  254,  255,  256,  257,  258,  259,  260,
  261,  262,  263,  264,  265,  266,  267,  268,  269,  270,
  271,  272,  273,  274,  275,  276,  277,  278,  279,  285,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,  119,  120,  388,  122,  123,    0,
  124,  125,  126,  127,  128,  129,  130,  131,  132,  133,
  134,    0,  135,  136,  137,  138,  139,  140,  141,  142,
  143,  144,  145,  146,  147,    0,  148,  149,  150,  151,
  152,  153,  154,  155,    0,  156,  157,    0,  158,  159,
    0,  160,  161,  162,  163,  164,  165,    0,    0,  166,
  167,    0,  168,  169,  170,  171,  172,  173,  174,  175,
  176,  177,    0,    0,  178,  179,  180,  181,  182,  183,
  184,    0,    0,    0,    0,    0,    0,    0,    0,  185,
  186,  187,  188,  189,  190,  191,  192,  193,  194,  195,
  196,    0,    0,    0,  197,  198,  199,  200,  201,  202,
  203,  204,  205,  206,  207,  208,  209,  210,  211,  212,
  213,  214,  215,  216,  217,  218,  219,  220,  221,  222,
  223,  224,  225,  226,  227,  228,  229,  230,  231,  232,
  233,  234,  235,  236,    0,  237,  238,  239,  240,  241,
  242,  243,  244,  245,  246,  247,  248,  249,  250,  251,
  252,  253,  254,  255,  256,  257,  258,  259,  260,  261,
  262,  263,  264,  265,  266,  267,  268,  269,  270,  271,
  272,  273,  274,  275,  276,  277,  278,  279,  285,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,  119,  120,  402,  122,  123,    0,  124,
  125,  126,  127,  128,  129,  130,  131,  132,  133,  134,
    0,  135,  136,  137,  138,  139,  140,  141,  142,  143,
  144,  145,  146,  147,    0,  148,  149,  150,  151,  152,
  153,  154,  155,    0,  156,  157,    0,  158,  159,    0,
  160,  161,  162,  163,  164,  165,    0,    0,  166,  167,
    0,  168,  169,  170,  171,  172,  173,  174,  175,  176,
  177,    0,    0,  178,  179,  180,  181,  182,  183,  184,
    0,    0,    0,    0,    0,    0,    0,    0,  185,  186,
  187,  188,  189,  190,  191,  192,  193,  194,  195,  196,
    0,    0,    0,  197,  198,  199,  200,  201,  202,  203,
  204,  205,  206,  207,  208,  209,  210,  211,  212,  213,
  214,  215,  216,  217,  218,  219,  220,  221,  222,  223,
  224,  225,  226,  227,  228,  229,  230,  231,  232,  233,
  234,  235,  236,    0,  237,  238,  239,  240,  241,  242,
  243,  244,  245,  246,  247,  248,  249,  250,  251,  252,
  253,  254,  255,  256,  257,  258,  259,  260,  261,  262,
  263,  264,  265,  266,  267,  268,  269,  270,  271,  272,
  273,  274,  275,  276,  277,  278,  279,  285,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,  119,  120,    0,  122,  123,    0,  124,  125,
  126,  127,  128,  129,  130,  131,  132,  133,  134,    0,
  135,  136,  137,  138,  139,  140,  141,  142,  143,  144,
  145,  146,  147,    0,  148,  149,  150,  151,  152,  153,
  154,  155,    0,  156,  157,    0,  158,  159,    0,  160,
  161,  162,  163,  164,  165,    0,    0,  166,  167,    0,
  168,  169,  170,  171,  172,  173,  174,  175,  176,  177,
    0,    0,  178,  179,  180,  181,  182,  183,  184,    0,
    0,    0,    0,    0,    0,    0,    0,  185,  186,  187,
  188,  189,  190,  191,  192,  193,  194,  195,  196,    0,
    0,    0,  197,  198,  199,  200,  201,  202,  203,  204,
  205,  206,  207,  208,  209,  210,  211,  212,  213,  214,
  215,  216,  217,  218,  219,  220,  221,  222,  223,  224,
  225,  226,  227,  228,  229,  230,  231,  232,  233,  234,
  235,  236,    0,  237,  238,  239,  240,  241,  242,  243,
  244,  245,  246,  247,  248,  249,  250,  251,  252,  253,
  254,  255,  256,  257,  258,  259,  260,  261,  262,  263,
  264,  265,  266,  267,  268,  269,  270,  271,  272,  273,
  274,  275,  276,  277,  278,  279,  119,  120,  121,  122,
  123,    0,  124,  125,  126,  127,  128,  129,  130,  131,
  132,  133,  134,    0,  135,  136,  137,  138,  139,  140,
  141,  142,  143,  144,  145,  146,  147,    0,  148,  149,
  150,  151,  152,  153,  154,  155,    0,  156,  157,    0,
  158,  159,    0,  160,  161,  162,  163,  164,  165,    0,
    0,  166,  167,    0,  168,  169,  170,  171,  172,  173,
  174,  175,  176,  177,    0,    0,  178,  179,  180,  181,
  182,  183,  184,    0,    0,    0,    0,    0,    0,    0,
    0,  185,  186,  187,  188,  189,  190,  191,  192,  193,
  194,  195,  196,    0,    0,    0,  197,  198,  199,  200,
  201,  202,  203,  204,  205,  206,  207,  208,  209,  210,
  211,  212,  213,  214,  215,  216,  217,  218,  219,  220,
  221,  222,  223,  224,  225,  226,  227,  228,  229,  230,
  231,  232,  233,  234,  235,  236,    0,  237,  238,  239,
  240,  241,  242,  243,  244,  245,  246,  247,  248,  249,
  250,  251,  252,  253,  254,  255,  256,  257,  258,  259,
  260,  261,  262,  263,  264,  265,  266,  267,  268,  269,
  270,  271,  272,  273,  274,  275,  276,  277,  278,  279,
  119,  120,  394,  122,  123,    0,  124,  125,  126,  127,
  128,  129,  130,  131,  132,  133,  134,    0,  135,  136,
  137,  138,  139,  140,  141,  142,  143,  144,  145,  146,
  147,    0,  148,  149,  150,  151,  152,  153,  154,  155,
    0,  156,  157,    0,  158,  159,    0,  160,  161,  162,
  163,  164,  165,    0,    0,  166,  167,    0,  168,  169,
  170,  171,  172,  173,  174,  175,  176,  177,    0,    0,
  178,  179,  180,  181,  182,  183,  184,    0,    0,    0,
    0,    0,    0,    0,    0,  185,  186,  187,  188,  189,
  190,  191,  192,  193,  194,  195,  196,    0,    0,    0,
  197,  198,  199,  200,  201,  202,  203,  204,  205,  206,
  207,  208,  209,  210,  211,  212,  213,  214,  215,  216,
  217,  218,  219,  220,  221,  222,  223,  224,  225,  226,
  227,  228,  229,  230,  231,  232,  233,  234,  235,  236,
    0,  237,  238,  239,  240,  241,  242,  243,  244,  245,
  246,  247,  248,  249,  250,  251,  252,  253,  254,  255,
  256,  257,  258,  259,  260,  261,  262,  263,  264,  265,
  266,  267,  268,  269,  270,  271,  272,  273,  274,  275,
  276,  277,  278,  279,  119,  120,    0,  122,  123,    0,
  124,  125,  126,  127,  128,  129,  130,  131,  132,  133,
  134,    0,  135,  136,  137,  138,  139,  140,  141,  142,
  143,  144,  145,  146,  147,    0,  148,  149,  150,  151,
  152,  153,  154,  155,    0,  156,  157,    0,  158,  159,
    0,  160,  161,  162,  163,  164,  165,    0,    0,  166,
  167,    0,  168,  169,  170,  171,  172,  173,  174,  175,
  176,  177,    0,    0,  178,  179,  180,  181,  182,  183,
  184,    0,    0,    0,    0,    0,    0,    0,    0,  185,
  186,  187,  188,  189,  190,  191,  192,  193,  194,  195,
  196,    0,    0,    0,  197,  198,  199,  200,  201,  202,
  203,  204,  205,  206,  207,  208,  209,  210,  211,  212,
  213,  214,  215,  216,  217,  218,  219,  220,  221,  222,
  223,  224,  225,  226,  227,  228,  229,  230,  231,  232,
  233,  234,  235,  236,    0,  237,  238,  239,  240,  241,
  242,  243,  244,  245,  246,  247,  248,  249,  250,  251,
  252,  253,  254,  255,  256,  257,  258,  259,  260,  261,
  262,  263,  264,  265,  266,  267,  268,  269,  270,  271,
  272,  273,  274,  275,  276,  277,  278,  279,
};
short yycheck[] = {                                      81,
  104,   83,   84,  102,   86,  104,   92,   82,  102,  104,
  104,   99,   94,  259,  102,  302,   98,  256,   85,  256,
  102,  103,  104,  105,  256,   81,   93,   83,   84,  104,
   86,   91,  276,  259,  434,  257,   96,  104,   94,  309,
  107,  101,   98,  110,  111,  256,  102,  103,  104,  105,
   81,  321,   83,   84,  496,   86,  326,  291,  290,  298,
  257,  298,  462,   94,  256,  309,  264,   98,  256,  280,
  512,  310,  103,  310,  105,  256,  257,  321,  259,  521,
  314,  269,  326,  264,  276,  256,  319,  333,  269,  322,
  323,  256,  318,  327,  328,  305,  257,  511,  269,  264,
  256,  380,  381,  264,  269,  519,  393,  317,  342,  343,
  397,  267,  257,  345,  257,  260,  259,  264,  257,  264,
  257,  264,  257,  357,  358,  264,  257,  264,  257,  264,
   75,   76,   77,  264,  404,  264,  257,  371,  372,  373,
  410,  257,  412,  264,  257,  257,  260,  257,  264,  257,
  257,  264,  264,  385,  264,  257,  264,  264,  256,  450,
  404,  259,  264,  304,  257,  257,  410,  257,  412,  269,
  257,  264,  264,  406,  264,  408,  257,  264,  459,  257,
  414,  257,  477,  264,  479,  455,  264,  257,  264,  257,
  259,  437,  257,  257,  264,  257,  264,  380,  381,  264,
  264,  473,  264,  380,  381,  287,  380,  381,  271,  291,
  271,  455,  451,  301,  451,  301,  302,  456,  268,  456,
  369,  370,  453,  451,    4,   89,  366,  423,   -1,   -1,
   -1,  287,  443,  319,  322,  291,  322,  323,   -1,  321,
   -1,   -1,   -1,   -1,   -1,   -1,  457,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,  287,   -1,   -1,   -1,
  291,   -1,   -1,   -1,   -1,  321,   -1,   -1,  328,   -1,
   -1,   -1,  339,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,  369,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
  321,   -1,   -1,  379,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,  364,  393,   -1,  393,  375,   -1,
   -1,  397,  398,  399,   -1,   -1,   -1,   -1,  406,   -1,
  406,   -1,  408,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,  430,   -1,   -1,   -1,   -1,   -1,  434,  453,
   -1,   -1,   -1,   -1,  453,  459,   -1,   -1,   -1,  453,
  459,   -1,   -1,   -1,  459,  459,   -1,   -1,   -1,   -1,
  458,  453,   -1,   -1,   -1,   -1,  462,  459,  453,   -1,
   -1,   -1,  464,   -1,  459,   -1,  453,   -1,   -1,   -1,
   -1,   -1,  459,   -1,   -1,   -1,   -1,  453,   -1,   -1,
   -1,   -1,   -1,  459,   -1,   -1,   -1,   -1,  464,   -1,
   -1,   -1,   -1,   -1,  496,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,  511,
  512,   -1,   -1,   -1,   -1,   -1,   -1,  519,   -1,  521,
  496,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
  256,   -1,   -1,  259,   -1,  511,  512,  263,   -1,   -1,
   -1,   -1,   -1,  519,   -1,  521,   -1,   -1,  274,  275,
  276,  277,  278,   -1,  280,  281,  282,  283,  284,  285,
  286,  287,  288,  289,  290,   -1,  292,  293,  294,  295,
  296,  297,  298,  299,  300,  301,  302,  303,  304,   -1,
  306,  307,  308,  309,  310,  311,  312,  313,   -1,  315,
  316,   -1,  318,  319,   -1,  321,  322,  323,  324,  325,
  326,   -1,   -1,  329,  330,   -1,  332,  333,  334,  335,
  336,  337,  338,  339,  340,  341,   -1,   -1,  344,  345,
  346,  347,  348,  349,  350,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,  359,  360,  361,  362,  363,  364,  365,
  366,  367,  368,  369,  370,   -1,   -1,   -1,  374,  375,
  376,  377,  378,  379,  380,  381,  382,  383,  384,  385,
  386,  387,  388,  389,  390,  391,  392,  393,  394,  395,
  396,  397,  398,  399,  400,  401,  402,  403,  404,  405,
  406,  407,  408,  409,  410,  411,  412,  413,   -1,  415,
  416,  417,  418,  419,  420,  421,  422,  423,  424,  425,
  426,  427,  428,  429,  430,  431,  432,  433,  434,  435,
  436,  437,  438,  439,  440,  441,  442,  443,  444,  445,
  446,  447,  448,  449,  450,  451,  452,  453,  454,  455,
  456,  457,  256,   -1,   -1,   -1,   -1,   -1,   -1,  263,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
  274,  275,   -1,  277,  278,   -1,  280,  281,  282,  283,
  284,  285,  286,  287,  288,  289,  290,   -1,  292,  293,
  294,  295,  296,  297,  298,  299,  300,  301,  302,  303,
  304,   -1,  306,  307,  308,  309,  310,  311,  312,  313,
   -1,  315,  316,   -1,  318,  319,   -1,  321,  322,  323,
  324,  325,  326,   -1,   -1,  329,  330,   -1,  332,  333,
  334,  335,  336,  337,  338,  339,  340,  341,   -1,   -1,
  344,  345,  346,  347,  348,  349,  350,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,  359,  360,  361,  362,  363,
  364,  365,  366,  367,  368,  369,  370,   -1,   -1,   -1,
  374,  375,  376,  377,  378,  379,  380,  381,  382,  383,
  384,  385,  386,  387,  388,  389,  390,  391,  392,  393,
  394,  395,  396,  397,  398,  399,  400,  401,  402,  403,
  404,  405,  406,  407,  408,  409,  410,  411,  412,  413,
   -1,  415,  416,  417,  418,  419,  420,  421,  422,  423,
  424,  425,  426,  427,  428,  429,  430,  431,  432,  433,
  434,  435,  436,  437,  438,  439,  440,  441,  442,  443,
  444,  445,  446,  447,  448,  449,  450,  451,  452,  453,
  454,  455,  456,  457,  256,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,  274,  275,   -1,  277,  278,   -1,  280,  281,
  282,  283,  284,  285,  286,  287,  288,  289,  290,   -1,
  292,  293,  294,  295,  296,  297,  298,  299,  300,  301,
  302,  303,  304,   -1,  306,  307,  308,  309,  310,  311,
  312,  313,   -1,  315,  316,   -1,  318,  319,   -1,  321,
  322,  323,  324,  325,  326,   -1,   -1,  329,  330,   -1,
  332,  333,  334,  335,  336,  337,  338,  339,  340,  341,
   -1,   -1,  344,  345,  346,  347,  348,  349,  350,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,  359,  360,  361,
  362,  363,  364,  365,  366,  367,  368,  369,  370,   -1,
   -1,   -1,  374,  375,  376,  377,  378,  379,  380,  381,
  382,  383,  384,  385,  386,  387,  388,  389,  390,  391,
  392,  393,  394,  395,  396,  397,  398,  399,  400,  401,
  402,  403,  404,  405,  406,  407,  408,  409,  410,  411,
  412,  413,   -1,  415,  416,  417,  418,  419,  420,  421,
  422,  423,  424,  425,  426,  427,  428,  429,  430,  431,
  432,  433,  434,  435,  436,  437,  438,  439,  440,  441,
  442,  443,  444,  445,  446,  447,  448,  449,  450,  451,
  452,  453,  454,  455,  456,  457,  257,   -1,  259,   -1,
   -1,   -1,   -1,  264,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,  274,  275,   -1,  277,  278,   -1,  280,
  281,  282,  283,  284,  285,  286,  287,  288,  289,  290,
   -1,  292,  293,  294,  295,  296,  297,  298,  299,  300,
  301,  302,  303,  304,   -1,  306,  307,  308,  309,  310,
  311,  312,  313,   -1,  315,  316,   -1,  318,  319,   -1,
  321,  322,  323,  324,  325,  326,   -1,   -1,  329,  330,
   -1,  332,  333,  334,  335,  336,  337,  338,  339,  340,
  341,   -1,   -1,  344,  345,  346,  347,  348,  349,  350,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,  359,  360,
  361,  362,  363,  364,  365,  366,  367,  368,  369,  370,
   -1,   -1,   -1,  374,  375,  376,  377,  378,  379,  380,
  381,  382,  383,  384,  385,  386,  387,  388,  389,  390,
  391,  392,  393,  394,  395,  396,  397,  398,  399,  400,
  401,  402,  403,  404,  405,  406,  407,  408,  409,  410,
  411,  412,  413,   -1,  415,  416,  417,  418,  419,  420,
  421,  422,  423,  424,  425,  426,  427,  428,  429,  430,
  431,  432,  433,  434,  435,  436,  437,  438,  439,  440,
  441,  442,  443,  444,  445,  446,  447,  448,  449,  450,
  451,  452,  453,  454,  455,  456,  457,  256,  257,  258,
   -1,   -1,   -1,   -1,  263,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,  285,  286,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,  295,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,  303,   -1,   -1,   -1,  307,   -1,
  309,   -1,   -1,   -1,  313,   -1,  315,   -1,   -1,   -1,
   -1,  320,  321,   -1,  323,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,  331,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,  361,   -1,  363,   -1,   -1,   -1,  367,  368,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,  256,  383,  258,   -1,   -1,   -1,  388,
   -1,   -1,  391,  392,  393,   -1,   -1,  396,   -1,   -1,
   -1,   -1,  401,  402,   -1,   -1,  405,  406,  407,   -1,
   -1,   -1,  285,  286,  413,   -1,   -1,   -1,  417,   -1,
   -1,  420,  295,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
  303,   -1,   -1,   -1,  307,   -1,  309,   -1,   -1,   -1,
  313,   -1,  315,   -1,  443,   -1,   -1,  320,  321,   -1,
  323,   -1,   -1,  452,   -1,   -1,  455,  456,  331,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,  361,   -1,
  363,   -1,   -1,   -1,  367,  368,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
  383,   -1,   -1,   -1,   -1,  388,   -1,   -1,  391,  392,
  393,   -1,   -1,  396,   -1,   -1,   -1,   -1,  401,  402,
   -1,   -1,  405,  406,  407,   -1,   -1,   -1,   -1,   -1,
  413,   -1,   -1,   -1,  417,   -1,   -1,  420,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
  443,  259,  260,  261,  262,  263,   -1,  265,   -1,  452,
   -1,   -1,  455,  456,  272,   -1,  274,  275,  276,  277,
  278,   -1,  280,  281,  282,  283,  284,  285,  286,  287,
  288,  289,  290,  291,  292,  293,  294,  295,  296,  297,
  298,  299,  300,  301,  302,  303,  304,  305,  306,  307,
  308,  309,  310,  311,  312,  313,  314,  315,  316,  317,
  318,  319,   -1,  321,  322,  323,  324,  325,  326,  327,
  328,  329,  330,   -1,  332,  333,  334,  335,  336,  337,
  338,  339,  340,  341,  342,  343,  344,  345,  346,  347,
  348,  349,  350,  351,  352,  353,  354,  355,  356,  357,
  358,  359,  360,  361,  362,  363,  364,  365,  366,  367,
  368,  369,  370,  371,  372,  373,  374,  375,  376,  377,
  378,  379,  380,  381,  382,  383,  384,  385,  386,  387,
  388,  389,  390,  391,  392,  393,  394,  395,  396,  397,
  398,  399,  400,  401,  402,  403,  404,  405,  406,  407,
  408,  409,  410,  411,  412,  413,  414,  415,  416,  417,
  418,  419,  420,  421,  422,  423,  424,  425,  426,  427,
  428,  429,  430,  431,  432,  433,  434,  435,  436,  437,
  438,  439,  440,  441,  442,  443,  444,  445,  446,  447,
  448,  449,  450,  451,  452,  453,  454,  455,  456,  457,
  259,  260,  261,  262,  263,   -1,   -1,  266,   -1,   -1,
   -1,   -1,   -1,  272,   -1,  274,  275,  276,  277,  278,
   -1,  280,  281,  282,  283,  284,  285,  286,  287,  288,
  289,  290,  291,  292,  293,  294,  295,  296,  297,  298,
  299,  300,  301,  302,  303,  304,  305,  306,  307,  308,
  309,  310,  311,  312,  313,  314,  315,  316,  317,  318,
  319,   -1,  321,  322,  323,  324,  325,  326,  327,  328,
  329,  330,   -1,  332,  333,  334,  335,  336,  337,  338,
  339,  340,  341,  342,  343,  344,  345,  346,  347,  348,
  349,  350,  351,  352,  353,  354,  355,  356,  357,  358,
  359,  360,  361,  362,  363,  364,  365,  366,  367,  368,
  369,  370,  371,  372,  373,  374,  375,  376,  377,  378,
  379,  380,  381,  382,  383,  384,  385,  386,  387,  388,
  389,  390,  391,  392,  393,  394,  395,  396,  397,  398,
  399,  400,  401,  402,  403,  404,  405,  406,  407,  408,
  409,  410,  411,  412,  413,  414,  415,  416,  417,  418,
  419,  420,  421,  422,  423,  424,  425,  426,  427,  428,
  429,  430,  431,  432,  433,  434,  435,  436,  437,  438,
  439,  440,  441,  442,  443,  444,  445,  446,  447,  448,
  449,  450,  451,  452,  453,  454,  455,  456,  457,  259,
  260,  261,  262,  263,   -1,  265,   -1,   -1,   -1,   -1,
   -1,   -1,  272,   -1,  274,  275,  276,  277,  278,   -1,
  280,  281,  282,  283,  284,  285,  286,  287,  288,  289,
  290,  291,  292,  293,  294,  295,  296,  297,  298,  299,
  300,  301,  302,  303,  304,  305,  306,  307,  308,  309,
  310,  311,  312,  313,  314,  315,  316,  317,  318,  319,
   -1,  321,  322,  323,  324,  325,  326,  327,  328,  329,
  330,   -1,  332,  333,  334,  335,  336,  337,  338,  339,
  340,  341,  342,  343,  344,  345,  346,  347,  348,  349,
  350,  351,  352,  353,  354,  355,  356,  357,  358,  359,
  360,  361,  362,  363,  364,  365,  366,  367,  368,  369,
  370,  371,  372,  373,  374,  375,  376,  377,  378,  379,
  380,  381,  382,  383,  384,  385,  386,  387,  388,  389,
  390,  391,  392,  393,  394,  395,  396,  397,  398,  399,
  400,  401,  402,  403,  404,  405,  406,  407,  408,  409,
  410,  411,  412,  413,  414,  415,  416,  417,  418,  419,
  420,  421,  422,  423,  424,  425,  426,  427,  428,  429,
  430,  431,  432,  433,  434,  435,  436,  437,  438,  439,
  440,  441,  442,  443,  444,  445,  446,  447,  448,  449,
  450,  451,  452,  453,  454,  455,  456,  457,  259,  260,
  261,  262,  263,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,  272,   -1,  274,  275,  276,  277,  278,   -1,  280,
  281,  282,  283,  284,  285,  286,  287,  288,  289,  290,
  291,  292,  293,  294,  295,  296,  297,  298,  299,  300,
  301,  302,  303,  304,  305,  306,  307,  308,  309,  310,
  311,  312,  313,  314,  315,  316,  317,  318,  319,   -1,
  321,  322,  323,  324,  325,  326,  327,  328,  329,  330,
   -1,  332,  333,  334,  335,  336,  337,  338,  339,  340,
  341,  342,  343,  344,  345,  346,  347,  348,  349,  350,
  351,  352,  353,  354,  355,  356,  357,  358,  359,  360,
  361,  362,  363,  364,  365,  366,  367,  368,  369,  370,
  371,  372,  373,  374,  375,  376,  377,  378,  379,  380,
  381,  382,  383,  384,  385,  386,  387,  388,  389,  390,
  391,  392,  393,  394,  395,  396,  397,  398,  399,  400,
  401,  402,  403,  404,  405,  406,  407,  408,  409,  410,
  411,  412,  413,  414,  415,  416,  417,  418,  419,  420,
  421,  422,  423,  424,  425,  426,  427,  428,  429,  430,
  431,  432,  433,  434,  435,  436,  437,  438,  439,  440,
  441,  442,  443,  444,  445,  446,  447,  448,  449,  450,
  451,  452,  453,  454,  455,  456,  457,  259,  260,  261,
  262,  263,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,  273,  274,  275,  276,  277,  278,   -1,  280,  281,
  282,  283,  284,  285,  286,  287,  288,  289,  290,   -1,
  292,  293,  294,  295,  296,  297,  298,  299,  300,  301,
  302,  303,  304,   -1,  306,  307,  308,  309,  310,  311,
  312,  313,   -1,  315,  316,   -1,  318,  319,   -1,  321,
  322,  323,  324,  325,  326,   -1,   -1,  329,  330,   -1,
  332,  333,  334,  335,  336,  337,  338,  339,  340,  341,
   -1,   -1,  344,  345,  346,  347,  348,  349,  350,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,  359,  360,  361,
  362,  363,  364,  365,  366,  367,  368,  369,  370,   -1,
   -1,   -1,  374,  375,  376,  377,  378,  379,  380,  381,
  382,  383,  384,  385,  386,  387,  388,  389,  390,  391,
  392,  393,  394,  395,  396,  397,  398,  399,  400,  401,
  402,  403,  404,  405,  406,  407,  408,  409,  410,  411,
  412,  413,   -1,  415,  416,  417,  418,  419,  420,  421,
  422,  423,  424,  425,  426,  427,  428,  429,  430,  431,
  432,  433,  434,  435,  436,  437,  438,  439,  440,  441,
  442,  443,  444,  445,  446,  447,  448,  449,  450,  451,
  452,  453,  454,  455,  456,  457,  259,  260,  261,  262,
  263,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,  274,  275,  276,  277,  278,   -1,  280,  281,  282,
  283,  284,  285,  286,  287,  288,  289,  290,   -1,  292,
  293,  294,  295,  296,  297,  298,  299,  300,  301,  302,
  303,  304,   -1,  306,  307,  308,  309,  310,  311,  312,
  313,   -1,  315,  316,   -1,  318,  319,   -1,  321,  322,
  323,  324,  325,  326,   -1,   -1,  329,  330,   -1,  332,
  333,  334,  335,  336,  337,  338,  339,  340,  341,   -1,
   -1,  344,  345,  346,  347,  348,  349,  350,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,  359,  360,  361,  362,
  363,  364,  365,  366,  367,  368,  369,  370,   -1,   -1,
   -1,  374,  375,  376,  377,  378,  379,  380,  381,  382,
  383,  384,  385,  386,  387,  388,  389,  390,  391,  392,
  393,  394,  395,  396,  397,  398,  399,  400,  401,  402,
  403,  404,  405,  406,  407,  408,  409,  410,  411,  412,
  413,   -1,  415,  416,  417,  418,  419,  420,  421,  422,
  423,  424,  425,  426,  427,  428,  429,  430,  431,  432,
  433,  434,  435,  436,  437,  438,  439,  440,  441,  442,
  443,  444,  445,  446,  447,  448,  449,  450,  451,  452,
  453,  454,  455,  456,  457,  259,  260,  261,  262,   -1,
  264,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
  274,  275,  276,  277,  278,   -1,  280,  281,  282,  283,
  284,  285,  286,  287,  288,  289,  290,   -1,  292,  293,
  294,  295,  296,  297,  298,  299,  300,  301,  302,  303,
  304,   -1,  306,  307,  308,  309,  310,  311,  312,  313,
   -1,  315,  316,   -1,  318,  319,   -1,  321,  322,  323,
  324,  325,  326,   -1,   -1,  329,  330,   -1,  332,  333,
  334,  335,  336,  337,  338,  339,  340,  341,   -1,   -1,
  344,  345,  346,  347,  348,  349,  350,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,  359,  360,  361,  362,  363,
  364,  365,  366,  367,  368,  369,  370,   -1,   -1,   -1,
  374,  375,  376,  377,  378,  379,  380,  381,  382,  383,
  384,  385,  386,  387,  388,  389,  390,  391,  392,  393,
  394,  395,  396,  397,  398,  399,  400,  401,  402,  403,
  404,  405,  406,  407,  408,  409,  410,  411,  412,  413,
   -1,  415,  416,  417,  418,  419,  420,  421,  422,  423,
  424,  425,  426,  427,  428,  429,  430,  431,  432,  433,
  434,  435,  436,  437,  438,  439,  440,  441,  442,  443,
  444,  445,  446,  447,  448,  449,  450,  451,  452,  453,
  454,  455,  456,  457,  259,  260,  261,  262,  263,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,  274,
  275,  276,  277,  278,   -1,  280,  281,  282,  283,  284,
  285,  286,  287,  288,  289,  290,   -1,  292,  293,  294,
  295,  296,  297,  298,  299,  300,  301,  302,  303,  304,
   -1,  306,  307,  308,  309,  310,  311,  312,  313,   -1,
  315,  316,   -1,  318,  319,   -1,  321,  322,  323,  324,
  325,  326,   -1,   -1,  329,  330,   -1,  332,  333,  334,
  335,  336,  337,  338,  339,  340,  341,   -1,   -1,  344,
  345,  346,  347,  348,  349,  350,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,  359,  360,  361,  362,  363,  364,
  365,  366,  367,  368,  369,  370,   -1,   -1,   -1,  374,
  375,  376,  377,  378,  379,  380,  381,  382,  383,  384,
  385,  386,  387,  388,  389,  390,  391,  392,  393,  394,
  395,  396,  397,  398,  399,  400,  401,  402,  403,  404,
  405,  406,  407,  408,  409,  410,  411,  412,  413,   -1,
  415,  416,  417,  418,  419,  420,  421,  422,  423,  424,
  425,  426,  427,  428,  429,  430,  431,  432,  433,  434,
  435,  436,  437,  438,  439,  440,  441,  442,  443,  444,
  445,  446,  447,  448,  449,  450,  451,  452,  453,  454,
  455,  456,  457,  259,  260,  261,  262,  263,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,  274,  275,
  276,  277,  278,   -1,  280,  281,  282,  283,  284,  285,
  286,  287,  288,  289,  290,   -1,  292,  293,  294,  295,
  296,  297,  298,  299,  300,  301,  302,  303,  304,   -1,
  306,  307,  308,  309,  310,  311,  312,  313,   -1,  315,
  316,   -1,  318,  319,   -1,  321,  322,  323,  324,  325,
  326,   -1,   -1,  329,  330,   -1,  332,  333,  334,  335,
  336,  337,  338,  339,  340,  341,   -1,   -1,  344,  345,
  346,  347,  348,  349,  350,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,  359,  360,  361,  362,  363,  364,  365,
  366,  367,  368,  369,  370,   -1,   -1,   -1,  374,  375,
  376,  377,  378,  379,  380,  381,  382,  383,  384,  385,
  386,  387,  388,  389,  390,  391,  392,  393,  394,  395,
  396,  397,  398,  399,  400,  401,  402,  403,  404,  405,
  406,  407,  408,  409,  410,  411,  412,  413,   -1,  415,
  416,  417,  418,  419,  420,  421,  422,  423,  424,  425,
  426,  427,  428,  429,  430,  431,  432,  433,  434,  435,
  436,  437,  438,  439,  440,  441,  442,  443,  444,  445,
  446,  447,  448,  449,  450,  451,  452,  453,  454,  455,
  456,  457,  259,  260,  261,  262,  263,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,  274,  275,  276,
  277,  278,   -1,  280,  281,  282,  283,  284,  285,  286,
  287,  288,  289,  290,   -1,  292,  293,  294,  295,  296,
  297,  298,  299,  300,  301,  302,  303,  304,   -1,  306,
  307,  308,  309,  310,  311,  312,  313,   -1,  315,  316,
   -1,  318,  319,   -1,  321,  322,  323,  324,  325,  326,
   -1,   -1,  329,  330,   -1,  332,  333,  334,  335,  336,
  337,  338,  339,  340,  341,   -1,   -1,  344,  345,  346,
  347,  348,  349,  350,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,  359,  360,  361,  362,  363,  364,  365,  366,
  367,  368,  369,  370,   -1,   -1,   -1,  374,  375,  376,
  377,  378,  379,  380,  381,  382,  383,  384,  385,  386,
  387,  388,  389,  390,  391,  392,  393,  394,  395,  396,
  397,  398,  399,  400,  401,  402,  403,  404,  405,  406,
  407,  408,  409,  410,  411,  412,  413,   -1,  415,  416,
  417,  418,  419,  420,  421,  422,  423,  424,  425,  426,
  427,  428,  429,  430,  431,  432,  433,  434,  435,  436,
  437,  438,  439,  440,  441,  442,  443,  444,  445,  446,
  447,  448,  449,  450,  451,  452,  453,  454,  455,  456,
  457,  259,  260,  261,  262,  263,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,  274,  275,  276,  277,
  278,   -1,  280,  281,  282,  283,  284,  285,  286,  287,
  288,  289,  290,   -1,  292,  293,  294,  295,  296,  297,
  298,  299,  300,  301,  302,  303,  304,   -1,  306,  307,
  308,  309,  310,  311,  312,  313,   -1,  315,  316,   -1,
  318,  319,   -1,  321,  322,  323,  324,  325,  326,   -1,
   -1,  329,  330,   -1,  332,  333,  334,  335,  336,  337,
  338,  339,  340,  341,   -1,   -1,  344,  345,  346,  347,
  348,  349,  350,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,  359,  360,  361,  362,  363,  364,  365,  366,  367,
  368,  369,  370,   -1,   -1,   -1,  374,  375,  376,  377,
  378,  379,  380,  381,  382,  383,  384,  385,  386,  387,
  388,  389,  390,  391,  392,  393,  394,  395,  396,  397,
  398,  399,  400,  401,  402,  403,  404,  405,  406,  407,
  408,  409,  410,  411,  412,  413,   -1,  415,  416,  417,
  418,  419,  420,  421,  422,  423,  424,  425,  426,  427,
  428,  429,  430,  431,  432,  433,  434,  435,  436,  437,
  438,  439,  440,  441,  442,  443,  444,  445,  446,  447,
  448,  449,  450,  451,  452,  453,  454,  455,  456,  457,
  259,   -1,   -1,  262,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,  274,  275,  276,  277,  278,
   -1,  280,  281,  282,  283,  284,  285,  286,  287,  288,
  289,  290,   -1,  292,  293,  294,  295,  296,  297,  298,
  299,  300,  301,  302,  303,  304,   -1,  306,  307,  308,
  309,  310,  311,  312,  313,   -1,  315,  316,   -1,  318,
  319,   -1,  321,  322,  323,  324,  325,  326,   -1,   -1,
  329,  330,   -1,  332,  333,  334,  335,  336,  337,  338,
  339,  340,  341,   -1,   -1,  344,  345,  346,  347,  348,
  349,  350,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
  359,  360,  361,  362,  363,  364,  365,  366,  367,  368,
  369,  370,   -1,   -1,   -1,  374,  375,  376,  377,  378,
  379,  380,  381,  382,  383,  384,  385,  386,  387,  388,
  389,  390,  391,  392,  393,  394,  395,  396,  397,  398,
  399,  400,  401,  402,  403,  404,  405,  406,  407,  408,
  409,  410,  411,  412,  413,   -1,  415,  416,  417,  418,
  419,  420,  421,  422,  423,  424,  425,  426,  427,  428,
  429,  430,  431,  432,  433,  434,  435,  436,  437,  438,
  439,  440,  441,  442,  443,  444,  445,  446,  447,  448,
  449,  450,  451,  452,  453,  454,  455,  456,  457,  259,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,  274,  275,  276,  277,  278,   -1,
  280,  281,  282,  283,  284,  285,  286,  287,  288,  289,
  290,   -1,  292,  293,  294,  295,  296,  297,  298,  299,
  300,  301,  302,  303,  304,   -1,  306,  307,  308,  309,
  310,  311,  312,  313,   -1,  315,  316,   -1,  318,  319,
   -1,  321,  322,  323,  324,  325,  326,   -1,   -1,  329,
  330,   -1,  332,  333,  334,  335,  336,  337,  338,  339,
  340,  341,   -1,   -1,  344,  345,  346,  347,  348,  349,
  350,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,  359,
  360,  361,  362,  363,  364,  365,  366,  367,  368,  369,
  370,   -1,   -1,   -1,  374,  375,  376,  377,  378,  379,
  380,  381,  382,  383,  384,  385,  386,  387,  388,  389,
  390,  391,  392,  393,  394,  395,  396,  397,  398,  399,
  400,  401,  402,  403,  404,  405,  406,  407,  408,  409,
  410,  411,  412,  413,   -1,  415,  416,  417,  418,  419,
  420,  421,  422,  423,  424,  425,  426,  427,  428,  429,
  430,  431,  432,  433,  434,  435,  436,  437,  438,  439,
  440,  441,  442,  443,  444,  445,  446,  447,  448,  449,
  450,  451,  452,  453,  454,  455,  456,  457,  259,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,  274,  275,  276,  277,  278,   -1,  280,
  281,  282,  283,  284,  285,  286,  287,  288,  289,  290,
   -1,  292,  293,  294,  295,  296,  297,  298,  299,  300,
  301,  302,  303,  304,   -1,  306,  307,  308,  309,  310,
  311,  312,  313,   -1,  315,  316,   -1,  318,  319,   -1,
  321,  322,  323,  324,  325,  326,   -1,   -1,  329,  330,
   -1,  332,  333,  334,  335,  336,  337,  338,  339,  340,
  341,   -1,   -1,  344,  345,  346,  347,  348,  349,  350,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,  359,  360,
  361,  362,  363,  364,  365,  366,  367,  368,  369,  370,
   -1,   -1,   -1,  374,  375,  376,  377,  378,  379,  380,
  381,  382,  383,  384,  385,  386,  387,  388,  389,  390,
  391,  392,  393,  394,  395,  396,  397,  398,  399,  400,
  401,  402,  403,  404,  405,  406,  407,  408,  409,  410,
  411,  412,  413,   -1,  415,  416,  417,  418,  419,  420,
  421,  422,  423,  424,  425,  426,  427,  428,  429,  430,
  431,  432,  433,  434,  435,  436,  437,  438,  439,  440,
  441,  442,  443,  444,  445,  446,  447,  448,  449,  450,
  451,  452,  453,  454,  455,  456,  457,  259,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,  274,  275,   -1,  277,  278,   -1,  280,  281,
  282,  283,  284,  285,  286,  287,  288,  289,  290,   -1,
  292,  293,  294,  295,  296,  297,  298,  299,  300,  301,
  302,  303,  304,   -1,  306,  307,  308,  309,  310,  311,
  312,  313,   -1,  315,  316,   -1,  318,  319,   -1,  321,
  322,  323,  324,  325,  326,   -1,   -1,  329,  330,   -1,
  332,  333,  334,  335,  336,  337,  338,  339,  340,  341,
   -1,   -1,  344,  345,  346,  347,  348,  349,  350,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,  359,  360,  361,
  362,  363,  364,  365,  366,  367,  368,  369,  370,   -1,
   -1,   -1,  374,  375,  376,  377,  378,  379,  380,  381,
  382,  383,  384,  385,  386,  387,  388,  389,  390,  391,
  392,  393,  394,  395,  396,  397,  398,  399,  400,  401,
  402,  403,  404,  405,  406,  407,  408,  409,  410,  411,
  412,  413,   -1,  415,  416,  417,  418,  419,  420,  421,
  422,  423,  424,  425,  426,  427,  428,  429,  430,  431,
  432,  433,  434,  435,  436,  437,  438,  439,  440,  441,
  442,  443,  444,  445,  446,  447,  448,  449,  450,  451,
  452,  453,  454,  455,  456,  457,  274,  275,  276,  277,
  278,   -1,  280,  281,  282,  283,  284,  285,  286,  287,
  288,  289,  290,   -1,  292,  293,  294,  295,  296,  297,
  298,  299,  300,  301,  302,  303,  304,   -1,  306,  307,
  308,  309,  310,  311,  312,  313,   -1,  315,  316,   -1,
  318,  319,   -1,  321,  322,  323,  324,  325,  326,   -1,
   -1,  329,  330,   -1,  332,  333,  334,  335,  336,  337,
  338,  339,  340,  341,   -1,   -1,  344,  345,  346,  347,
  348,  349,  350,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,  359,  360,  361,  362,  363,  364,  365,  366,  367,
  368,  369,  370,   -1,   -1,   -1,  374,  375,  376,  377,
  378,  379,  380,  381,  382,  383,  384,  385,  386,  387,
  388,  389,  390,  391,  392,  393,  394,  395,  396,  397,
  398,  399,  400,  401,  402,  403,  404,  405,  406,  407,
  408,  409,  410,  411,  412,  413,   -1,  415,  416,  417,
  418,  419,  420,  421,  422,  423,  424,  425,  426,  427,
  428,  429,  430,  431,  432,  433,  434,  435,  436,  437,
  438,  439,  440,  441,  442,  443,  444,  445,  446,  447,
  448,  449,  450,  451,  452,  453,  454,  455,  456,  457,
  274,  275,  276,  277,  278,   -1,  280,  281,  282,  283,
  284,  285,  286,  287,  288,  289,  290,   -1,  292,  293,
  294,  295,  296,  297,  298,  299,  300,  301,  302,  303,
  304,   -1,  306,  307,  308,  309,  310,  311,  312,  313,
   -1,  315,  316,   -1,  318,  319,   -1,  321,  322,  323,
  324,  325,  326,   -1,   -1,  329,  330,   -1,  332,  333,
  334,  335,  336,  337,  338,  339,  340,  341,   -1,   -1,
  344,  345,  346,  347,  348,  349,  350,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,  359,  360,  361,  362,  363,
  364,  365,  366,  367,  368,  369,  370,   -1,   -1,   -1,
  374,  375,  376,  377,  378,  379,  380,  381,  382,  383,
  384,  385,  386,  387,  388,  389,  390,  391,  392,  393,
  394,  395,  396,  397,  398,  399,  400,  401,  402,  403,
  404,  405,  406,  407,  408,  409,  410,  411,  412,  413,
   -1,  415,  416,  417,  418,  419,  420,  421,  422,  423,
  424,  425,  426,  427,  428,  429,  430,  431,  432,  433,
  434,  435,  436,  437,  438,  439,  440,  441,  442,  443,
  444,  445,  446,  447,  448,  449,  450,  451,  452,  453,
  454,  455,  456,  457,  274,  275,   -1,  277,  278,   -1,
  280,  281,  282,  283,  284,  285,  286,  287,  288,  289,
  290,   -1,  292,  293,  294,  295,  296,  297,  298,  299,
  300,  301,  302,  303,  304,   -1,  306,  307,  308,  309,
  310,  311,  312,  313,   -1,  315,  316,   -1,  318,  319,
   -1,  321,  322,  323,  324,  325,  326,   -1,   -1,  329,
  330,   -1,  332,  333,  334,  335,  336,  337,  338,  339,
  340,  341,   -1,   -1,  344,  345,  346,  347,  348,  349,
  350,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,  359,
  360,  361,  362,  363,  364,  365,  366,  367,  368,  369,
  370,   -1,   -1,   -1,  374,  375,  376,  377,  378,  379,
  380,  381,  382,  383,  384,  385,  386,  387,  388,  389,
  390,  391,  392,  393,  394,  395,  396,  397,  398,  399,
  400,  401,  402,  403,  404,  405,  406,  407,  408,  409,
  410,  411,  412,  413,   -1,  415,  416,  417,  418,  419,
  420,  421,  422,  423,  424,  425,  426,  427,  428,  429,
  430,  431,  432,  433,  434,  435,  436,  437,  438,  439,
  440,  441,  442,  443,  444,  445,  446,  447,  448,  449,
  450,  451,  452,  453,  454,  455,  456,  457,
};
#define YYFINAL 39
#ifndef YYDEBUG
#define YYDEBUG 0
#endif
#define YYMAXTOKEN 457
#if YYDEBUG
char *yyname[] = {
"end-of-file",0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,"TOK_EOL","TOK_EOF",
"TOK_INTEGER_CONST","TOK_INSTANCE_CONST","TOK_OPAQUE_CONST","TOK_FLOAT_CONST",
"TOK_LPAREN","TOK_RPAREN","TOK_LBRACE","TOK_RBRACE","TOK_LBRACKET",
"TOK_RBRACKET","TOK_HAT","TOK_AMPERSAND","TOK_TILDE","TOK_START_DISJUNCTION",
"TOK_END_DISJUNCTION","TOK_PLUS","TOK_MINUS","TOK_TIMES","TOK_DIVIDE",
"TOK_MODULUS","UMINUS","TOK_ACCEPT","TOK_ACCEPT_ATOM","TOK_ACCEPTLINE_COMPOUND",
"TOK_ACCEPTS","TOK_ACTIVATES","TOK_ADDSTATE","TOK_AFTER","TOK_ALIAS_FOR",
"TOK_AND","TOK_ANY","TOK_APPEND","TOK_APPROX_EQUAL","TOK_ARROW","TOK_ASCID",
"TOK_ASCIZ","TOK_AT","TOK_ATOM","TOK_BIND","TOK_BLOCK_NAME","TOK_BY","TOK_BYTE",
"TOK_CATCH","TOK_CALL_INHERITED","TOK_CLOSEFILE","TOK_COMPOUND","TOK_CONTAINS",
"TOK_CONCAT","TOK_COPY","TOK_CRLF","TOK_CS","TOK_CTRLC","TOK_DECLARATION_BLOCK",
"TOK_DEBUG","TOK_DEFAULT","TOK_DIFF_TYPE","TOK_DISABLE","TOK_DO",
"TOK_DOES_NOT_CONTAIN","TOK_DOLLAR_LAST","TOK_DOUBLE_FLOAT","TOK_EBREAK",
"TOK_EB","TOK_ELSE","TOK_ENABLE","TOK_END_BLOCK","TOK_END_GROUP",
"TOK_ENTRY_BLOCK","TOK_EQUAL","TOK_EQUAL_EQUAL","TOK_EVERY","TOK_EXCISE",
"TOK_EXIT","TOK_EXTERNAL_ROUTINE","TOK_FAILURE","TOK_FILENAME","TOK_FILL",
"TOK_FLOAT","TOK_FOR_EACH","TOK_GENATOM","TOK_GENERIC_METHOD","TOK_GENINT",
"TOK_GET","TOK_GREATER","TOK_GREATER_EQUAL","TOK_IF","TOK_IN",
"TOK_INHERITS_FROM","TOK_INSTANCE","TOK_INTEGER","TOK_IS_OPEN","TOK_LENGTH",
"TOK_LENGTH_EQUAL","TOK_LENGTH_GREATER","TOK_LENGTH_GREATER_EQUAL",
"TOK_LENGTH_LESS","TOK_LENGTH_LESS_EQUAL","TOK_LENGTH_NOT_EQUAL","TOK_LESS",
"TOK_LESS_EQUAL","TOK_LEX","TOK_LONG","TOK_MAKE","TOK_MAX","TOK_MATCHES",
"TOK_MEA","TOK_METHOD","TOK_MIN","TOK_MODIFY","TOK_NEXT","TOK_NTH","TOK_NOT",
"TOK_NOT_APPROX_EQUAL","TOK_NOT_EQ","TOK_NOT_EQUAL","TOK_ON_EMPTY",
"TOK_ON_ENTRY","TOK_ON_EVERY","TOK_ON_EXIT","TOK_OBJECT_CLASS","TOK_OF",
"TOK_OFF","TOK_ON","TOK_OPAQUE","TOK_OPENFILE","TOK_OR","TOK_OUT","TOK_P",
"TOK_PATHNAME","TOK_RBREAK","TOK_POINTER","TOK_POSITION","TOK_PPCLASS",
"TOK_PPWM","TOK_PROMPT","TOK_READ_ONLY","TOK_READ_WRITE","TOK_QUIT",
"TOK_QUOTED_SYMBOL","TOK_QUOTED_VAR","TOK_RESTART","TOK_REFERENCE","TOK_REMOVE",
"TOK_REMOVE_EVERY","TOK_REPORT","TOK_RG","TOK_RUN","TOK_RESTORESTATE",
"TOK_RETURN","TOK_RETURNS","TOK_RJUST","TOK_RULE","TOK_RULE_BLOCK",
"TOK_RULE_GROUP","TOK_SAVESTATE","TOK_SAME_TYPE","TOK_SCALAR","TOK_SHORT",
"TOK_SHOW","TOK_SINGLE_FLOAT","TOK_SPACE","TOK_SPECIALIZE","TOK_SQL_ATTACH",
"TOK_SQL_COMMIT","TOK_SQL_DELETE","TOK_SQL_DETACH","TOK_SQL_FETCH_AS_OBJECT",
"TOK_SQL_FETCH_EACH","TOK_SQL_INSERT","TOK_SQL_INSERT_FROM_OBJECT",
"TOK_SQL_ROLLBACK","TOK_SQL_START","TOK_SQL_UPDATE",
"TOK_SQL_UPDATE_FROM_OBJECT","TOK_STARTUP","TOK_STRATEGY","TOK_SUBCOMPOUND",
"TOK_SUBSYMBOL","TOK_SUCCESS","TOK_SYMBOL","TOK_SYMBOL_CONST",
"TOK_SYMBOL_LENGTH","TOK_TABTO","TOK_THEN","TOK_TRACE","TOK_UNSIGNED_BYTE",
"TOK_UNSIGNED_LONG","TOK_UNSIGNED_SHORT","TOK_USES","TOK_VALUE","TOK_VARIABLE",
"TOK_VERSION","TOK_WARNING","TOK_WBREAK","TOK_WHEN","TOK_WHILE","TOK_WM",
"TOK_WMHISTORY","TOK_WRITE",
};
char *yyrule[] = {
"$accept : command_line",
"command_line : command TOK_EOL",
"command_line : error TOK_EOL",
"command_line : TOK_LPAREN command TOK_RPAREN",
"command_line : TOK_LPAREN error TOK_RPAREN",
"command_line : TOK_EOL",
"command : at_cmd",
"command : addstate_cmd",
"command : after_cmd",
"command : closefile_cmd",
"command : copy_cmd",
"command : cs_cmd",
"command : default_cmd",
"command : disable_cmd",
"command : ebreak_cmd",
"command : enable_cmd",
"command : exit_cmd",
"command : make_cmd",
"command : matches_cmd",
"command : modify_cmd",
"command : next_cmd",
"command : openfile_cmd",
"command : rbreak_cmd",
"command : ppclass_cmd",
"command : ppwm_cmd",
"command : prompt_cmd",
"command : quit_cmd",
"command : remove_cmd",
"command : remove_every_cmd",
"command : restorestate_cmd",
"command : return_cmd",
"command : run_cmd",
"command : savestate_cmd",
"command : show_cmd",
"command : specialize_cmd",
"command : trace_cmd",
"command : wbreak_cmd",
"command : wm_cmd",
"command : wmhistory_cmd",
"$$1 :",
"at_cmd : TOK_AT $$1 symbol",
"$$2 :",
"addstate_cmd : TOK_ADDSTATE $$2 symbol",
"$$3 :",
"after_cmd : TOK_AFTER $$3 after_params",
"after_params : int_atom symbol",
"after_params : error",
"$$4 :",
"closefile_cmd : TOK_CLOSEFILE $$4 closefile_ids",
"closefile_ids : symbol",
"closefile_ids : closefile_ids symbol",
"copy_cmd : copy_start attr_name_value_list",
"$$5 :",
"copy_start : TOK_COPY $$5 wmo_id",
"cs_cmd : TOK_CS",
"$$6 :",
"default_cmd : TOK_DEFAULT $$6 symbol default_keyword",
"default_keyword : TOK_ACCEPT",
"default_keyword : TOK_TRACE",
"default_keyword : TOK_WRITE",
"default_keyword : error",
"$$7 :",
"disable_cmd : TOK_DISABLE $$7 disable_keyword",
"disable_keyword : TOK_WARNING",
"disable_keyword : TOK_WMHISTORY",
"disable_keyword : TOK_BLOCK_NAME",
"disable_keyword : TOK_CTRLC",
"disable_keyword : error",
"$$8 :",
"ebreak_cmd : TOK_EBREAK $$8 ebreak_what",
"$$9 :",
"ebreak_cmd : TOK_EB $$9 ebreak_what",
"ebreak_what :",
"ebreak_what : ebreak_change",
"ebreak_change : TOK_ON eb_on_par",
"ebreak_change : TOK_OFF eb_off_par",
"eb_on_par : TOK_TIMES",
"eb_on_par : ebreak_on_params",
"ebreak_on_params : eb_name",
"ebreak_on_params : ebreak_on_params eb_name",
"eb_off_par : TOK_TIMES",
"eb_off_par : ebreak_off_params",
"ebreak_off_params : eb_name",
"ebreak_off_params : ebreak_off_params eb_name",
"ebreak_off_params : integer_const",
"ebreak_off_params : ebreak_off_params integer_const",
"eb_name : name",
"$$10 :",
"enable_cmd : TOK_ENABLE $$10 enable_keyword",
"enable_keyword : TOK_WARNING",
"enable_keyword : TOK_WMHISTORY",
"enable_keyword : TOK_BLOCK_NAME",
"enable_keyword : TOK_CTRLC",
"enable_keyword : error",
"exit_cmd : TOK_EXIT",
"exit_cmd : TOK_EOF",
"make_cmd : make_start attr_name_value_list",
"$$11 :",
"make_start : TOK_MAKE $$11 object_class",
"$$12 :",
"matches_cmd : TOK_MATCHES $$12 matches_rules",
"matches_rules : rule_name",
"matches_rules : matches_rules rule_name",
"modify_cmd : modify_start attr_name_value_list",
"$$13 :",
"modify_start : TOK_MODIFY $$13 wmo_id",
"next_cmd : TOK_NEXT",
"$$14 :",
"openfile_cmd : TOK_OPENFILE $$14 symbol symbol openfile_keyword",
"openfile_keyword :",
"openfile_keyword : TOK_IN",
"openfile_keyword : TOK_OUT",
"openfile_keyword : TOK_APPEND",
"openfile_keyword : error",
"$$15 :",
"rbreak_cmd : TOK_RBREAK $$15 rbreak_what",
"rbreak_what :",
"rbreak_what : rbreak_change",
"rbreak_change : TOK_ON rbreak_on_params",
"rbreak_change : TOK_OFF rb_off_par",
"rbreak_on_params : rule_name",
"rbreak_on_params : rbreak_on_params rule_name",
"rb_off_par : TOK_TIMES",
"rb_off_par : rbreak_off_params",
"rbreak_off_params : rule_name",
"rbreak_off_params : rbreak_off_params rule_name",
"rbreak_off_params : integer_const",
"rbreak_off_params : rbreak_off_params integer_const",
"$$16 :",
"ppclass_cmd : TOK_PPCLASS $$16 ppclass_class",
"ppclass_class :",
"ppclass_class : object_class",
"$$17 :",
"ppwm_cmd : TOK_PPWM $$17 ppwm_show",
"ppwm_show :",
"ppwm_show : form",
"$$18 :",
"prompt_cmd : TOK_PROMPT $$18 symbol",
"$$19 :",
"quit_cmd : TOK_QUIT $$19 opt_ret_value",
"opt_ret_value :",
"opt_ret_value : TOK_SUCCESS",
"opt_ret_value : TOK_FAILURE",
"opt_ret_value : integer_const",
"$$20 :",
"remove_cmd : TOK_REMOVE $$20 rem_wmos",
"rem_wmos :",
"rem_wmos : TOK_TIMES",
"rem_wmos : rem_wmos wmo_id",
"rem_wmos : error",
"$$21 :",
"remove_every_cmd : TOK_REMOVE_EVERY $$21 object_class",
"$$22 :",
"restorestate_cmd : TOK_RESTORESTATE $$22 symbol",
"$$23 :",
"return_cmd : TOK_RETURN $$23 return_value",
"return_value :",
"return_value : molecule",
"$$24 :",
"run_cmd : TOK_RUN $$24 run_cnt",
"run_cnt :",
"run_cnt : integer_const",
"run_cnt : symbol_string",
"run_cnt : quoted_string",
"run_cnt : flt_atom",
"$$25 :",
"savestate_cmd : TOK_SAVESTATE $$25 symbol",
"$$26 :",
"show_cmd : TOK_SHOW $$26 show_param",
"show_param : TOK_VERSION",
"specialize_cmd : specialize_start attr_name_value_list",
"$$27 :",
"specialize_start : TOK_SPECIALIZE $$27 wmo_id object_class",
"$$28 :",
"trace_cmd : TOK_TRACE $$28 trace_what",
"trace_what :",
"trace_what : trace_change",
"trace_change : TOK_ON trace_params",
"trace_change : TOK_OFF trace_params",
"trace_params : TOK_TIMES",
"trace_params : trace_param_list",
"trace_param_list : trace_param",
"trace_param_list : trace_param_list trace_param",
"trace_param : TOK_ENTRY_BLOCK",
"trace_param : TOK_EB",
"trace_param : TOK_RULE_GROUP",
"trace_param : TOK_RG",
"trace_param : TOK_RULE",
"trace_param : TOK_WM",
"trace_param : TOK_CS",
"$$29 :",
"wbreak_cmd : TOK_WBREAK $$29 wbreak_what",
"wbreak_what :",
"wbreak_what : wbreak_change",
"wbreak_change : TOK_ON wbreak_on_params",
"wbreak_change : TOK_OFF wb_off_par",
"wbreak_on_params : form",
"wb_off_par : TOK_TIMES",
"wb_off_par : wbreak_off_params",
"wbreak_off_params : form",
"wbreak_off_params : integer_const",
"wbreak_off_params : wbreak_off_params integer_const",
"attr_name : name",
"$$30 :",
"wm_cmd : TOK_WM $$30 wm_show_what",
"wm_show_what :",
"wm_show_what : wm_show_wmos",
"wm_show_wmos : wmo_id",
"wm_show_wmos : wm_show_wmos wmo_id",
"$$31 :",
"wmhistory_cmd : TOK_WMHISTORY $$31 wmh_wmo wmh_attr",
"wmh_wmo : wmo_id",
"wmh_attr :",
"wmh_attr : TOK_HAT attr_name",
"attr_name_value_list :",
"attr_name_value_list : attr_name_value_list attr_name_value",
"attr_name_value : TOK_HAT attr_name attr_index attr_value",
"attr_name_value : error",
"object_class : name TOK_TILDE name",
"object_class : name",
"object_class : error",
"attr_value : molecule",
"$$32 :",
"form : TOK_LPAREN object_class $$32 opt_lhs_terms TOK_RPAREN",
"$$33 :",
"form : object_class $$33 opt_lhs_terms",
"opt_lhs_terms :",
"opt_lhs_terms : opt_lhs_terms lhs_term",
"lhs_term : ce_attr lhs_value",
"ce_attr : TOK_HAT attr_name attr_index",
"ce_attr : error",
"attr_index :",
"attr_index : TOK_LBRACKET ca_index TOK_RBRACKET",
"attr_index : error",
"ca_index : integer_const",
"ca_index : TOK_DOLLAR_LAST",
"lhs_value : restriction",
"$$34 :",
"lhs_value : TOK_LBRACE $$34 restriction_list TOK_RBRACE",
"restriction_list : restriction_list restriction",
"restriction_list : restriction",
"$$35 :",
"restriction : TOK_START_DISJUNCTION $$35 pat_val_list TOK_END_DISJUNCTION",
"restriction : predicate value",
"restriction : value",
"pat_val_list : value",
"pat_val_list : pat_val_list value",
"predicate : single_predicate",
"predicate : content_predicate",
"single_predicate : TOK_APPROX_EQUAL",
"single_predicate : TOK_NOT_APPROX_EQUAL",
"single_predicate : TOK_EQUAL",
"single_predicate : TOK_EQUAL_EQUAL",
"single_predicate : TOK_GREATER",
"single_predicate : TOK_GREATER_EQUAL",
"single_predicate : TOK_LESS",
"single_predicate : TOK_LESS_EQUAL",
"single_predicate : TOK_NOT_EQ",
"single_predicate : TOK_NOT_EQUAL",
"single_predicate : TOK_SAME_TYPE",
"single_predicate : TOK_DIFF_TYPE",
"content_predicate : TOK_LENGTH_LESS_EQUAL",
"content_predicate : TOK_LENGTH_EQUAL",
"content_predicate : TOK_LENGTH_NOT_EQUAL",
"content_predicate : TOK_LENGTH_LESS",
"content_predicate : TOK_LENGTH_GREATER_EQUAL",
"content_predicate : TOK_LENGTH_GREATER",
"content_predicate : TOK_CONTAINS",
"content_predicate : TOK_DOES_NOT_CONTAIN",
"content_predicate : TOK_CONTAINS single_predicate",
"content_predicate : TOK_DOES_NOT_CONTAIN single_predicate",
"content_predicate : single_predicate TOK_CONTAINS",
"content_predicate : single_predicate TOK_DOES_NOT_CONTAIN",
"value : constant",
"constant : int_atom",
"constant : flt_atom",
"constant : wmo_id",
"constant : opaque_atom",
"constant : symbol",
"constant : compound_constant",
"symbol : symbol_string",
"symbol : quoted_string",
"rule_name : name",
"rule_name : name TOK_TILDE name",
"name : most_toks",
"name : quoted_string",
"molecule : scalar_constant",
"molecule : compound_constant",
"quoted_string : TOK_QUOTED_SYMBOL",
"symbol_string : TOK_TIMES",
"symbol_string : most_toks",
"most_toks : TOK_AT",
"most_toks : TOK_ACCEPT",
"most_toks : TOK_ACCEPT_ATOM",
"most_toks : TOK_ACCEPTLINE_COMPOUND",
"most_toks : TOK_ACCEPTS",
"most_toks : TOK_ACTIVATES",
"most_toks : TOK_ADDSTATE",
"most_toks : TOK_AFTER",
"most_toks : TOK_ALIAS_FOR",
"most_toks : TOK_AND",
"most_toks : TOK_ANY",
"most_toks : TOK_APPEND",
"most_toks : TOK_ARROW",
"most_toks : TOK_ASCID",
"most_toks : TOK_ASCIZ",
"most_toks : TOK_ATOM",
"most_toks : TOK_BIND",
"most_toks : TOK_BLOCK_NAME",
"most_toks : TOK_BY",
"most_toks : TOK_BYTE",
"most_toks : TOK_CATCH",
"most_toks : TOK_CALL_INHERITED",
"most_toks : TOK_CLOSEFILE",
"most_toks : TOK_COMPOUND",
"most_toks : TOK_CONCAT",
"most_toks : TOK_COPY",
"most_toks : TOK_CRLF",
"most_toks : TOK_CS",
"most_toks : TOK_CTRLC",
"most_toks : TOK_DECLARATION_BLOCK",
"most_toks : TOK_DEBUG",
"most_toks : TOK_DEFAULT",
"most_toks : TOK_DISABLE",
"most_toks : TOK_DIVIDE",
"most_toks : TOK_DO",
"most_toks : TOK_DOLLAR_LAST",
"most_toks : TOK_DOUBLE_FLOAT",
"most_toks : TOK_EB",
"most_toks : TOK_ELSE",
"most_toks : TOK_ENABLE",
"most_toks : TOK_END_BLOCK",
"most_toks : TOK_END_GROUP",
"most_toks : TOK_ENTRY_BLOCK",
"most_toks : TOK_EVERY",
"most_toks : TOK_EXCISE",
"most_toks : TOK_EXTERNAL_ROUTINE",
"most_toks : TOK_FAILURE",
"most_toks : TOK_FILENAME",
"most_toks : TOK_FILL",
"most_toks : TOK_FLOAT",
"most_toks : TOK_FOR_EACH",
"most_toks : TOK_GENATOM",
"most_toks : TOK_GENERIC_METHOD",
"most_toks : TOK_GENINT",
"most_toks : TOK_GET",
"most_toks : TOK_IF",
"most_toks : TOK_IN",
"most_toks : TOK_INHERITS_FROM",
"most_toks : TOK_INSTANCE",
"most_toks : TOK_INTEGER",
"most_toks : TOK_IS_OPEN",
"most_toks : TOK_LENGTH",
"most_toks : TOK_LEX",
"most_toks : TOK_LONG",
"most_toks : TOK_MAKE",
"most_toks : TOK_MATCHES",
"most_toks : TOK_MAX",
"most_toks : TOK_MEA",
"most_toks : TOK_METHOD",
"most_toks : TOK_MIN",
"most_toks : TOK_MINUS",
"most_toks : TOK_MODIFY",
"most_toks : TOK_MODULUS",
"most_toks : TOK_NEXT",
"most_toks : TOK_NOT",
"most_toks : TOK_NTH",
"most_toks : TOK_OBJECT_CLASS",
"most_toks : TOK_OF",
"most_toks : TOK_OFF",
"most_toks : TOK_ON",
"most_toks : TOK_ON_EMPTY",
"most_toks : TOK_ON_ENTRY",
"most_toks : TOK_ON_EVERY",
"most_toks : TOK_ON_EXIT",
"most_toks : TOK_OPAQUE",
"most_toks : TOK_OPENFILE",
"most_toks : TOK_OR",
"most_toks : TOK_OUT",
"most_toks : TOK_P",
"most_toks : TOK_PATHNAME",
"most_toks : TOK_RBREAK",
"most_toks : TOK_PLUS",
"most_toks : TOK_POINTER",
"most_toks : TOK_POSITION",
"most_toks : TOK_PPCLASS",
"most_toks : TOK_PPWM",
"most_toks : TOK_PROMPT",
"most_toks : TOK_QUIT",
"most_toks : TOK_QUOTED_VAR",
"most_toks : TOK_READ_ONLY",
"most_toks : TOK_READ_WRITE",
"most_toks : TOK_REFERENCE",
"most_toks : TOK_REMOVE",
"most_toks : TOK_REMOVE_EVERY",
"most_toks : TOK_REPORT",
"most_toks : TOK_RESTART",
"most_toks : TOK_RESTORESTATE",
"most_toks : TOK_RETURN",
"most_toks : TOK_RETURNS",
"most_toks : TOK_RG",
"most_toks : TOK_RJUST",
"most_toks : TOK_RULE",
"most_toks : TOK_RULE_BLOCK",
"most_toks : TOK_RULE_GROUP",
"most_toks : TOK_RUN",
"most_toks : TOK_SAVESTATE",
"most_toks : TOK_SCALAR",
"most_toks : TOK_SHORT",
"most_toks : TOK_SHOW",
"most_toks : TOK_SINGLE_FLOAT",
"most_toks : TOK_SPACE",
"most_toks : TOK_SPECIALIZE",
"most_toks : TOK_SQL_ATTACH",
"most_toks : TOK_SQL_COMMIT",
"most_toks : TOK_SQL_DELETE",
"most_toks : TOK_SQL_DETACH",
"most_toks : TOK_SQL_FETCH_AS_OBJECT",
"most_toks : TOK_SQL_FETCH_EACH",
"most_toks : TOK_SQL_INSERT",
"most_toks : TOK_SQL_INSERT_FROM_OBJECT",
"most_toks : TOK_SQL_ROLLBACK",
"most_toks : TOK_SQL_START",
"most_toks : TOK_SQL_UPDATE",
"most_toks : TOK_SQL_UPDATE_FROM_OBJECT",
"most_toks : TOK_STARTUP",
"most_toks : TOK_STRATEGY",
"most_toks : TOK_SUBSYMBOL",
"most_toks : TOK_SUBCOMPOUND",
"most_toks : TOK_SUCCESS",
"most_toks : TOK_SYMBOL",
"most_toks : TOK_SYMBOL_CONST",
"most_toks : TOK_SYMBOL_LENGTH",
"most_toks : TOK_TABTO",
"most_toks : TOK_THEN",
"most_toks : TOK_TRACE",
"most_toks : TOK_UNSIGNED_BYTE",
"most_toks : TOK_UNSIGNED_LONG",
"most_toks : TOK_UNSIGNED_SHORT",
"most_toks : TOK_USES",
"most_toks : TOK_VALUE",
"most_toks : TOK_VARIABLE",
"most_toks : TOK_VERSION",
"most_toks : TOK_WARNING",
"most_toks : TOK_WBREAK",
"most_toks : TOK_WHILE",
"most_toks : TOK_WHEN",
"most_toks : TOK_WM",
"most_toks : TOK_WMHISTORY",
"most_toks : TOK_WRITE",
"int_atom : integer_const",
"integer_const : TOK_INTEGER_CONST",
"flt_atom : float_const",
"float_const : TOK_FLOAT_CONST",
"opaque_atom : TOK_OPAQUE_CONST",
"compound_constant : TOK_LPAREN TOK_COMPOUND constants TOK_RPAREN",
"constants :",
"constants : constants scalar_constant",
"scalar_constant : symbol_string",
"scalar_constant : quoted_string",
"scalar_constant : wmo_id",
"scalar_constant : int_atom",
"scalar_constant : flt_atom",
"scalar_constant : opaque_atom",
"wmo_id : TOK_INSTANCE_CONST",
};
#endif
#ifdef YYSTACKSIZE
#undef YYMAXDEPTH
#define YYMAXDEPTH YYSTACKSIZE
#else
#ifdef YYMAXDEPTH
#define YYSTACKSIZE YYMAXDEPTH
#else
#define YYSTACKSIZE 500
#define YYMAXDEPTH 500
#endif
#endif
int yydebug;
int yynerrs;
int yyerrflag;
int yychar;
short *yyssp;
YYSTYPE *yyvsp;
YYSTYPE yyval;
YYSTYPE yylval;
short yyss[YYSTACKSIZE];
YYSTYPE yyvs[YYSTACKSIZE];
#define yystacksize YYSTACKSIZE
#line 2049 "../source/cmd_pars.y"


/****************************************************************************/
/* C CODE SECTION							    */

static void       cmd_at (void)
{
   tmpios = rul__ios_open_file (p1, p1, IOS__E_IN);
   if (tmpios != NULL) {
      rul__scan_switch_file (tmpios);
   }
}

static void       cmd_addstate (void)
{
   rul__dbg_addstate ((Molecule) p1);
}

static void       cmd_after (void)
{
   rul__dbg_set_catcher (p1, p2);
}

static void       cmd_closefile (void)
{
   Param_List p = pl;

   while (p) {
      rul__ios_close_file ((Molecule) pl->data);
      p = p->next;
   }
   rul__dbg_free_param_list (pl);
   pl = NULL;
}

static void       cmd_copy (void)
{
   ebdata = rul__dbg_get_ebdata ();
   cur_wmo = rul__wm_copy (cur_wmo, ebdata);
   if (cur_wmo) {
      for (j = DECL_FIRST_USER_ATTR_OFFSET; j < result_len; j++){
	 if (result[j] != NULL)
	   rul__wm_set_offset_val(cur_wmo, j, result[j], ebdata);
      }
      rul__wm_update_and_notify (cur_wmo, ebdata);
      rul__dbg_flag_changes ();
   }
}

static void       cmd_cs (void)
{
   rul__dbg_print_cs ();
}

static void       cmd_default (void)
{
   rul__ios_set_default (p1, (IO_Catagory) p2);
}

static void       cmd_disable (void)
{
   if (p1 == (void *) TOK_WARNING) {
      rul__msg_disable_messages ();
   }
   else if (p1 == (void *) TOK_WMHISTORY) {
      rul__wm_for_each_object_in_wm (rul__wm_free_wmh_data);
      rul__dbg_gl_enable &= ~DBG_M_ENABLE_WMH;
   }
   else if (p1 == (void *) TOK_BLOCK_NAME) {
      rul__dbg_gl_enable &= ~DBG_M_ENABLE_BKN;
   }
   else if (p1 == (void *) TOK_CTRLC) {
      rul__dbg_disable_control_c ();
   }
}

static void       cmd_ebreak (void)
{
   if (pl == (void *) -1)
     rul__dbg_show_ebreaks ();
   else {
      rul__dbg_ebreak (on_flag, pl);
      rul__dbg_free_param_list (pl);
      pl = NULL;
   }
}

static void       cmd_enable (void)
{
   if (p1 == (void *) TOK_WARNING) {
      rul__msg_enable_messages ();
   }
   else if (p1 == (void *) TOK_WMHISTORY) {
      rul__dbg_gl_enable |= DBG_M_ENABLE_WMH;
   }
   else if (p1 == (void *) TOK_BLOCK_NAME) {
      rul__dbg_gl_enable |= DBG_M_ENABLE_BKN;
   }
   else if (p1 == (void *) TOK_CTRLC) {
      rul__dbg_enable_control_y ();
   }
}

static void       cmd_exit (void)
{
   if (p1 == (void *) -1) {
      if (rul__scan_switch_file (0)) {
	 rul__scan_reset_parens ();
	 return;
      }
   }
   rul__dbg_set_exit (EXIT_SUCCESS); 
}

static void       cmd_make (void)
{
   cur_wid = result[DECL_ID_ATTR_OFFSET];
   if (cur_wid != NULL) {
      if (!rul__is_wid_translation_on ()) {
	 rul__msg_print (CLI_INVMAKID);
	 cur_wid = NULL;
	 return;
      }
      else {
	 if (rul__mol_instance_id_value (cur_wid)) {
	    rul__msg_print (CLI_INVMAKTID);
	    return;
	 }
      }
   }
   ebdata = rul__dbg_get_ebdata ();
   cur_wmo = rul__wm_create (cur_cls, cur_wid, ebdata);
   if (cur_wmo) {
      for (j = DECL_FIRST_USER_ATTR_OFFSET; j < result_len; j++){
	 if (result[j] != NULL)
	   rul__wm_set_offset_val (cur_wmo, j, result[j], ebdata);
      }
      rul__wm_update_and_notify (cur_wmo, ebdata);
      rul__dbg_flag_changes ();
   }
}

static void       cmd_matches (void)
{
   rul__dbg_show_matches (pl);
}

static void       cmd_modify (void)
{
   if (cur_wmo) {
      ebdata = rul__dbg_get_ebdata ();
      rul__wm_modify (cur_wmo, ebdata);
      for (j = DECL_FIRST_USER_ATTR_OFFSET; j < result_len; j++){
	 if (result[j] != NULL)
	   rul__wm_set_offset_val (cur_wmo, j, result[j], ebdata);
      }
      rul__wm_update_and_notify (cur_wmo, ebdata);
      rul__dbg_flag_changes ();
   }
}

static void       cmd_next (void)
{
   rul__dbg_show_next ();
}

static void       cmd_openfile (void)
{
   rul__ios_open_file (p1, p2, (IO_Access_Mode) p3);
}

static void       cmd_ppclass (void)
{
   if (cur_cls == NULL)
     rul__dbg_print_class_list ();
   else
     rul__decl_print_class_info (cur_cls, RUL__C_STD_ERR);
}

static void       cmd_ppwm (void)
{
   Pat_Pattern *pat = NULL;

   if (pl)
     rul__dbg_set_pp_pat ((Pat_Pattern *) pl->data);
   rul__wm_for_each_object_in_wm (rul__dbg_pp_print);
   rul__dbg_free_param_list (pl);
   pl = NULL;
   rul__dbg_set_pp_pat (NULL);
}

static void       cmd_prompt (void)
{
   rul__dbg_set_prompt ((Molecule) p1);
}

static void       cmd_quit (void)
{
   rul__dbg_set_exit ((long) p1);
}

static void       cmd_rbreak (void)
{
   if (pl == (void *) -1)
     rul__dbg_show_rbreaks ();
   else {
      rul__dbg_rbreak (on_flag, pl);
      rul__dbg_free_param_list (pl);
      pl = NULL;
   }
}

static void       cmd_remove (void)
{
   Param_List p = pl;
   
   if (pl == NULL) {
      rul__wm_destroy_and_notify_all (0, rul__dbg_get_ebdata ());
   }
   else {
      while (p) {
	 cur_wmo = rul__mol_instance_id_value ((Molecule) p->data);
	 if (cur_wmo == NULL)
	   rul__msg_print (CLI_INVWMO, cur_int, "REMOVE");
	 else {
	    rul__wm_destroy_and_notify (cur_wmo, rul__dbg_get_ebdata ());
	 }
	 p = p->next;
      }
   }
   rul__dbg_flag_changes ();
   rul__dbg_free_param_list (pl);
   pl = NULL;
}

static void       cmd_remove_every (void)
{
   rul__dbg_remove_class_wmes (cur_cls);
   rul__dbg_flag_changes ();
}

static void       cmd_restorestate (void)
{
   rul__dbg_restorestate (p1);
}

static void       cmd_return (void)
{
   rul__dbg_set_return ((Molecule) p1);
}

static void       cmd_run (void)
{
   rul__dbg_set_run ((long) p1);
}

static void       cmd_savestate (void)
{
   rul__dbg_savestate ((Molecule) p1);
}

static void       cmd_show (void)
{
   rul__msg_version (RUL__C_STD_ERR);
}

static void       cmd_specialize (void)
{
   ebdata = rul__dbg_get_ebdata ();
   cur_wmo = rul__wm_specialize (cur_wmo, cur_cls, ebdata);
   if (cur_wmo) {
      for (j = DECL_FIRST_USER_ATTR_OFFSET; j < result_len; j++){
	 if (result[j] != NULL)
	   rul__wm_set_offset_val (cur_wmo, j, result[j], ebdata);
      }
      rul__wm_update_and_notify (cur_wmo, ebdata);
      rul__dbg_flag_changes ();
   }
}

static void       cmd_trace (void)
{
   if (p1 == (void *) -1) {
      if (rul__dbg_gl_trace & DBG_M_TRACE_ALL) {
	 rul__ios_printf (RUL__C_STD_ERR, "   TRACEs set on: ");
	 if (rul__dbg_gl_trace & DBG_M_TRACE_EB)
	   rul__ios_printf (RUL__C_STD_ERR, " ENTRY-BLOCK");
	 if (rul__dbg_gl_trace & DBG_M_TRACE_RG)
	   rul__ios_printf (RUL__C_STD_ERR, " RULE-GROUP");
	 if (rul__dbg_gl_trace & DBG_M_TRACE_R)
	   rul__ios_printf (RUL__C_STD_ERR, " RULE");
	 if (rul__dbg_gl_trace & DBG_M_TRACE_WM)
	   rul__ios_printf (RUL__C_STD_ERR, " WM");
	 if (rul__dbg_gl_trace & DBG_M_TRACE_CS)
	   rul__ios_printf (RUL__C_STD_ERR, " CS");
      }
      else
	rul__ios_printf (RUL__C_STD_ERR, "   No TRACEs set");
      rul__ios_printf (RUL__C_STD_ERR, "\n"); 
   }
   else {
      if (on_flag) {
	 rul__dbg_gl_trace |= (long) p1;
	 if (rul__dbg_gl_trace & DBG_M_TRACE_RG)
	   rul__dbg_set_group ();
      }
      else {
	 rul__dbg_gl_trace &= ~((long) p1);
      }
   }
}

static void       cmd_wbreak (void)
{
   if (pl == (void *) -1)
     rul__dbg_show_wbreaks ();
   else {
      rul__dbg_wbreak (on_flag, pl);
      rul__dbg_free_param_list (pl);
      pl = NULL;
   }
   pat_pat = NULL;
}

static void       cmd_wm (void)
{
   Param_List p = pl;

   if (pl == NULL) {
      rul__wm_for_each_object_in_wm (rul__dbg_print); 
   }
   else {
      while (p) {
	 cur_wmo = rul__mol_instance_id_value ((Molecule) p->data);
	 if (cur_wmo == NULL)
	   rul__msg_print_w_atoms (CLI_NOSUCHWMO, 1, (Molecule) p->data);
	 else
	   rul__dbg_print (cur_wmo);
	 p = p->next;
      }
      rul__dbg_free_param_list (pl);
      pl = NULL;
   }
}

static void       cmd_wmhistory (void)
{
}


static void process_command (void)
{
   switch (dbg_command) {
    case DBG__E_CMD_AT:
      cmd_at ();
      break;
    case DBG__E_CMD_ADDSTATE:
      cmd_addstate ();
      break;
    case DBG__E_CMD_AFTER:
      cmd_after ();
      break;
    case DBG__E_CMD_CLOSEFILE:
      cmd_closefile ();
      break;
    case DBG__E_CMD_COPY:
      cmd_copy ();
      break;
    case DBG__E_CMD_CS:
      cmd_cs ();
      break;
    case DBG__E_CMD_DEFAULT:
      cmd_default ();
      break;
    case DBG__E_CMD_DISABLE:
      cmd_disable ();
      break;
    case DBG__E_CMD_EBREAK:
      cmd_ebreak ();
      break;
    case DBG__E_CMD_ENABLE:
      cmd_enable ();
      break;
    case DBG__E_CMD_EXIT:
      cmd_exit ();
      break;
    case DBG__E_CMD_MAKE:
      cmd_make ();
      break;
    case DBG__E_CMD_MATCHES:
      cmd_matches ();
      break;
    case DBG__E_CMD_MODIFY:
      cmd_modify ();
      break;
    case DBG__E_CMD_NEXT:
      cmd_next ();
      break;
    case DBG__E_CMD_OPENFILE:
      cmd_openfile ();
      break;
    case DBG__E_CMD_RBREAK:
      cmd_rbreak ();
      break;
    case DBG__E_CMD_PPCLASS:
      cmd_ppclass ();
      break;
    case DBG__E_CMD_PPWM:
      cmd_ppwm ();
      break;
    case DBG__E_CMD_PROMPT:
      cmd_prompt ();
      break;
    case DBG__E_CMD_QUIT:
      cmd_quit ();
      break;
    case DBG__E_CMD_REMOVE:
      cmd_remove ();
      break;
    case DBG__E_CMD_REMOVE_EVERY:
      cmd_remove_every ();
      break;
    case DBG__E_CMD_RESTORESTATE:
      cmd_restorestate ();
      break;
    case DBG__E_CMD_RETURN:
      cmd_return ();
      break;
    case DBG__E_CMD_RUN:
      cmd_run ();
      break;
    case DBG__E_CMD_SAVESTATE:
      cmd_savestate ();
      break;
    case DBG__E_CMD_SHOW:
      cmd_show ();
      break;
    case DBG__E_CMD_SPECIALIZE:
      cmd_specialize ();
      break;
    case DBG__E_CMD_TRACE:
      cmd_trace ();
      break;
    case DBG__E_CMD_WBREAK:
      cmd_wbreak ();
      break;
    case DBG__E_CMD_WM:
      cmd_wm ();
      break;
    case DBG__E_CMD_WMHISTORY:
      cmd_wmhistory ();
      break;
   }
}


static Boolean	SB_in_command = FALSE;
static long	SL_command_type = 0;
static char	SC_command_name[RUL_C_MAX_SYMBOL_SIZE+1];


/*****************
**              **
**  IN_COMMAND  **
**              **
*****************/

static Boolean in_command (void)
{
  return (SB_in_command);
}

/***********************
**                    **
**  GET_COMMAND_TYPE  **
**                    **
***********************/

static long get_command_type (void)
{
  return (SL_command_type);
}
/***********************
**                    **
**  SET_COMMAND_TYPE  **
**                    **
***********************/

static void set_command_type (long cmd_type)
{
  SL_command_type = cmd_type;
}



/***************************
**                        **
**  COMMAND_TYPE_TO_NAME  **
**                        **
***************************/

static char *command_type_to_name (RulDbg_Command cmd_type)
{
  switch (cmd_type) {
  case DBG__E_CMD_AT:
    return ("@"); break;
  case DBG__E_CMD_ADDSTATE:
    return ("ADDSTATE"); break;
  case DBG__E_CMD_AFTER:
    return ("AFTER"); break;
  case DBG__E_CMD_CLOSEFILE:
    return ("CLOSEFILE"); break;
  case DBG__E_CMD_COPY:
    return ("COPY"); break;
  case DBG__E_CMD_CS:
    return ("CS"); break;
  case DBG__E_CMD_DEFAULT:
    return ("DEFAULT"); break;
  case DBG__E_CMD_DISABLE:
    return ("DISABLE"); break;
  case DBG__E_CMD_EBREAK:
    return ("EBREAK"); break;
  case DBG__E_CMD_ENABLE:
    return ("ENABLE"); break;
  case DBG__E_CMD_EXIT:
    return ("EXIT"); break;
  case DBG__E_CMD_MAKE:
    return ("MAKE"); break;
  case DBG__E_CMD_MATCHES:
    return ("MATCHES"); break;
  case DBG__E_CMD_MODIFY:
    return ("MODIFY"); break;
  case DBG__E_CMD_NEXT:
    return ("NEXT"); break;
  case DBG__E_CMD_OPENFILE:
    return ("OPENFILE"); break;
  case DBG__E_CMD_RBREAK:
    return ("RBREAK"); break;
  case DBG__E_CMD_PPCLASS:
    return ("PPCLASS"); break;
  case DBG__E_CMD_PPWM:
    return ("PPWM"); break;
  case DBG__E_CMD_PROMPT:
    return ("PROMPT"); break;
  case DBG__E_CMD_QUIT:
    return ("QUIT"); break;
  case DBG__E_CMD_REMOVE:
    return ("REMOVE"); break;
  case DBG__E_CMD_REMOVE_EVERY:
    return ("REMOVE-EVERY"); break;
  case DBG__E_CMD_RESTORESTATE:
    return ("RESTORESTATE"); break;
  case DBG__E_CMD_RUN:
    return ("RUN"); break;
  case DBG__E_CMD_SAVESTATE:
    return ("SAVESTATE"); break;
  case DBG__E_CMD_SHOW:
    return ("SHOW"); break;
  case DBG__E_CMD_SPECIALIZE:
    return ("SPECIALIZE"); break;
  case DBG__E_CMD_TRACE:
    return ("TRACE"); break;
  case DBG__E_CMD_WBREAK:
    return ("WBREAK"); break;
  case DBG__E_CMD_WM:
    return ("WM"); break;
  case DBG__E_CMD_WMHISTORY:
    return ("WMHISTORY"); break;
  default:
    return (""); break;
  }
}



/***********************
**                    **
**  GET_USAGE_STRING  **
**                    **
***********************/

static char *get_usage_string (RulDbg_Command cmd)
{
   char *ret_str;

   switch (cmd) {
	case DBG__E_CMD_AT:		ret_str = CLI_USAGE_AT;  break;
	case DBG__E_CMD_ADDSTATE:	ret_str = CLI_USAGE_ADDSTATE;  break;
	case DBG__E_CMD_AFTER:		ret_str = CLI_USAGE_AFTER;  break;
	case DBG__E_CMD_CLOSEFILE:	ret_str = CLI_USAGE_CLOSEFILE;  break;
	case DBG__E_CMD_COPY:		ret_str = CLI_USAGE_COPY;  break;
	case DBG__E_CMD_CS:		ret_str = CLI_USAGE_CS;  break;
	case DBG__E_CMD_DEFAULT:	ret_str = CLI_USAGE_DEFAULT;  break;
	case DBG__E_CMD_DISABLE:	ret_str = CLI_USAGE_DISABLE;  break;
	case DBG__E_CMD_EBREAK:		ret_str = CLI_USAGE_EBREAK;  break;
	case DBG__E_CMD_ENABLE:		ret_str = CLI_USAGE_ENABLE;  break;
	case DBG__E_CMD_EXIT:		ret_str = CLI_USAGE_EXIT;  break;
	case DBG__E_CMD_MAKE:		ret_str = CLI_USAGE_MAKE;  break;
	case DBG__E_CMD_MATCHES:	ret_str = CLI_USAGE_MATCHES;  break;
	case DBG__E_CMD_MODIFY:		ret_str = CLI_USAGE_MODIFY;  break;
	case DBG__E_CMD_NEXT:		ret_str = CLI_USAGE_NEXT;  break;
	case DBG__E_CMD_OPENFILE:	ret_str = CLI_USAGE_OPENFILE;  break;
	case DBG__E_CMD_RBREAK:		ret_str = CLI_USAGE_RBREAK;  break;
	case DBG__E_CMD_PPCLASS:	ret_str = CLI_USAGE_PPCLASS;  break;
	case DBG__E_CMD_PPWM:		ret_str = CLI_USAGE_PPWM;  break;
	case DBG__E_CMD_PROMPT:		ret_str = "" /*?*/;  break;
	case DBG__E_CMD_QUIT:		ret_str = CLI_USAGE_QUIT;  break;
	case DBG__E_CMD_REMOVE:		ret_str = CLI_USAGE_REMOVE;  break;
	case DBG__E_CMD_REMOVE_EVERY:	ret_str = CLI_USAGE_REMOVE_EVERY;
					break;
	case DBG__E_CMD_RESTORESTATE:	ret_str = CLI_USAGE_RESTORESTATE;
					break;
	case DBG__E_CMD_RETURN:		ret_str = CLI_USAGE_RETURN;  break;
	case DBG__E_CMD_RUN:		ret_str = CLI_USAGE_RUN;  break;
	case DBG__E_CMD_SAVESTATE:	ret_str = CLI_USAGE_SAVESTATE;  break;
	case DBG__E_CMD_SHOW:		ret_str = "" /*?*/;  break;
	case DBG__E_CMD_SPECIALIZE:	ret_str = CLI_USAGE_SPECIALIZE;  break;
	case DBG__E_CMD_TRACE:		ret_str = CLI_USAGE_TRACE;  break;
	case DBG__E_CMD_WBREAK:		ret_str = CLI_USAGE_WBREAK;  break;
	case DBG__E_CMD_WM:		ret_str = CLI_USAGE_WM;  break;
	case DBG__E_CMD_WMHISTORY:	ret_str = CLI_USAGE_WMHISTORY;  break;
	case DBG__E_CMD_IS_BOGUS:	
	default:			ret_str = "";  break;
    }
    return ret_str;
}



/**************************
**                       **
**  GET_EXAMPLES_STRING  **
**                       **
**************************/

static char *get_examples_string (RulDbg_Command cmd)
{
   char *ret_str;

   switch (cmd) {
	case DBG__E_CMD_AT:		ret_str = CLI_EXAMP_AT;  break;
	case DBG__E_CMD_ADDSTATE:	ret_str = CLI_EXAMP_ADDSTATE;  break;
	case DBG__E_CMD_AFTER:		ret_str = CLI_EXAMP_AFTER;  break;
	case DBG__E_CMD_CLOSEFILE:	ret_str = CLI_EXAMP_CLOSEFILE;  break;
	case DBG__E_CMD_COPY:		ret_str = CLI_EXAMP_COPY;  break;
	case DBG__E_CMD_CS:		ret_str = CLI_EXAMP_CS;  break;
	case DBG__E_CMD_DEFAULT:	ret_str = CLI_EXAMP_DEFAULT;  break;
	case DBG__E_CMD_DISABLE:	ret_str = CLI_EXAMP_DISABLE;  break;
	case DBG__E_CMD_EBREAK:		ret_str = CLI_EXAMP_EBREAK;  break;
	case DBG__E_CMD_ENABLE:		ret_str = CLI_EXAMP_ENABLE;  break;
	case DBG__E_CMD_EXIT:		ret_str = CLI_EXAMP_EXIT;  break;
	case DBG__E_CMD_MAKE:		ret_str = CLI_EXAMP_MAKE;  break;
	case DBG__E_CMD_MATCHES:	ret_str = CLI_EXAMP_MATCHES;  break;
	case DBG__E_CMD_MODIFY:		ret_str = CLI_EXAMP_MODIFY;  break;
	case DBG__E_CMD_NEXT:		ret_str = CLI_EXAMP_NEXT;  break;
	case DBG__E_CMD_OPENFILE:	ret_str = CLI_EXAMP_OPENFILE;  break;
	case DBG__E_CMD_RBREAK:		ret_str = CLI_EXAMP_RBREAK;  break;
	case DBG__E_CMD_PPCLASS:	ret_str = CLI_EXAMP_PPCLASS;  break;
	case DBG__E_CMD_PPWM:		ret_str = CLI_EXAMP_PPWM;  break;
	case DBG__E_CMD_PROMPT:		ret_str = "" /*?*/;  break;
	case DBG__E_CMD_QUIT:		ret_str = CLI_EXAMP_QUIT;  break;
	case DBG__E_CMD_REMOVE:		ret_str = CLI_EXAMP_REMOVE;  break;
	case DBG__E_CMD_REMOVE_EVERY:	ret_str = CLI_EXAMP_REMOVE_EVERY;
					break;
	case DBG__E_CMD_RESTORESTATE:	ret_str = CLI_EXAMP_RESTORESTATE;
					break;
	case DBG__E_CMD_RETURN:		ret_str = CLI_EXAMP_RETURN;  break;
	case DBG__E_CMD_RUN:		ret_str = CLI_EXAMP_RUN;  break;
	case DBG__E_CMD_SAVESTATE:	ret_str = CLI_EXAMP_SAVESTATE;  break;
	case DBG__E_CMD_SHOW:		ret_str = "" /*?*/;  break;
	case DBG__E_CMD_SPECIALIZE:	ret_str = CLI_EXAMP_SPECIALIZE;  break;
	case DBG__E_CMD_TRACE:		ret_str = CLI_EXAMP_TRACE;  break;
	case DBG__E_CMD_WBREAK:		ret_str = CLI_EXAMP_WBREAK;  break;
	case DBG__E_CMD_WM:		ret_str = CLI_EXAMP_WM;  break;
	case DBG__E_CMD_WMHISTORY:	ret_str = CLI_EXAMP_WMHISTORY;  break;
	case DBG__E_CMD_IS_BOGUS:	
	default:			ret_str = "";  break;
    }
    return ret_str;
}



/***********************
**                    **
**  GET_HINTS_STRING  **
**                    **
***********************/

static char *get_hints_string (RulDbg_Command cmd)
{
   char *ret_str;

   switch (cmd) {
	case DBG__E_CMD_AT:		ret_str = CLI_HINT_AT;  break;
	case DBG__E_CMD_ADDSTATE:	ret_str = CLI_HINT_ADDSTATE;  break;
	case DBG__E_CMD_AFTER:		ret_str = CLI_HINT_AFTER;  break;
	case DBG__E_CMD_CLOSEFILE:	ret_str = CLI_HINT_CLOSEFILE;  break;
	case DBG__E_CMD_COPY:		ret_str = CLI_HINT_COPY;  break;
	case DBG__E_CMD_CS:		ret_str = CLI_HINT_CS;  break;
	case DBG__E_CMD_DEFAULT:	ret_str = CLI_HINT_DEFAULT;  break;
	case DBG__E_CMD_DISABLE:	ret_str = CLI_HINT_DISABLE;  break;
	case DBG__E_CMD_EBREAK:		ret_str = CLI_HINT_EBREAK;  break;
	case DBG__E_CMD_ENABLE:		ret_str = CLI_HINT_ENABLE;  break;
	case DBG__E_CMD_EXIT:		ret_str = CLI_HINT_EXIT;  break;
	case DBG__E_CMD_MAKE:		ret_str = CLI_HINT_MAKE;  break;
	case DBG__E_CMD_MATCHES:	ret_str = CLI_HINT_MATCHES;  break;
	case DBG__E_CMD_MODIFY:		ret_str = CLI_HINT_MODIFY;  break;
	case DBG__E_CMD_NEXT:		ret_str = CLI_HINT_NEXT;  break;
	case DBG__E_CMD_OPENFILE:	ret_str = CLI_HINT_OPENFILE;  break;
	case DBG__E_CMD_RBREAK:		ret_str = CLI_HINT_RBREAK;  break;
	case DBG__E_CMD_PPCLASS:	ret_str = CLI_HINT_PPCLASS;  break;
	case DBG__E_CMD_PPWM:		ret_str = CLI_HINT_PPWM;  break;
	case DBG__E_CMD_PROMPT:		ret_str = "" /*?*/;  break;
	case DBG__E_CMD_QUIT:		ret_str = CLI_HINT_QUIT;  break;
	case DBG__E_CMD_REMOVE:		ret_str = CLI_HINT_REMOVE;  break;
	case DBG__E_CMD_REMOVE_EVERY:	ret_str = CLI_HINT_REMOVE_EVERY;
					break;
	case DBG__E_CMD_RESTORESTATE:	ret_str = CLI_HINT_RESTORESTATE;
					break;
	case DBG__E_CMD_RETURN:		ret_str = CLI_HINT_RETURN;  break;
	case DBG__E_CMD_RUN:		ret_str = CLI_HINT_RUN;  break;
	case DBG__E_CMD_SAVESTATE:	ret_str = CLI_HINT_SAVESTATE;  break;
	case DBG__E_CMD_SHOW:		ret_str = "" /*?*/;  break;
	case DBG__E_CMD_SPECIALIZE:	ret_str = CLI_HINT_SPECIALIZE;  break;
	case DBG__E_CMD_TRACE:		ret_str = CLI_HINT_TRACE;  break;
	case DBG__E_CMD_WBREAK:		ret_str = CLI_HINT_WBREAK;  break;
	case DBG__E_CMD_WM:		ret_str = CLI_HINT_WM;  break;
	case DBG__E_CMD_WMHISTORY:	ret_str = CLI_HINT_WMHISTORY;  break;
	case DBG__E_CMD_IS_BOGUS:	
	default:			ret_str = "";  break;
    }
    return ret_str;
}




static Boolean SB_syntax_error = FALSE;

/******************
**               **
**  CLEAR_ERROR  **
**               **
******************/

static void clear_error (void)
{
  SB_syntax_error = FALSE;
}


/****************
**             **
**  SET_ERROR  **
**             **
****************/

static void set_error (void)
{
  SB_syntax_error = TRUE;
  rul__dbg_set_pp_pat (NULL);
}


/***************
**            **
**  IN_ERROR  **
**            **
***************/

static Boolean in_error (void)
{
  return (SB_syntax_error);
}




/**************
**           **
**  YYERROR  **
**           **
**************/

static void yyerror (char *msg)
     /*
      **	Command and post an appropriate error message
      */
{
  char buffer[100], err_msg[100];
  char *str, *cmd_str, *examp_str, *use_str;
  char in_msg[RUL_C_MAX_SYMBOL_SIZE*2+25];
  char token_str[RUL_C_MAX_SYMBOL_SIZE+25];
  char near_msg[RUL_C_MAX_SYMBOL_SIZE+25];
  Boolean dont_print_in = FALSE;
  Token_Type typ;
  Token_Value val;

  if (SB_syntax_error) {
    /*
     **   If we are in the middle of a statement which
     **   we already know contains an error, clear the
     **   input buffer and continue.
     */
    return;
  }
  set_error ();

  typ = rul__scan_get_last_token (&val);

  switch (typ /* current token type */) {

  case TOK_FLOAT_CONST:
    sprintf (buffer, "%f", val.fval);
    str = buffer;
    break;

  case TOK_INTEGER_CONST:
    sprintf (buffer, "%ld", val.ival);
    str = buffer;
    break;

  case TOK_INSTANCE_CONST:
    sprintf (buffer, "#%ld", val.ival);
    str = buffer;
    break;

  case TOK_OPAQUE_CONST :
    sprintf (buffer, "%%x%p", val.ival);
    str = buffer;
    break;

  default:
    str = val.sval;
  }

  if (str[0] == '\n') {
    strcpy (token_str, " missing required parameters");
    dont_print_in = TRUE;
  } else if (str[0] == '\0') {
    token_str[0] = '\0';
  } else {
    if (dbg_command == DBG__E_CMD_IS_BOGUS) {
      sprintf (token_str, " unknown command '%s'", str);
    } else {
      sprintf (token_str, " at or near '%s'", str);
    }
  }

  err_msg[0] = '\0';
  near_msg[0] = '\0';
  in_msg[0] = '\0';

  if (dbg_command != DBG__E_CMD_IS_BOGUS) {
    cmd_str = command_type_to_name (dbg_command);
    if (cmd_str[0] != '\0') {
      if (dont_print_in) sprintf (in_msg, " %s command", cmd_str);
      else sprintf (in_msg, " in %s command", cmd_str);
    }
  }

  if ((strcmp (msg, "Syntax error") == 0) ||
      (strcmp (msg, "parse error") == 0)  ||
      (strcmp (msg, "syntax error") == 0)) {
    err_msg[0] = '\0';
  } else {
    sprintf (err_msg, "%s", msg);
  }

  rul__msg_print (CLI_SYNTAXERR, err_msg, in_msg, token_str);
  if (dbg_command != DBG__E_CMD_IS_BOGUS) {
    use_str = get_usage_string (dbg_command);
    examp_str = get_examples_string (dbg_command);
    if (use_str[0] != '\0'  ||  examp_str[0] != '\0') {
	rul__ios_printf (RUL__C_STD_ERR, "%s%s", use_str, examp_str);
    }
  }
}
#line 3206 "y.tab.c"
#define YYABORT goto yyabort
#define YYREJECT goto yyabort
#define YYACCEPT goto yyaccept
#define YYERROR goto yyerrlab
int
#if defined(__STDC__)
yyparse(void)
#else
yyparse()
#endif
{
    register int yym, yyn, yystate;
#if YYDEBUG
    register char *yys;
    extern char *getenv();

    if (yys = getenv("YYDEBUG"))
    {
        yyn = *yys;
        if (yyn >= '0' && yyn <= '9')
            yydebug = yyn - '0';
    }
#endif

    yynerrs = 0;
    yyerrflag = 0;
    yychar = (-1);

    yyssp = yyss;
    yyvsp = yyvs;
    *yyssp = yystate = 0;

yyloop:
    if ((yyn = yydefred[yystate]) != 0) goto yyreduce;
    if (yychar < 0)
    {
        if ((yychar = yylex()) < 0) yychar = 0;
#if YYDEBUG
        if (yydebug)
        {
            yys = 0;
            if (yychar <= YYMAXTOKEN) yys = yyname[yychar];
            if (!yys) yys = "illegal-symbol";
            printf("%sdebug: state %d, reading %d (%s)\n",
                    YYPREFIX, yystate, yychar, yys);
        }
#endif
    }
    if ((yyn = yysindex[yystate]) && (yyn += yychar) >= 0 &&
            yyn <= YYTABLESIZE && yycheck[yyn] == yychar)
    {
#if YYDEBUG
        if (yydebug)
            printf("%sdebug: state %d, shifting to state %d\n",
                    YYPREFIX, yystate, yytable[yyn]);
#endif
        if (yyssp >= yyss + yystacksize - 1)
        {
            goto yyoverflow;
        }
        *++yyssp = yystate = yytable[yyn];
        *++yyvsp = yylval;
        yychar = (-1);
        if (yyerrflag > 0)  --yyerrflag;
        goto yyloop;
    }
    if ((yyn = yyrindex[yystate]) && (yyn += yychar) >= 0 &&
            yyn <= YYTABLESIZE && yycheck[yyn] == yychar)
    {
        yyn = yytable[yyn];
        goto yyreduce;
    }
    if (yyerrflag) goto yyinrecovery;
    yyerror("syntax error");
#ifdef lint
    goto yyerrlab;
#endif
yyerrlab:
    ++yynerrs;
yyinrecovery:
    if (yyerrflag < 3)
    {
        yyerrflag = 3;
        for (;;)
        {
            if ((yyn = yysindex[*yyssp]) && (yyn += YYERRCODE) >= 0 &&
                    yyn <= YYTABLESIZE && yycheck[yyn] == YYERRCODE)
            {
#if YYDEBUG
                if (yydebug)
                    printf("%sdebug: state %d, error recovery shifting\
 to state %d\n", YYPREFIX, *yyssp, yytable[yyn]);
#endif
                if (yyssp >= yyss + yystacksize - 1)
                {
                    goto yyoverflow;
                }
                *++yyssp = yystate = yytable[yyn];
                *++yyvsp = yylval;
                goto yyloop;
            }
            else
            {
#if YYDEBUG
                if (yydebug)
                    printf("%sdebug: error recovery discarding state %d\n",
                            YYPREFIX, *yyssp);
#endif
                if (yyssp <= yyss) goto yyabort;
                --yyssp;
                --yyvsp;
            }
        }
    }
    else
    {
        if (yychar == 0) goto yyabort;
#if YYDEBUG
        if (yydebug)
        {
            yys = 0;
            if (yychar <= YYMAXTOKEN) yys = yyname[yychar];
            if (!yys) yys = "illegal-symbol";
            printf("%sdebug: state %d, error recovery discards token %d (%s)\n",
                    YYPREFIX, yystate, yychar, yys);
        }
#endif
        yychar = (-1);
        goto yyloop;
    }
yyreduce:
#if YYDEBUG
    if (yydebug)
        printf("%sdebug: state %d, reducing by rule %d (%s)\n",
                YYPREFIX, yystate, yyn, yyrule[yyn]);
#endif
    yym = yylen[yyn];
    yyval = yyvsp[1-yym];
    switch (yyn)
    {
case 1:
#line 545 "../source/cmd_pars.y"
{
		process_command (); 
		dbg_command = DBG__E_CMD_IS_BOGUS;
		INTERP_ABORT;
		}
break;
case 2:
#line 551 "../source/cmd_pars.y"
{ dbg_command = DBG__E_CMD_IS_BOGUS;  INTERP_ABORT;}
break;
case 3:
#line 553 "../source/cmd_pars.y"
{ 
		process_command (); 
		dbg_command = DBG__E_CMD_IS_BOGUS;
		INTERP_ABORT;
		}
break;
case 4:
#line 559 "../source/cmd_pars.y"
{ dbg_command = DBG__E_CMD_IS_BOGUS;  INTERP_ABORT;}
break;
case 5:
#line 561 "../source/cmd_pars.y"
{ dbg_command = DBG__E_CMD_IS_BOGUS;  INTERP_ABORT;}
break;
case 39:
#line 601 "../source/cmd_pars.y"
{/*MRA*/ dbg_command = DBG__E_CMD_AT;}
break;
case 40:
#line 602 "../source/cmd_pars.y"
{
		   p1 = (void *) yyvsp[0].mol;
		}
break;
case 41:
#line 608 "../source/cmd_pars.y"
{/*MRA*/ dbg_command = DBG__E_CMD_ADDSTATE;}
break;
case 42:
#line 609 "../source/cmd_pars.y"
{
		   p1 = (void *) yyvsp[0].mol;
		}
break;
case 43:
#line 615 "../source/cmd_pars.y"
{/*MRA*/ dbg_command = DBG__E_CMD_AFTER;}
break;
case 44:
#line 616 "../source/cmd_pars.y"
{ }
break;
case 45:
#line 621 "../source/cmd_pars.y"
{
		   p1 = (void *) yyvsp[-1].mol;
		   p2 = (void *) yyvsp[0].mol;
		}
break;
case 46:
#line 626 "../source/cmd_pars.y"
{ INTERP_ABORT; }
break;
case 47:
#line 631 "../source/cmd_pars.y"
{/*MRA*/ dbg_command = DBG__E_CMD_CLOSEFILE;
		 rul__dbg_free_param_list (pl); pl = NULL; }
break;
case 48:
#line 634 "../source/cmd_pars.y"
{ }
break;
case 49:
#line 639 "../source/cmd_pars.y"
{
		   rul__dbg_add_data_to_list (&pl, DBG__E_PL_MOL, (void*) yyvsp[0].mol);
		}
break;
case 50:
#line 643 "../source/cmd_pars.y"
{
		   rul__dbg_add_data_to_list (&pl, DBG__E_PL_MOL, (void*) yyvsp[0].mol);
		}
break;
case 51:
#line 650 "../source/cmd_pars.y"
{ }
break;
case 52:
#line 654 "../source/cmd_pars.y"
{/*MRA*/ dbg_command = DBG__E_CMD_COPY;}
break;
case 53:
#line 655 "../source/cmd_pars.y"
{
		  cur_wmo = rul__mol_instance_id_value (yyvsp[0].mol);
		  if (cur_wmo == NULL) {
		    rul__msg_print (CLI_INVWMO, cur_int, "COPY");
		    INTERP_ABORT;
		  }
		  cur_cls = rul__wm_get_class (cur_wmo);
		  num_attrs = rul__decl_get_class_num_attrs (cur_cls) + 1;
		  if (result_len < num_attrs) {
		    result = rul__mem_realloc(result, (num_attrs * 4));
		    result_len = num_attrs;
		  }
		  wmo_cmd = WM__OPR_COPY;
		  for (j = 0; j < result_len; j++) { result[j] = NULL; }
		}
break;
case 54:
#line 674 "../source/cmd_pars.y"
{ dbg_command = DBG__E_CMD_CS; }
break;
case 55:
#line 678 "../source/cmd_pars.y"
{/*MRA*/ dbg_command = DBG__E_CMD_DEFAULT;}
break;
case 56:
#line 680 "../source/cmd_pars.y"
{
		   p1 = (void *) yyvsp[-1].mol;
		   p2 = (void *) yyvsp[0].ioc;
		}
break;
case 57:
#line 688 "../source/cmd_pars.y"
{ yyval.ioc = IOS__E_ACCEPT; }
break;
case 58:
#line 690 "../source/cmd_pars.y"
{ yyval.ioc = IOS__E_TRACE; }
break;
case 59:
#line 692 "../source/cmd_pars.y"
{ yyval.ioc = IOS__E_WRITE; }
break;
case 60:
#line 694 "../source/cmd_pars.y"
{ INTERP_ABORT; }
break;
case 61:
#line 698 "../source/cmd_pars.y"
{/*MRA*/ dbg_command = DBG__E_CMD_DISABLE;}
break;
case 62:
#line 699 "../source/cmd_pars.y"
{ p1 = (void *) yyvsp[0].ptr; }
break;
case 63:
#line 704 "../source/cmd_pars.y"
{ yyval.ptr = (void *) TOK_WARNING; }
break;
case 64:
#line 706 "../source/cmd_pars.y"
{ yyval.ptr = (void *) TOK_WMHISTORY; }
break;
case 65:
#line 708 "../source/cmd_pars.y"
{ yyval.ptr = (void *) TOK_BLOCK_NAME; }
break;
case 66:
#line 710 "../source/cmd_pars.y"
{ yyval.ptr = (void *)TOK_CTRLC; }
break;
case 67:
#line 712 "../source/cmd_pars.y"
{ INTERP_ABORT; }
break;
case 68:
#line 717 "../source/cmd_pars.y"
{/*MRA*/ dbg_command = DBG__E_CMD_EBREAK;
		rul__dbg_free_param_list (pl); pl = NULL; }
break;
case 69:
#line 720 "../source/cmd_pars.y"
{ }
break;
case 70:
#line 722 "../source/cmd_pars.y"
{/*MRA*/ dbg_command = DBG__E_CMD_EBREAK;
		rul__dbg_free_param_list (pl); pl = NULL; }
break;
case 71:
#line 725 "../source/cmd_pars.y"
{ }
break;
case 72:
#line 730 "../source/cmd_pars.y"
{ pl = (void *) -1; }
break;
case 73:
#line 732 "../source/cmd_pars.y"
{ }
break;
case 74:
#line 738 "../source/cmd_pars.y"
{ on_flag = TRUE; }
break;
case 75:
#line 740 "../source/cmd_pars.y"
{ on_flag = FALSE; }
break;
case 76:
#line 745 "../source/cmd_pars.y"
{ }
break;
case 77:
#line 747 "../source/cmd_pars.y"
{ }
break;
case 78:
#line 752 "../source/cmd_pars.y"
{
		   rul__dbg_add_data_to_list (&pl, DBG__E_PL_MOL, (void*) yyvsp[0].mol);
		}
break;
case 79:
#line 756 "../source/cmd_pars.y"
{
		   rul__dbg_add_data_to_list (&pl, DBG__E_PL_MOL, (void*) yyvsp[0].mol);
		}
break;
case 80:
#line 763 "../source/cmd_pars.y"
{ }
break;
case 81:
#line 765 "../source/cmd_pars.y"
{ }
break;
case 82:
#line 770 "../source/cmd_pars.y"
{
		   rul__dbg_add_data_to_list (&pl, DBG__E_PL_MOL, (void*) yyvsp[0].mol);
		}
break;
case 83:
#line 774 "../source/cmd_pars.y"
{
		   rul__dbg_add_data_to_list (&pl, DBG__E_PL_MOL, (void*) yyvsp[0].mol);
		}
break;
case 84:
#line 778 "../source/cmd_pars.y"
{
		   rul__dbg_add_data_to_list (&pl, DBG__E_PL_INT, (void*) yyvsp[0].tok.ival);
		}
break;
case 85:
#line 782 "../source/cmd_pars.y"
{
		   rul__dbg_add_data_to_list (&pl, DBG__E_PL_INT, (void*) yyvsp[0].tok.ival);
		}
break;
case 86:
#line 789 "../source/cmd_pars.y"
{ }
break;
case 87:
#line 793 "../source/cmd_pars.y"
{/*MRA*/ dbg_command = DBG__E_CMD_ENABLE;}
break;
case 88:
#line 794 "../source/cmd_pars.y"
{ p1 = (void *) yyvsp[0].ptr; }
break;
case 89:
#line 799 "../source/cmd_pars.y"
{ yyval.ptr = (void *) TOK_WARNING; }
break;
case 90:
#line 801 "../source/cmd_pars.y"
{ yyval.ptr = (void *) TOK_WMHISTORY; }
break;
case 91:
#line 803 "../source/cmd_pars.y"
{ yyval.ptr = (void *) TOK_BLOCK_NAME; }
break;
case 92:
#line 805 "../source/cmd_pars.y"
{ yyval.ptr = (void *) TOK_CTRLC; }
break;
case 93:
#line 807 "../source/cmd_pars.y"
{ INTERP_ABORT; }
break;
case 94:
#line 813 "../source/cmd_pars.y"
{
		   dbg_command = DBG__E_CMD_EXIT;
		   p1 = (void *) NULL;
		   cmd_exit ();
		   INTERP_ABORT;
		}
break;
case 95:
#line 820 "../source/cmd_pars.y"
{
		   dbg_command = DBG__E_CMD_EXIT;
		   p1 = (void *) -1;
		   cmd_exit ();
		   INTERP_ABORT;
		}
break;
case 96:
#line 830 "../source/cmd_pars.y"
{ }
break;
case 97:
#line 834 "../source/cmd_pars.y"
{/*MRA*/ dbg_command = DBG__E_CMD_MAKE;}
break;
case 98:
#line 835 "../source/cmd_pars.y"
{
		  num_attrs = rul__decl_get_class_num_attrs (yyvsp[0].cls) + 1;
		  if (result_len < num_attrs) {
		    result = rul__mem_realloc (result, (num_attrs*4));
		    result_len = num_attrs;
		  }
		  wmo_cmd = WM__OPR_MAKE;
		  for (j = 0; j < result_len; j++) {
		    result[j] = NULL;
		  }
		}
break;
case 99:
#line 850 "../source/cmd_pars.y"
{/*MRA*/ dbg_command = DBG__E_CMD_MATCHES;
	    rul__dbg_free_param_list (pl); pl = NULL; }
break;
case 100:
#line 853 "../source/cmd_pars.y"
{ }
break;
case 101:
#line 858 "../source/cmd_pars.y"
{ }
break;
case 102:
#line 860 "../source/cmd_pars.y"
{ }
break;
case 103:
#line 865 "../source/cmd_pars.y"
{ }
break;
case 104:
#line 869 "../source/cmd_pars.y"
{/*MRA*/ dbg_command = DBG__E_CMD_MODIFY;}
break;
case 105:
#line 870 "../source/cmd_pars.y"
{
		  cur_wmo = rul__mol_instance_id_value (yyvsp[0].mol);
		  if (cur_wmo == NULL) {
		    rul__msg_print (CLI_INVWMO, cur_int, "MODIFY");
		    INTERP_ABORT;
		  }
		  cur_cls = rul__wm_get_class (cur_wmo);
		  num_attrs = rul__decl_get_class_num_attrs (cur_cls) + 1;
		  if (result_len < num_attrs) {
		    result = rul__mem_realloc (result, (num_attrs * 4));
		    result_len = num_attrs;
		  }
		  wmo_cmd = WM__OPR_MODIFY;
		  for (j = 0; j < result_len; j++) {
		    result[j] = NULL;
		  }
		}
break;
case 106:
#line 891 "../source/cmd_pars.y"
{ dbg_command = DBG__E_CMD_NEXT; }
break;
case 107:
#line 895 "../source/cmd_pars.y"
{/*MRA*/ dbg_command = DBG__E_CMD_OPENFILE; }
break;
case 108:
#line 897 "../source/cmd_pars.y"
{
		   p1 = (void *) yyvsp[-2].mol;
		   p2 = (void *) yyvsp[-1].mol;
		   p3 = (void *) yyvsp[0].ioa;
		}
break;
case 109:
#line 906 "../source/cmd_pars.y"
{ yyval.ioa = IOS__E_IN; }
break;
case 110:
#line 908 "../source/cmd_pars.y"
{ yyval.ioa = IOS__E_IN; }
break;
case 111:
#line 910 "../source/cmd_pars.y"
{ yyval.ioa = IOS__E_OUT; }
break;
case 112:
#line 912 "../source/cmd_pars.y"
{ yyval.ioa = IOS__E_APPEND; }
break;
case 113:
#line 914 "../source/cmd_pars.y"
{ INTERP_ABORT; }
break;
case 114:
#line 919 "../source/cmd_pars.y"
{/*MRA*/  dbg_command = DBG__E_CMD_RBREAK;
	    rul__dbg_free_param_list (pl); pl = NULL; }
break;
case 115:
#line 922 "../source/cmd_pars.y"
{ }
break;
case 116:
#line 927 "../source/cmd_pars.y"
{ pl = (void *) -1; }
break;
case 117:
#line 929 "../source/cmd_pars.y"
{ }
break;
case 118:
#line 934 "../source/cmd_pars.y"
{ on_flag = TRUE; }
break;
case 119:
#line 936 "../source/cmd_pars.y"
{ on_flag = FALSE; }
break;
case 120:
#line 941 "../source/cmd_pars.y"
{ }
break;
case 121:
#line 943 "../source/cmd_pars.y"
{ }
break;
case 122:
#line 948 "../source/cmd_pars.y"
{ }
break;
case 123:
#line 950 "../source/cmd_pars.y"
{ }
break;
case 124:
#line 955 "../source/cmd_pars.y"
{ }
break;
case 125:
#line 957 "../source/cmd_pars.y"
{ }
break;
case 126:
#line 959 "../source/cmd_pars.y"
{
		   rul__dbg_add_data_to_list (&pl, DBG__E_PL_INT, (void*) yyvsp[0].tok.ival);
		}
break;
case 127:
#line 963 "../source/cmd_pars.y"
{
		   rul__dbg_add_data_to_list (&pl, DBG__E_PL_INT, (void*) yyvsp[0].tok.ival);
		}
break;
case 128:
#line 969 "../source/cmd_pars.y"
{/*MRA*/ dbg_command = DBG__E_CMD_PPCLASS;}
break;
case 129:
#line 970 "../source/cmd_pars.y"
{ }
break;
case 130:
#line 975 "../source/cmd_pars.y"
{ cur_cls = NULL; }
break;
case 131:
#line 977 "../source/cmd_pars.y"
{ }
break;
case 132:
#line 982 "../source/cmd_pars.y"
{/*MRA*/  dbg_command = DBG__E_CMD_PPWM;
	    rul__dbg_free_param_list (pl); pl = NULL; }
break;
case 133:
#line 985 "../source/cmd_pars.y"
{ }
break;
case 134:
#line 990 "../source/cmd_pars.y"
{ }
break;
case 135:
#line 992 "../source/cmd_pars.y"
{
		   rul__dbg_add_data_to_list (&pl, DBG__E_PL_PAT, (void*) yyvsp[0].ptr);
		   pat_pat = NULL;
		}
break;
case 136:
#line 999 "../source/cmd_pars.y"
{/*MRA*/ dbg_command = DBG__E_CMD_PROMPT;}
break;
case 137:
#line 1000 "../source/cmd_pars.y"
{ p1 = (void *) yyvsp[0].mol; }
break;
case 138:
#line 1004 "../source/cmd_pars.y"
{/*MRA*/ dbg_command = DBG__E_CMD_QUIT;}
break;
case 139:
#line 1005 "../source/cmd_pars.y"
{ p1 = (void *) yyvsp[0].tok.ival; }
break;
case 140:
#line 1010 "../source/cmd_pars.y"
{ yyval.tok.ival = EXIT_SUCCESS; }
break;
case 141:
#line 1012 "../source/cmd_pars.y"
{ yyval.tok.ival = EXIT_SUCCESS; }
break;
case 142:
#line 1014 "../source/cmd_pars.y"
{ yyval.tok.ival = EXIT_FAILURE; }
break;
case 143:
#line 1016 "../source/cmd_pars.y"
{ yyval.tok.ival = yyvsp[0].tok.ival; }
break;
case 144:
#line 1021 "../source/cmd_pars.y"
{/*MRA*/  dbg_command = DBG__E_CMD_REMOVE;
	    rul__dbg_free_param_list (pl); pl = NULL; }
break;
case 145:
#line 1024 "../source/cmd_pars.y"
{ }
break;
case 147:
#line 1030 "../source/cmd_pars.y"
{ }
break;
case 148:
#line 1032 "../source/cmd_pars.y"
{
		   rul__dbg_add_data_to_list (&pl, DBG__E_PL_INT, (void*) yyvsp[0].mol);
		}
break;
case 149:
#line 1036 "../source/cmd_pars.y"
{ INTERP_ABORT; }
break;
case 150:
#line 1041 "../source/cmd_pars.y"
{/*MRA*/ dbg_command = DBG__E_CMD_REMOVE_EVERY;}
break;
case 151:
#line 1043 "../source/cmd_pars.y"
{ }
break;
case 152:
#line 1048 "../source/cmd_pars.y"
{/*MRA*/ dbg_command = DBG__E_CMD_RESTORESTATE;}
break;
case 153:
#line 1050 "../source/cmd_pars.y"
{ p1 = (void *) yyvsp[0].mol; }
break;
case 154:
#line 1054 "../source/cmd_pars.y"
{/*MRA*/ dbg_command = DBG__E_CMD_RETURN;}
break;
case 155:
#line 1055 "../source/cmd_pars.y"
{ p1 = (void *) yyvsp[0].mol; }
break;
case 156:
#line 1060 "../source/cmd_pars.y"
{ yyval.mol = NULL; }
break;
case 157:
#line 1062 "../source/cmd_pars.y"
{ }
break;
case 158:
#line 1067 "../source/cmd_pars.y"
{/*MRA*/ dbg_command = DBG__E_CMD_RUN;}
break;
case 159:
#line 1069 "../source/cmd_pars.y"
{ p1 = (void *) yyvsp[0].tok.ival; }
break;
case 160:
#line 1074 "../source/cmd_pars.y"
{ yyval.tok.ival = -1; }
break;
case 161:
#line 1076 "../source/cmd_pars.y"
{ yyval.tok.ival = cur_int;	}
break;
case 162:
#line 1078 "../source/cmd_pars.y"
{
		   rul__msg_print (CLI_INVRUNCNT, yyvsp[0].tok.sval);
		   INTERP_ABORT;
		}
break;
case 163:
#line 1083 "../source/cmd_pars.y"
{
		   rul__msg_print (CLI_INVRUNCNT, yyvsp[0].tok.sval);
		   INTERP_ABORT;
		}
break;
case 164:
#line 1088 "../source/cmd_pars.y"
{
		   rul__msg_print_w_atoms(CLI_INVRUNCNF, 1, yyvsp[0].mol);
		   INTERP_ABORT;
		}
break;
case 165:
#line 1095 "../source/cmd_pars.y"
{/*MRA*/ dbg_command = DBG__E_CMD_SAVESTATE;}
break;
case 166:
#line 1096 "../source/cmd_pars.y"
{ p1 = (void *) yyvsp[0].mol; }
break;
case 167:
#line 1100 "../source/cmd_pars.y"
{/*MRA*/ dbg_command = DBG__E_CMD_SHOW;}
break;
case 168:
#line 1101 "../source/cmd_pars.y"
{ }
break;
case 169:
#line 1106 "../source/cmd_pars.y"
{ }
break;
case 170:
#line 1111 "../source/cmd_pars.y"
{ }
break;
case 171:
#line 1116 "../source/cmd_pars.y"
{/*MRA*/ dbg_command = DBG__E_CMD_SPECIALIZE;}
break;
case 172:
#line 1118 "../source/cmd_pars.y"
{
		  cur_wmo = rul__mol_instance_id_value (yyvsp[-1].mol);
		  if (cur_wmo == NULL) {
		    rul__msg_print (CLI_INVWMO, cur_int, "SPECIALIZE");
		    INTERP_ABORT;
		  }
		  tmp_cls = rul__wm_get_class (cur_wmo);
		  tmp_atm = rul__decl_get_class_name (tmp_cls);
		  if (!(rul__decl_is_subclass_of (yyvsp[0].cls, tmp_cls))) {
		    rul__msg_print_w_atoms(CLI_INVSPECLS, 2, cls_nam, tmp_atm);
		    INTERP_ABORT;
		  }
		  num_attrs = rul__decl_get_class_num_attrs (yyvsp[0].cls) + 1;
		  if (result_len < num_attrs) {
		    result = rul__mem_realloc (result, (num_attrs * 4));
		    result_len = num_attrs;
		  }
		  wmo_cmd = WM__OPR_SPECIALIZE;
		  for (j = 0; j < result_len; j++) {
		    result[j] = NULL;
		  }
		}
break;
case 173:
#line 1144 "../source/cmd_pars.y"
{/*MRA*/ dbg_command = DBG__E_CMD_TRACE;  p1 = NULL;}
break;
case 174:
#line 1146 "../source/cmd_pars.y"
{ }
break;
case 175:
#line 1151 "../source/cmd_pars.y"
{ p1 = (void *) -1; }
break;
case 176:
#line 1153 "../source/cmd_pars.y"
{ }
break;
case 177:
#line 1158 "../source/cmd_pars.y"
{ on_flag = TRUE; }
break;
case 178:
#line 1160 "../source/cmd_pars.y"
{ on_flag = FALSE; }
break;
case 179:
#line 1165 "../source/cmd_pars.y"
{ p1 = (void *) ((long) DBG_M_TRACE_ALL); }
break;
case 180:
#line 1167 "../source/cmd_pars.y"
{ }
break;
case 181:
#line 1172 "../source/cmd_pars.y"
{ }
break;
case 182:
#line 1174 "../source/cmd_pars.y"
{ }
break;
case 183:
#line 1179 "../source/cmd_pars.y"
{ p1 = (void *) ((long) p1 | DBG_M_TRACE_EB); }
break;
case 184:
#line 1181 "../source/cmd_pars.y"
{ p1 = (void *) ((long) p1 | DBG_M_TRACE_EB); }
break;
case 185:
#line 1183 "../source/cmd_pars.y"
{ p1 = (void *) ((long) p1 | DBG_M_TRACE_RG); }
break;
case 186:
#line 1185 "../source/cmd_pars.y"
{ p1 = (void *) ((long) p1 | DBG_M_TRACE_RG); }
break;
case 187:
#line 1187 "../source/cmd_pars.y"
{ p1 = (void *) ((long) p1 | DBG_M_TRACE_R); }
break;
case 188:
#line 1189 "../source/cmd_pars.y"
{ p1 = (void *) ((long) p1 | DBG_M_TRACE_WM); }
break;
case 189:
#line 1191 "../source/cmd_pars.y"
{ p1 = (void *) ((long) p1 | DBG_M_TRACE_CS); }
break;
case 190:
#line 1196 "../source/cmd_pars.y"
{/*MRA*/  dbg_command = DBG__E_CMD_WBREAK;
	    rul__dbg_free_param_list (pl);  pl = NULL;}
break;
case 191:
#line 1199 "../source/cmd_pars.y"
{ }
break;
case 192:
#line 1205 "../source/cmd_pars.y"
{ pl = (void *) -1; }
break;
case 193:
#line 1207 "../source/cmd_pars.y"
{ }
break;
case 194:
#line 1212 "../source/cmd_pars.y"
{ on_flag = TRUE; }
break;
case 195:
#line 1214 "../source/cmd_pars.y"
{ on_flag = FALSE; }
break;
case 196:
#line 1220 "../source/cmd_pars.y"
{
		   rul__dbg_add_data_to_list (&pl, DBG__E_PL_PAT, (void*) yyvsp[0].ptr);
		   pat_pat = NULL;
		}
break;
case 197:
#line 1228 "../source/cmd_pars.y"
{ }
break;
case 198:
#line 1230 "../source/cmd_pars.y"
{ }
break;
case 199:
#line 1235 "../source/cmd_pars.y"
{ 
		   rul__dbg_add_data_to_list (&pl, DBG__E_PL_PAT, (void*) yyvsp[0].ptr);
		   pat_pat = NULL;
		}
break;
case 200:
#line 1240 "../source/cmd_pars.y"
{
		   rul__dbg_add_data_to_list (&pl, DBG__E_PL_INT, (void*) yyvsp[0].tok.ival);
		}
break;
case 201:
#line 1244 "../source/cmd_pars.y"
{
		   rul__dbg_add_data_to_list (&pl, DBG__E_PL_INT, (void*) yyvsp[0].tok.ival);
		}
break;
case 202:
#line 1251 "../source/cmd_pars.y"
{ }
break;
case 203:
#line 1256 "../source/cmd_pars.y"
{/*MRA*/  dbg_command = DBG__E_CMD_WM;
	    rul__dbg_free_param_list (pl);  pl = NULL;}
break;
case 204:
#line 1259 "../source/cmd_pars.y"
{ }
break;
case 205:
#line 1264 "../source/cmd_pars.y"
{ }
break;
case 206:
#line 1266 "../source/cmd_pars.y"
{ }
break;
case 207:
#line 1271 "../source/cmd_pars.y"
{
		   rul__dbg_add_data_to_list (&pl, DBG__E_PL_MOL, (void*) yyvsp[0].mol);
		}
break;
case 208:
#line 1275 "../source/cmd_pars.y"
{
		   rul__dbg_add_data_to_list (&pl, DBG__E_PL_MOL, (void*) yyvsp[0].mol);
		}
break;
case 209:
#line 1282 "../source/cmd_pars.y"
{/*MRA*/ dbg_command = DBG__E_CMD_WMHISTORY;}
break;
case 210:
#line 1284 "../source/cmd_pars.y"
{
		  if (yyvsp[0].mol != NULL) {
		    if (!rul__decl_is_attr_in_class (cur_cls, yyvsp[0].mol)) {
		      rul__msg_print_w_atoms (CLI_INVCLSATT, 2, yyvsp[0].mol, cls_nam);
		      INTERP_ABORT;
		    }
		  }
		  rul__wm_print_histform (yyvsp[-1].obj, yyvsp[0].mol, RUL__C_STD_ERR);
		  rul__ios_printf(RUL__C_STD_ERR, "\n");
		}
break;
case 211:
#line 1298 "../source/cmd_pars.y"
{
		  yyval.obj = cur_wmo = rul__mol_instance_id_value (yyvsp[0].mol);
		  if (cur_wmo) {
		    cur_cls = rul__wm_get_class (cur_wmo);
		    cls_nam = rul__decl_get_class_name (cur_cls);
		  }
		  else {
		    rul__msg_print_w_atoms (CLI_NOSUCHWMO, 1, yyvsp[0].mol);
		    INTERP_ABORT;
		  }
		}
break;
case 212:
#line 1313 "../source/cmd_pars.y"
{ yyval.mol = NULL; }
break;
case 213:
#line 1315 "../source/cmd_pars.y"
{ yyval.mol = yyvsp[0].mol; }
break;
case 216:
#line 1325 "../source/cmd_pars.y"
{
		  if (!rul__decl_is_attr_in_class (cur_cls, yyvsp[-2].mol)) {
		    rul__msg_print_w_atoms (CLI_INVCLSATT, 2, yyvsp[-2].mol, cls_nam);
		    INTERP_ABORT;
		  }
		  cur_off = rul__decl_get_attr_offset (cur_cls, yyvsp[-2].mol);
		  att_shape = rul__decl_get_attr_shape (cur_cls, yyvsp[-2].mol);
		  if (yyvsp[-1].tok.ival == 0) {
		    if (att_shape == shape_compound &&
			!rul__mol_is_compound (yyvsp[0].mol)) {
		      rul__ios_printf (RUL__C_STD_ERR,
			       "   Invalid compound attribute value\n");
		      INTERP_ABORT;
		    }
		    else if (att_shape != shape_compound &&
			     rul__mol_is_compound (yyvsp[0].mol)) {
		      rul__ios_printf (RUL__C_STD_ERR,
			       "   Invalid scalar attribute value\n");
		      INTERP_ABORT;
		    }
		    result[cur_off] = yyvsp[0].mol;
		  }
		  else {
		    if (att_shape != shape_compound) {
		      rul__ios_printf (RUL__C_STD_ERR,
			       "   Invalid indexing of scalar attribute\n");
		      INTERP_ABORT;
		    }
		    if (rul__mol_is_compound (yyvsp[0].mol)) {
		      rul__ios_printf (RUL__C_STD_ERR,
				       "   Invalid indexed attribute value\n");
		      INTERP_ABORT;
		    }
		    if (result[cur_off] == NULL) {
		      if (wmo_cmd != WM__OPR_MAKE)
			result[cur_off] = rul__wm_get_offset_val (cur_wmo,
								  cur_off);
		      else
			result[cur_off] = rul__mol_make_comp (0);
		    }
		    if (yyvsp[-1].tok.ival == -1) {
		      yyvsp[-1].tok.ival = rul__mol_get_poly_count (result[cur_off]);
		      if (yyvsp[-1].tok.ival == 0)
			yyvsp[-1].tok.ival = 1;
		    }
		    result[cur_off] = rul__mol_set_comp_nth (result[cur_off],
							     yyvsp[-1].tok.ival, yyvsp[0].mol, 
				     rul__decl_get_attr_fill (cur_cls, yyvsp[-2].mol));

		  }
		}
break;
case 217:
#line 1377 "../source/cmd_pars.y"
{ INTERP_ABORT; }
break;
case 218:
#line 1382 "../source/cmd_pars.y"
{
		  if (rul__dbg_is_valid_db (yyvsp[-2].mol)) {
		    cur_blk = rul__decl_get_block (yyvsp[-2].mol);
		    cur_rb = yyvsp[-2].mol;
		    cur_cls = yyval.cls = rul__decl_get_class (cur_blk, yyvsp[0].mol);
		    if (yyval.cls == NULL) {
		      if (rul__dbg_is_visible_class (yyvsp[0].mol))
			rul__msg_print_w_atoms (CLI_INVBLKCLS, 2, yyvsp[0].mol, yyvsp[-2].mol);
		      else
			rul__msg_print_w_atoms (CLI_INVCLSNAM, 1, yyvsp[0].mol);
		      INTERP_ABORT;
		    }
		    cls_nam = yyvsp[0].mol;
		  }
		  else {
		    rul__msg_print_w_atoms (CLI_INVBLKNAM, 1, yyvsp[-2].mol);
		    INTERP_ABORT;
		  }
		}
break;
case 219:
#line 1402 "../source/cmd_pars.y"
{
		  cur_blk = NULL;
		  cur_cls = yyval.cls = rul__decl_get_class_if_unique (yyvsp[0].mol);
		  if (yyval.cls == NULL) {
		    if (rul__dbg_is_visible_class (yyvsp[0].mol)) {
		      rul__msg_print_w_atoms (CLI_AMBCLSNAM, 1, yyvsp[0].mol);
		      rul__dbg_show_amb_class (yyvsp[0].mol);
		    }
		    else
		      rul__msg_print_w_atoms (CLI_INVCLSNAM, 1, yyvsp[0].mol);
		    INTERP_ABORT;
		  }
		  cur_blk = rul__decl_get_class_block (cur_cls);
		  if (cur_blk)
		    cur_rb = rul__decl_get_decl_name (cur_blk);
		  cls_nam = yyvsp[0].mol;
		}
break;
case 220:
#line 1420 "../source/cmd_pars.y"
{ INTERP_ABORT; }
break;
case 222:
#line 1466 "../source/cmd_pars.y"
{
		  if (pat_pat == NULL) {
		    pat_pat = RUL_MEM_ALLOCATE (Pat_Pattern, 1);
		    pcn = &(pat_pat->pc);
		  }
		  *pcn = pat_cls = RUL_MEM_ALLOCATE (Pat_Classes, 1);
		  pat_cls->cls = yyvsp[0].cls;
		  pan = &(pat_cls->pa);
		  pcn = &(pat_cls->next);
		}
break;
case 223:
#line 1477 "../source/cmd_pars.y"
{ yyval.ptr = pat_pat; }
break;
case 224:
#line 1479 "../source/cmd_pars.y"
{
		  if (pat_pat == NULL) {
		    pat_pat = RUL_MEM_ALLOCATE (Pat_Pattern, 1);
		    pcn = &(pat_pat->pc);
		  }
		  *pcn = pat_cls = RUL_MEM_ALLOCATE (Pat_Classes, 1);
		  pat_cls->cls = yyvsp[0].cls;
		  pan = &(pat_cls->pa);
		  pcn = &(pat_cls->next);
		}
break;
case 225:
#line 1490 "../source/cmd_pars.y"
{ yyval.ptr = pat_pat; }
break;
case 226:
#line 1495 "../source/cmd_pars.y"
{ yyval.ptr = NULL; }
break;
case 227:
#line 1497 "../source/cmd_pars.y"
{ yyval.ptr = yyvsp[0].ptr; }
break;
case 228:
#line 1502 "../source/cmd_pars.y"
{
		  ok = TRUE;
		  if (att_shape != shape_compound ||
		      att_shape == shape_compound && pat_att->idx) {
		     if (pat_att->idx && att_shape != shape_compound) {
			rul__msg_print_w_atoms (CLI_INVATTSYN, 1,
						pat_att->attr);
			ok = FALSE;
		     }
		     else if ((pred1 && val_scalar) ||
			      (pred2 && val_scalar)) {
			rul__msg_print (CLI_INVPRDUSG);
			ok = FALSE;
		     }
		  }
		  else { /* compound attribute */
		     if (!pred1 && val_scalar) {
			rul__msg_print (CLI_INVPRDUSG);
			ok = FALSE;
		     }
		     else if ((pred1 || pred2) && !val_scalar) {
			rul__msg_print (CLI_INVPRDUSG);
			ok = FALSE;
		     }
		  }
		  if (ok == FALSE) {
		     INTERP_ABORT;
		  }
		}
break;
case 229:
#line 1535 "../source/cmd_pars.y"
{
		  *pan = pat_att = RUL_MEM_ALLOCATE (Pat_Attrs, 1);
		  if (!rul__decl_is_attr_in_class (pat_cls->cls, yyvsp[-1].mol)) {
		    rul__msg_print_w_atoms (CLI_INVCLSATT, 2, yyvsp[-1].mol, cls_nam);
		    INTERP_ABORT;
		  }
		  pat_att->attr = yyvsp[-1].mol;
		  pat_att->idx = yyvsp[0].tok.ival;
		  att_shape = rul__decl_get_attr_shape (pat_cls->cls, yyvsp[-1].mol);
		  val_scalar = TRUE;
		  pred1 = FALSE;
		  pred2 = FALSE;
		  pan = &(pat_att->next);
		  ptn = &(pat_att->pt);
		}
break;
case 230:
#line 1551 "../source/cmd_pars.y"
{ INTERP_ABORT; }
break;
case 231:
#line 1556 "../source/cmd_pars.y"
{ yyval.tok.ival = 0; }
break;
case 232:
#line 1558 "../source/cmd_pars.y"
{ yyval.tok.ival = yyvsp[-1].tok.ival; }
break;
case 233:
#line 1560 "../source/cmd_pars.y"
{ INTERP_ABORT; }
break;
case 234:
#line 1565 "../source/cmd_pars.y"
{
		  yyval.tok.ival = yyvsp[0].tok.ival;
		  if (yyvsp[0].tok.ival == 0) {
		    rul__msg_print (CLI_IDXZERO);
		    INTERP_ABORT;
		  }
		}
break;
case 235:
#line 1573 "../source/cmd_pars.y"
{ yyval.tok.ival = -1; }
break;
case 237:
#line 1586 "../source/cmd_pars.y"
{
		  *ptn = pat_tst = RUL_MEM_ALLOCATE (Pat_Tests, 1);
		  pat_tst->ttype = PAT_CONJ;
		  ptn = &(pat_tst->next);
		}
break;
case 238:
#line 1592 "../source/cmd_pars.y"
{ }
break;
case 241:
#line 1602 "../source/cmd_pars.y"
{
		  *ptn = pat_tst = RUL_MEM_ALLOCATE (Pat_Tests, 1);
		  pat_tst->ttype = PAT_DISJ;
		  ptn = &(pat_tst->next);
		  pdtn = &(pat_tst->u.pt);
		}
break;
case 242:
#line 1609 "../source/cmd_pars.y"
{ }
break;
case 243:
#line 1611 "../source/cmd_pars.y"
{
		  *ptn = pat_tst = RUL_MEM_ALLOCATE (Pat_Tests, 1);
		  ptn = &(pat_tst->next);
		  pat_tst->ttype = PAT_SCALAR;
		  pat_tst->pred = yyvsp[-1].tok.ival;
		  pat_tst->u.value = yyvsp[0].mol;
		}
break;
case 244:
#line 1619 "../source/cmd_pars.y"
{
		  *ptn = pat_tst = RUL_MEM_ALLOCATE (Pat_Tests, 1);
		  ptn = &(pat_tst->next);
		  pat_tst->ttype = PAT_SCALAR;
		  pat_tst->pred = TOK_EQUAL_EQUAL;
		  pat_tst->u.value = yyvsp[0].mol;
		}
break;
case 245:
#line 1630 "../source/cmd_pars.y"
{
		  *pdtn = pat_tst = RUL_MEM_ALLOCATE (Pat_Tests, 1);
		  pat_tst->ttype = PAT_SCALAR;
		  pat_tst->pred = TOK_EQUAL_EQUAL;
		  pat_tst->u.value = yyvsp[0].mol;
		  pdtn = &(pat_tst->next);
		}
break;
case 246:
#line 1638 "../source/cmd_pars.y"
{
		  *pdtn = pat_tst = RUL_MEM_ALLOCATE (Pat_Tests, 1);
		  pat_tst->ttype = PAT_SCALAR;
		  pat_tst->pred = TOK_EQUAL_EQUAL;
		  pat_tst->u.value = yyvsp[0].mol;
		  pdtn = &(pat_tst->next);
		}
break;
case 249:
#line 1654 "../source/cmd_pars.y"
{ yyval.tok.ival = TOK_APPROX_EQUAL; }
break;
case 250:
#line 1656 "../source/cmd_pars.y"
{ yyval.tok.ival = TOK_NOT_APPROX_EQUAL; }
break;
case 251:
#line 1658 "../source/cmd_pars.y"
{ yyval.tok.ival = TOK_EQUAL; }
break;
case 252:
#line 1660 "../source/cmd_pars.y"
{ yyval.tok.ival = TOK_EQUAL_EQUAL; }
break;
case 253:
#line 1662 "../source/cmd_pars.y"
{ yyval.tok.ival = TOK_GREATER; }
break;
case 254:
#line 1664 "../source/cmd_pars.y"
{ yyval.tok.ival = TOK_GREATER_EQUAL; }
break;
case 255:
#line 1666 "../source/cmd_pars.y"
{ yyval.tok.ival = TOK_LESS; }
break;
case 256:
#line 1668 "../source/cmd_pars.y"
{ yyval.tok.ival = TOK_LESS_EQUAL; }
break;
case 257:
#line 1670 "../source/cmd_pars.y"
{ yyval.tok.ival = TOK_NOT_EQ; }
break;
case 258:
#line 1672 "../source/cmd_pars.y"
{ yyval.tok.ival = TOK_NOT_EQUAL; }
break;
case 259:
#line 1674 "../source/cmd_pars.y"
{ yyval.tok.ival = TOK_SAME_TYPE; }
break;
case 260:
#line 1676 "../source/cmd_pars.y"
{ yyval.tok.ival = TOK_DIFF_TYPE; }
break;
case 261:
#line 1681 "../source/cmd_pars.y"
{ yyval.tok.ival = TOK_LENGTH_LESS_EQUAL; pred1 = TRUE; }
break;
case 262:
#line 1683 "../source/cmd_pars.y"
{ yyval.tok.ival = TOK_LENGTH_EQUAL; pred1 = TRUE; }
break;
case 263:
#line 1685 "../source/cmd_pars.y"
{ yyval.tok.ival = TOK_LENGTH_NOT_EQUAL; pred1 = TRUE; }
break;
case 264:
#line 1687 "../source/cmd_pars.y"
{ yyval.tok.ival = TOK_LENGTH_LESS; pred1 = TRUE; }
break;
case 265:
#line 1689 "../source/cmd_pars.y"
{ yyval.tok.ival = TOK_LENGTH_GREATER_EQUAL; pred1 = TRUE; }
break;
case 266:
#line 1691 "../source/cmd_pars.y"
{ yyval.tok.ival = TOK_LENGTH_GREATER; pred1 = TRUE; }
break;
case 267:
#line 1693 "../source/cmd_pars.y"
{ yyval.tok.ival = TOK_CONTAINS; pred1 = TRUE; }
break;
case 268:
#line 1695 "../source/cmd_pars.y"
{ yyval.tok.ival = TOK_DOES_NOT_CONTAIN; pred1 = TRUE; }
break;
case 269:
#line 1697 "../source/cmd_pars.y"
{ yyval.tok.ival = TOK_CONTAINS + (yyvsp[0].tok.ival << 16); pred1 = TRUE; }
break;
case 270:
#line 1699 "../source/cmd_pars.y"
{ yyval.tok.ival = TOK_DOES_NOT_CONTAIN + (yyvsp[0].tok.ival << 16); pred1 = TRUE; }
break;
case 271:
#line 1701 "../source/cmd_pars.y"
{ yyval.tok.ival = yyvsp[-1].tok.ival + (TOK_CONTAINS << 16); pred1 = FALSE;
		  pred2 = TRUE; }
break;
case 272:
#line 1704 "../source/cmd_pars.y"
{ yyval.tok.ival = yyvsp[-1].tok.ival + (TOK_DOES_NOT_CONTAIN << 16); pred1 = FALSE;
		  pred2 = TRUE; }
break;
case 280:
#line 1743 "../source/cmd_pars.y"
{
		  yyval.mol = rul__mol_make_symbol(rul__dbg_toupper(yyvsp[0].tok.sval));
		}
break;
case 281:
#line 1747 "../source/cmd_pars.y"
{
		  yyval.mol = rul__mol_make_symbol(yyvsp[0].tok.sval);
		}
break;
case 282:
#line 1754 "../source/cmd_pars.y"
{ 
		   rul_nam = rul__mem_malloc (sizeof (struct rulename));
		   rul_nam->rb_name = NULL;
		   rul_nam->rule_name = yyvsp[0].mol;
		   rul__dbg_add_data_to_list (&pl, DBG__E_PL_RUL,
					      (void*) rul_nam);
		}
break;
case 283:
#line 1762 "../source/cmd_pars.y"
{
		   rul_nam = rul__mem_malloc (sizeof (struct rulename));
		   rul_nam->rb_name = yyvsp[-2].mol;
		   rul_nam->rule_name = yyvsp[0].mol;
		   rul__dbg_add_data_to_list (&pl, DBG__E_PL_RUL,
					      (void*) rul_nam);
		}
break;
case 284:
#line 1773 "../source/cmd_pars.y"
{ yyval.mol = rul__mol_make_symbol (rul__dbg_toupper (yyvsp[0].tok.sval)); }
break;
case 285:
#line 1775 "../source/cmd_pars.y"
{ yyval.mol = rul__mol_make_symbol (yyvsp[0].tok.sval); }
break;
case 450:
#line 1956 "../source/cmd_pars.y"
{
		  yyval.mol = rul__mol_make_int_atom (cur_int);
		}
break;
case 451:
#line 1963 "../source/cmd_pars.y"
{
		  yyval.tok.ival = yyvsp[0].tok.ival;
		  cur_int = yyvsp[0].tok.ival;
		}
break;
case 452:
#line 1971 "../source/cmd_pars.y"
{
		  yyval.mol = rul__mol_make_dbl_atom (cur_flt);
		}
break;
case 453:
#line 1978 "../source/cmd_pars.y"
{
		  yyval.tok.fval = yyvsp[0].tok.fval;
		  cur_flt = yyvsp[0].tok.fval;
		}
break;
case 454:
#line 1986 "../source/cmd_pars.y"
{
		  yyval.mol = rul__mol_make_opaque ((void *) yyvsp[0].tok.ival);
		}
break;
case 455:
#line 1993 "../source/cmd_pars.y"
{
		  val_scalar = FALSE;
		  yyval.mol = yyvsp[-1].mol;
		}
break;
case 456:
#line 2001 "../source/cmd_pars.y"
{
		  comp_elmts = 0;
		  comp_value = rul__mol_make_comp (comp_elmts);
		  yyval.mol = comp_value;
		}
break;
case 457:
#line 2007 "../source/cmd_pars.y"
{
		  comp_value = rul__mol_set_comp_nth (comp_value,
						      ++comp_elmts,
						      yyvsp[0].mol,
						      (Molecule) NULL);
		  yyval.mol = comp_value;
		}
break;
case 458:
#line 2018 "../source/cmd_pars.y"
{
		  yyval.mol = rul__mol_make_symbol (rul__dbg_toupper (yyvsp[0].tok.sval));
		}
break;
case 459:
#line 2022 "../source/cmd_pars.y"
{
		  yyval.mol = rul__mol_make_symbol (yyvsp[0].tok.sval);
		}
break;
case 464:
#line 2033 "../source/cmd_pars.y"
{
		  cur_int = yyvsp[0].tok.ival;
		  if (rul__is_wid_translation_on ()) {
		    yyval.mol = rul__translate_wme_id (rul__mol_make_int_atom (yyvsp[0].tok.ival));
		  }
		  else {
		    yyval.mol = rul__mol_make_instance_atom (yyvsp[0].tok.ival);
		    if (yyval.mol == NULL) {
		      rul__msg_print (CLI_INVWMOID, yyvsp[0].tok.ival);
		      INTERP_ABORT;
		    }
		  }
		}
break;
#line 4746 "y.tab.c"
    }
    yyssp -= yym;
    yystate = *yyssp;
    yyvsp -= yym;
    yym = yylhs[yyn];
    if (yystate == 0 && yym == 0)
    {
#if YYDEBUG
        if (yydebug)
            printf("%sdebug: after reduction, shifting from state 0 to\
 state %d\n", YYPREFIX, YYFINAL);
#endif
        yystate = YYFINAL;
        *++yyssp = YYFINAL;
        *++yyvsp = yyval;
        if (yychar < 0)
        {
            if ((yychar = yylex()) < 0) yychar = 0;
#if YYDEBUG
            if (yydebug)
            {
                yys = 0;
                if (yychar <= YYMAXTOKEN) yys = yyname[yychar];
                if (!yys) yys = "illegal-symbol";
                printf("%sdebug: state %d, reading %d (%s)\n",
                        YYPREFIX, YYFINAL, yychar, yys);
            }
#endif
        }
        if (yychar == 0) goto yyaccept;
        goto yyloop;
    }
    if ((yyn = yygindex[yym]) && (yyn += yystate) >= 0 &&
            yyn <= YYTABLESIZE && yycheck[yyn] == yystate)
        yystate = yytable[yyn];
    else
        yystate = yydgoto[yym];
#if YYDEBUG
    if (yydebug)
        printf("%sdebug: after reduction, shifting from state %d \
to state %d\n", YYPREFIX, *yyssp, yystate);
#endif
    if (yyssp >= yyss + yystacksize - 1)
    {
        goto yyoverflow;
    }
    *++yyssp = yystate;
    *++yyvsp = yyval;
    goto yyloop;
yyoverflow:
    yyerror("yacc stack overflow");
yyabort:
    return (1);
yyaccept:
    return (0);
}
